#include "SPFD5408_Adafruit_GFX.h"    // Core graphics library
#include "SPFD5408_Adafruit_TFTLCD.h" // Hardware-specific library
#include "SPFD5408_TouchScreen.h"


#define YP A1  // must be an analog pin, use "An" notation!
#define XM A2  // must be an analog pin, use "An" notation!
#define YM 7   // can be a digital pin
#define XP 6   // can be a digital pin
#define TS_MINX 125
#define TS_MINY 85
#define TS_MAXX 965
#define TS_MAXY 905

#define LCD_CS A3
#define LCD_CD A2
#define LCD_WR A1
#define LCD_RD A0
#define LCD_RESET A4
#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF

class RuDuinoForms //: public Adafruit_TFTLCD
{
public:	
	
	bool VISIBLE;
	
	bool POSITION_HORISONT;
	uint16_t FORM_COLOR;
	uint16_t FORM_WIDTH; 
	uint16_t FORM_HEIGHT; 
	
public:
	RuDuinoForms()
	{
		VISIBLE = true;
		DrawComponent();
	}	
	
//protected:
	~RuDuinoForms()
	{
		//delete components;
	}
	
public:	
	void DrawComponent()
	{
		//отрисовка окна
	}
};

class RuDuinoButton //: public Adafruit_TFTLCD 
{
public:
	bool VISIBLE;
	
	bool POSITION_HORISONT;
	
	uint16_t BUTTON_COLOR;
	
	uint16_t BUTTON_BORDER;
	uint16_t BUTTON_BORDER_COLOR;
	
	uint16_t BUTTON_WIDTH;
	uint16_t BUTTON_HEIGHT; 
	
	uint16_t BUTTON_LOCATION_X; 
	uint16_t BUTTON_LOCATION_Y; 
	
	char LABEL[10];
	uint8_t TEXTSIZE;
	uint8_t TEXTCOLOR;
	//uint16_t TEXTFONT;
	
public:
	RuDuinoButton(Adafruit_TFTLCD tft, TSPoint p, uint16_t _BUTTON_LOCATION_X, uint16_t _BUTTON_LOCATION_Y, uint16_t _BUTTON_WIDTH, uint16_t _BUTTON_HEIGHT, char* _LABEL,
					uint8_t _TEXTSIZE, uint16_t _TEXTCOLOR)//, uint16_t _TEXTFONT)
	{				//RuDuinoButton button1(tft, p, 50, 50, 150, 50, "TextButton1", 2, RED);//
		//form.VISIBLE = true; //форма из которой нажали невидима
		
		POSITION_HORISONT = true;		
		BUTTON_COLOR = CYAN;
		BUTTON_BORDER = 2;
		BUTTON_BORDER_COLOR = BLUE;
		
		BUTTON_LOCATION_X = _BUTTON_LOCATION_X;
		BUTTON_LOCATION_Y = _BUTTON_LOCATION_Y;
		BUTTON_WIDTH = _BUTTON_WIDTH;
		BUTTON_HEIGHT = _BUTTON_HEIGHT;
		strncpy(LABEL, _LABEL, 9); LABEL[9] = 0;
		TEXTSIZE = _TEXTSIZE;
		TEXTCOLOR = _TEXTCOLOR;
		//TEXTFONT = _TEXTFONT;

		DrawComponent(tft);
	}	
	
//protected:
	~RuDuinoButton()
	{
		//delete components;
	}	
	
public:	

	//События Events//////////////////////////////////////////////	
	void onClickEvent(Adafruit_TFTLCD tft, bool Event)
	{
		TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);
		digitalWrite(13, HIGH);
		TSPoint p = ts.getPoint();  
		digitalWrite(13, LOW); 
		pinMode(XM, OUTPUT);
		pinMode(YP, OUTPUT);
		
		if(p.x > BUTTON_LOCATION_X && p.x < BUTTON_LOCATION_X + BUTTON_WIDTH)
		{
			if(p.y > BUTTON_LOCATION_Y && p.y < BUTTON_LOCATION_Y + BUTTON_HEIGHT)
			{
				bool VISIBLE = false;
				RuDuinoButton button2(tft, p, 50, 150, 150, 50, "TextButton2", 2, YELLOW);
			}			
		}					
	}
	//События Events END//////////////////////////////////////////////	
	
	//отрисовка RuDuinoButton
	void DrawComponent(Adafruit_TFTLCD tft)
	{
		uint16_t REAL_BUTTON_WIDTH = BUTTON_WIDTH;
		uint16_t REAL_BUTTON_HEIGHT = BUTTON_HEIGHT;
		
		if (POSITION_HORISONT == false)
		{
			REAL_BUTTON_WIDTH = BUTTON_HEIGHT;
			REAL_BUTTON_HEIGHT = BUTTON_WIDTH;
		}
		//Adafruit_TFTLCD tft(LCD_CS, LCD_CD, LCD_WR, LCD_RD, LCD_RESET);
		Serial.println("BUTTON_LOCATION_X"); Serial.println(BUTTON_LOCATION_X); 
		Serial.println("BUTTON_LOCATION_Y"); Serial.println(BUTTON_LOCATION_Y); 
		Serial.println("REAL_BUTTON_WIDTH"); Serial.println(REAL_BUTTON_WIDTH); 
		Serial.println("REAL_BUTTON_HEIGHT"); Serial.println(REAL_BUTTON_HEIGHT); 
		Serial.println("BUTTON_COLOR"); Serial.println(BUTTON_COLOR); 
		
		tft.fillRect(BUTTON_LOCATION_X, BUTTON_LOCATION_Y, REAL_BUTTON_WIDTH, REAL_BUTTON_HEIGHT, BUTTON_BORDER_COLOR);		
		tft.fillRect(BUTTON_LOCATION_X + BUTTON_BORDER, BUTTON_LOCATION_Y + BUTTON_BORDER, REAL_BUTTON_WIDTH - 2*BUTTON_BORDER, REAL_BUTTON_HEIGHT - 2*BUTTON_BORDER, BUTTON_COLOR); // рисуем Кнопку
		
		//_DrawComponent->
		Serial.println("TEXTSIZE"); Serial.println(TEXTSIZE); 
		Serial.println("TEXTCOLOR"); Serial.println(TEXTCOLOR); 
		tft.setTextSize(TEXTSIZE); // рисуем Текст
		tft.setTextColor(TEXTCOLOR); // рисуем Текст
		//_DrawComponent->setFont(&TEXTFONT);
		
		/*
		if (5*TEXTSIZE*strlen(LABEL) > BUTTON_WIDTH - 5)
		{
			_DrawComponent->println(LABEL); // рисуем Текст
		}*/					
		uint16_t TEXT_WIDTH = 5*TEXTSIZE*strlen(LABEL);
		if (TEXT_WIDTH > BUTTON_WIDTH) TEXT_WIDTH = BUTTON_WIDTH - 5;
		uint16_t TEXT_HEIGHT = 8*TEXTSIZE;
		if (TEXT_HEIGHT > BUTTON_HEIGHT) TEXT_HEIGHT = BUTTON_HEIGHT - 5;
		Serial.println("strlen(LABEL)"); Serial.println(strlen(LABEL));
		Serial.println("TEXT_WIDTH"); Serial.println(TEXT_WIDTH); 
		Serial.println("TEXT_HEIGHT"); Serial.println(TEXT_HEIGHT); 

		tft.setCursor(BUTTON_LOCATION_X + (BUTTON_WIDTH - TEXT_WIDTH)/2 - 10, BUTTON_LOCATION_Y + (BUTTON_HEIGHT - TEXT_HEIGHT )/2); // рисуем Текст по Центру//
		
		Serial.println("setCursorX"); Serial.println(BUTTON_LOCATION_X + (BUTTON_WIDTH - TEXT_WIDTH)/2 - 10); 
		Serial.println("setCursorY"); Serial.println(BUTTON_LOCATION_Y + (BUTTON_HEIGHT + TEXT_HEIGHT)/2); 
		
		Serial.println("LABEL"); Serial.println(LABEL); 
		tft.println(LABEL); // рисуем Текст
		//tft.drawRect(100, 50, 100, 100, GREEN);
		//DrawTextButton(char* _LABEL);
		
	}
};


///////////////////////////////////////////РЕАЛИЗАЦИЯ КОНКРЕТНЫХ ПОЛЬЗОВАТЕЛЬСКИХ ОБЬЕКТОВ//////////////////////////////////////////////////////////////////////////
class Form : public RuDuinoForms {

//////конструктор элментов окна Start////////////////////////////////////////////////
	///////добавление элментов управления в окно START//////////////////////////////	
	//private: RuDuinoButton button1; //добавляем кнопку		
	///////добавление элментов управления в окно END//////////////////////////////
public:
	Form(Adafruit_TFTLCD tft)
	{
		//Form* link_Form = form;	
		bool VISIBLE = true;
		
		if(VISIBLE == true) //если форма видима - инифиализируем
		{
			InitializeComponent(tft);
		}
	}
	
	void Refresh()
	{
		//Refresh();
		//Refresh();
		//Refresh();
	}
  
//protected:
	~Form()
	{
		//delete components;
	}	
	
public:	
	void InitializeComponent(Adafruit_TFTLCD tft)
	{
		//конструктор для формы				
		this->POSITION_HORISONT = true;
		this->FORM_COLOR = BLACK;
		this->FORM_WIDTH = 240;
		this->FORM_HEIGHT = 320; 
		//рисуеи форму
		DrawComponent(tft);
		//добаялет конструктор button1
		TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);
		digitalWrite(13, HIGH);
		TSPoint p = ts.getPoint();  
		digitalWrite(13, LOW); 
		pinMode(XM, OUTPUT);
		pinMode(YP, OUTPUT);
		//RuDuinoButton button1(this, tft, p, 50, 50, 150, 50, "TextButton1", 2, RED);//, *FreeMonoBoldOblique12pt7b); //0xF800=RED	
	}
	
	void DrawComponent(Adafruit_TFTLCD tft)
	{
		tft.fillScreen(WHITE);
	}
	
	//События Events//////////////////////////////////////////////	
	/*void ClickEvent(bool Event, TSPoint p)
	{
		if(p.x > BUTTON_LOCATION_X && p.x < BUTTON_LOCATION_X + BUTTON_WIDTH)
		{
			if(p.y > button1.BUTTON_LOCATION_Y && p.y < BUTTON_LOCATION_Y + BUTTON_HEIGHT)
			{
				button1.onClickEvent(Event, p);
			}			
		}			
	}*/
//////конструктор элментов окна END////////////////////////////////////////////////
};

