/*Created by releyshic @ 2016, Krasnoyarsk*/
#include "registers.h"
#include "pin_magic.h"
#include <SPI.h>
#include <avr/io.h>

#include "SPFD5408_Adafruit_GFX.h"    // Core graphics library
#include "SPFD5408_Adafruit_TFTLCD.h" // Hardware-specific library
#include "SPFD5408_TouchScreen.h"
//#include <Calendar.cpp>
#include "Icons.cpp"
#include <DS3231.h>
#include <EEPROM.h> // подключаем библиотеку EEPROM


#if defined(__SAM3X8E__)
    #undef __FlashStringHelper::F(string_literal)
    #define F(string_literal) string_literal
#endif

#define LCD_CS A3
#define LCD_CD A2
#define LCD_WR A1
#define LCD_RD A0
// optional
#define LCD_RESET A4

// Assign human-readable names to some common 16-bit color values:
#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF

#define TFT_HIGHT 240
#define TFT_WIDTH 320
#define COLOR_TFT BLACK

#define YP A1  // must be an analog pin, use "An" notation!
#define XM A2  // must be an analog pin, use "An" notation!
#define YM 7   // can be a digital pin
#define XP 6   // can be a digital pin
// Calibrate values
#define TS_MINX 125
#define TS_MINY 85
#define TS_MAXX 965
#define TS_MAXY 905
// For better pressure precision, we need to know the resistance
// between X+ and X- Use any multimeter to read it
// For the one we're using, its 300 ohms across the X plate
TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);

// Типы Представления Время и Даты ////////////////////////////////////////////////////////////////////////
#define Time_H_M_S 0 // Time in format Hour.Min.Sec
#define Time_H_M 1 // Time in format Hour.Min
#define Date_D_Month_Year 2 // Date in format Date.Month.Year
#define Date_D_Month_Year_DOW 3 // Date in format Date.Month.Year.DayOftheWeek
#define Date_D_MonthStr_Year 4 // Date in format Date.getMonthStr.Year
#define Date_D_MonthStr_Year_DOW 5 // Date in format Date.getMonthStr.Year.DayOftheWeek
#define TIMER_H_M_S 6 // TimeR in format Hour.Min.Sec
#define TIMER_H_M 7 // TimeR in format Hour.Min
#define Day_Of_Week 8 // Date in format DayOftheWeek
#define SET_TIMER_LECTURE 9 
#define SET_TIMER_BREAK 10
#define PRINT_WEEK 11 // Первая учебная неделя
#define SET_WEEK 12 // Первая учебная неделя
// ОКНА ////////////////////////////////////////////////////////////////////////
#define DESKTOP 1
#define CALENDAR 2
#define LIST_TIMERS_FIRST_WEEK 3
#define LIST_TIMERS_SECOND_WEEK 4
#define LIST_TIMERS_SET_DAY 5
#define SET_TIMER 6
#define SET_TIME_DATE 7
#define SETTINGS 8
#define EDIT_TIMER 9

#define OK_Window_COPY_TIMERS 1
#define OK_Window_CLEAR_EEPROM 2
#define OK_Window_SLEEP 3

#define PENRADIUS 3
#define BOXSIZE_MENU 40  // Размер Кнопок МЕНЮ
#define COLOR_FIELD_BOXSIZE_MENU BLUE
#define COLOR_BORDER_MENU RED
#define ICONS_COLOR WHITE

// рисования Рабочего стола ////////////////////////////////////////////////////////////////////////
#define BORDER_DESKTOP 2
#define COLOR_BORD_DESKTOP RED
#define Y0_Timer_or_Alarm 95 // Y0 начало полей Будильника/таймера внизу рабочего стола
#define dY_Timer_or_Alarm 35 // высота поля Будильника/таймера внизу рабочего стола
// рисования Календаря ////////////////////////////////////////////////////////////////////////
#define X_DATESIZE 35
#define Y_DATESIZE 32
#define LEFT_FIELD_CALENDAR 5
#define COLOR_FIELD_CALENDAR COLOR_TFT
#define COLOR_BORD_CALENDAR GREEN
#define COLOR_BORD_TODAY_CALENDAR CYAN
#define COLOR_TEXT_CALENDAR 0x001F
#define SIZE_TEXT_CALENDAR 2
#define PANEL_MONTH_CALENDAR 40
// рисования LIST_TIMERS_FIRST_WEEK 3 // LIST_TIMERS_SECOND_WEEK 4 // LIST_TIMERS_SET_DAY 5
#define COLOR_BORD_LIST_TIMERS YELLOW
#define X1_LIST_TIMERS BOXSIZE_MENU + BORDER_DESKTOP + 1
#define Y1_LIST_TIMERS BOXSIZE_MENU + BORDER_DESKTOP 
#define X2_LIST_TIMERS TFT_WIDTH - BORDER_DESKTOP 
#define Y2_LIST_TIMERS TFT_HIGHT - BORDER_DESKTOP  
#define COLOR_TEXT_LIST_TIMERS BLUE
#define SIZE_TEXT_LIST_TIMERS 2  
#define BORDER_TEXT_LIST_TIMERS BORDER_DESKTOP 
#define COLOR_FIELD_LIST_TIMERS WHITE // кроме GREEN RED 
#define COLOR_BORDER_LIST_TIMERS CYAN // кроме GREEN
// рисования SET_TIMER 6 ////////////////////////////////////////////////////////////////////////
#define COLOR_BORD_SET_TIMER YELLOW
#define SIZE_TEXT_LECTURE_SET_TIMER 4
#define X_LECTURE_SET_TIMER BOXSIZE_MENU + 5*BORDER_DESKTOP
#define Y_LECTURE_SET_TIMER BORDER_DESKTOP + 2*BOXSIZE_MENU + 5*BORDER_DESKTOP 
#define SIZE_TEXT_BREAK_SET_TIMER 4
#define X_BREAK_SET_TIMER X_LECTURE_SET_TIMER
#define Y_BREAK_SET_TIMER Y_LECTURE_SET_TIMER + 2*BOXSIZE_MENU
// рисования Настройки Времени и Даты SET_TIME_DATE 7 ////////////////////////////////////////////////////////////////////////
#define COLOR_BORD_SET_TIME_DATE YELLOW
#define COLOR_TEXT_SET_TIME_DATE GREEN
#define SIZE_TEXT_TIME_SET_TIME_DATE 5
#define X_TIME_SET_TIME_DATE BOXSIZE_MENU + 10*BORDER_DESKTOP
#define Y_TIME_SET_TIME_DATE BORDER_DESKTOP + BOXSIZE_MENU + BORDER_DESKTOP 
#define SIZE_TEXT_DATE_SET_TIME_DATE 4
#define X_DATE_SET_TIME_DATE X_TIME_SET_TIME_DATE
#define Y_DATE_SET_TIME_DATE Y_TIME_SET_TIME_DATE + 2*BOXSIZE_MENU 
#define SIZE_TEXT_DOW_SET_TIME_DATE 3
#define X_DOW_SET_TIME_DATE X_TIME_SET_TIME_DATE
#define Y_DOW_SET_TIME_DATE Y_DATE_SET_TIME_DATE + BOXSIZE_MENU + 10*BORDER_DESKTOP 
// рисования SETTINGS 8 ////////////////////////////////////////////////////////////////////////
#define COLOR_BORD_SETTINGS YELLOW
#define SIZE_TEXT_WEEK_SET_WEEK 3
#define X_WEEK_SET_WEEK X_TIME_SET_TIME_DATE
#define Y_WEEK_SET_WEEK 10*BORDER_DESKTOP
#define X_TIME_SET_WEEK X_WEEK_SET_WEEK
#define Y_TIME_SET_WEEK Y_WEEK_SET_WEEK
// рисования OK_Window ////////////////////////////////////////////////////////////////////////
#define FON_COLOR_OK_Window CYAN
#define BORD_COLOR_OK_Window RED
#define BUTTON_COLOR_OK_Window BLUE
#define TEXT_COLOR_OK_Window WHITE
#define SIZE_TEXT_OK_Window 2
#define X_OK_Window 2*BOXSIZE_MENU
#define Y_OK_Window 2*BOXSIZE_MENU
#define DEL_X_OK_Window TFT_WIDTH - X_OK_Window - BOXSIZE_MENU
#define DEL_Y_OK_Window TFT_HIGHT - Y_OK_Window - BOXSIZE_MENU
// Типы Кнопки Button ////////////////////////////////////////////////////////////////////////
#define TEXT_ 0   // Текст
#define RIGHT_ 1  // Стрелка 
#define HIGH_ 2   // Стрелка 
#define LEFT_ 3   // Стрелка 
#define DOWN_ 4   // Стрелка  
// Типы Кнопки Button ////////////////////////////////////////////////////////////////////////

#define TIMERS 40 // Количество Таймеров (элементов Массива)

///ТАБЛО////START/////////////////////////////////
const byte numbers[21] PROGMEM = {
  // биты     |  6 5 4 3 2 1 0  |
  // сегменты |  a b c d e f g  |
  //  Биты        raw
  0b1111110,//0 0x00
  0b0110000,//1 0x01
  0b1101101,//2 0x02
  0b1111001,//3 0x03
  0b0110011,//4 0x04
  0b1011011,//5 0x05
  0b1011111,//6 0x06
  0b1110000,//7 0x07
  0b1111111,//8 0x08
  0b1111011,//9 0x09
  0b1110111,//a 0x0A
  0b0011111,//b 0x0B
  0b1001110,//c 0x0C
  0b0111101,//d 0x0D
  0b1101111,//e 0x0E
  0b1000111,//f 0x0F
  0b1100111,//P 0x10
  0b0001111,//t 0x11
  0b0011100,//u 0x12
  0b0000000,//  0x13 пустой символ (пробел)
  0b0000001 //- 0x14 знак минус
};
///ТАБЛО////END/////////////////////////////////

struct Timer
{  
  uint8_t ID_TIMER = 0;
  //byte MUMBER_IN_LIST = 0;   // Номер в Списке при Выводе на Экран
  
  uint8_t WEEK_OR_EACH_DAY = 1; // 1 for 1st week, 2 for 2nd week, 0 - each day
  //byte FIRST_WEEK = true;   
  bool ACTIVE_TIMER = true;
  //bool ACTIVE_TIMER_BREAK = true;
  //bool ACTIVE_TIMER_IN_EACH_DAY = true;
  //bool ACTIVE_TIMER_BREAK_IN_EACH_DAY = true; 
  uint8_t DOW = 0;
  uint8_t TIME[8];
 /* byte HOUR_START_LECTURE = 0;
  byte MINET_START_LECTURE = 0;
  byte HOUR_END_LECTURE = 0;  
  byte MINET_END_LECTURE = 0;  
  byte HOUR_START_BREAK = 0;
  byte MINET_START_BREAK = 0;
  byte HOUR_DELTA_BREAK = 0;  
  byte MINET_DELTA_BREAK = 0;  */
  //byte DAY_OF_WEEK_TIMER = 0;
  //for EACH DAY TIMER
  uint8_t DAY = 0;
  uint8_t MONTH = 0;
  uint16_t YEAR = 0; //format XX  
  //char LABEL[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  //byte DIR_STRELKA = 0; //0=Text(не стрелка), 1=Right, 2=High, 3=Left, 4=Down  
};

struct MyTime
{
  uint8_t hour;
  uint8_t min;
  uint8_t sec;
  uint8_t date;
  uint8_t mon;
  uint16_t year;
  uint8_t dow;	
};

void WriteOnTablo(const MyTime &T);

MyTime Convert_TimeToMyTime(const Time& TIME);

MyTime Convert_TimeToMyTime(const Time& TIME)
{  
  MyTime T;
  T.hour = TIME.hour;
  T.min = TIME.min;
  T.sec = TIME.sec;
  T.date = TIME.date;
  T.mon = TIME.mon;
  T.year = TIME.year;
  T.dow = TIME.dow;
  return T;
}

bool TimersFirstTime = 0;
uint8_t SelectTimer = 0;
uint8_t IDSelectTimer = 0;
uint8_t LastTimer = 0;
uint8_t ButSetTimerSegment = 0, LastButSetTimerSegment = 0;
uint8_t i_FirstStrokaListTimers = 0; // Таймер Списка с которого начнётся вывод (для листания Списка Таймеров)

uint8_t LatchPin = 32;  // Pin connected to Pin 12 of 74HC595 (Latch)
uint8_t DataPin = 31;  // Pin connected to Pin 14 of 74HC595 (Data)
uint8_t ClockPin = 30;  // Pin connected to Pin 11 of 74HC595 (Clock)

uint8_t Pin_OpenCloseDoor = 33, Value_OpenCloseDoor = 0, IDTimerIsWork = 255, NextIDTimerIsWork = 255;
bool TimerIsWork = 0, OpenDoor = true, InvertValueCloseDoor = 0, BreakIsWork = 0;
bool DayTimerIsExist = 0; // 1= Есть Хоть один таймер на этот День

uint8_t CurrentVisibleWindow = DESKTOP; // рабочий стол Видим
uint8_t OldVisibleWindow = DESKTOP; // рабочий стол Видим
bool FirstTime = 1;
bool TimeDateFirstTime = 0;
uint8_t ButSetTimeDateSegment = 0, LastButSetTimeDateSegment = 0;
uint8_t HOUR = 0, MIN = 0, SEC = 0, DAY = 0, MONTH = 0, WEEK = 1, DOW = 0, LastDOW = 0; short YEAR = 0; // день месяц год ДЛЯ работы в ОКНАХ МЕНЮ
bool NOW_WEEK = 0; // 0 - 1 Week, 1 - 2 Week // to EEPROM
bool OK_WindowIsWork = 0;

uint16_t X_DAY = 2*BORDER_DESKTOP + BOXSIZE_MENU + LEFT_FIELD_CALENDAR - X_DATESIZE;
uint16_t Y_DAY = TFT_HIGHT - BORDER_DESKTOP/2 - 5*Y_DATESIZE - BORDER_DESKTOP;

short TIMER_LOCATION_X = 2*BORDER_DESKTOP + BOXSIZE_MENU; 
short TIMER_LOCATION_Y = BORDER_DESKTOP + PANEL_MONTH_CALENDAR;   
short TIMER_WIDTH = TFT_WIDTH - BORDER_DESKTOP - TIMER_LOCATION_X;
short TIMER_HIGH = 35;  
uint8_t TIMER_TEXTSIZE = 2;
short TIMER_TEXTCOLOR = BLUE;
short TIMER_COLOR = WHITE;  
uint8_t TIMER_BORDER = 2;
short TIMER_BORDER_COLOR = RED;  
short TIMER_BUT_COLOR = YELLOW;

uint8_t HOUR_START_LECTURE = 0;
uint8_t MINET_START_LECTURE = 0;
uint8_t HOUR_END_LECTURE = 0;  
uint8_t MINET_END_LECTURE = 0;  
uint8_t HOUR_START_BREAK = 0;
uint8_t MINET_START_BREAK = 0;
uint8_t HOUR_DELTA_BREAK = 0;  
uint8_t MINET_DELTA_BREAK = 0; 

int oldcolor, currentcolor;
//char Hour1='0', Hour2='0', Minet1='0', Minet2='0', Seconds1='0', Seconds2='0';

Adafruit_TFTLCD tft(LCD_CS, LCD_CD, LCD_WR, LCD_RD, LCD_RESET);
TSPoint p;
DS3231  rtc(SDA, SCL); // Init the DS3231
//DS1307 rtc(SDA, SCL);
Time TIME; // Init a Time-data structure
MyTime TIME_Previous; // Init a Time-data structure
MyTime TIME_Timer; // Обратный отсчёт
MyTime TIME_Timer_Previous;
unsigned long set_time = 0; 
bool OnTimeTablo = 0; // 0 - Otschet na Tablo, 1 - Time
Timer Timers[TIMERS]; //, TimersFromEEPROM[TIMERS]; 
uint8_t IDSortTimers[TIMERS], IDSortTimersDay[TIMERS], IDSortTimersDOW_1[TIMERS], IDSortTimersDOW_2[TIMERS]; 
uint8_t i_LastTimer = 0, LastTimerDay = 0, LastTimerDOW_1 = 0, LastTimerDOW_2 = 0; //[3] = {0, 0, 0}; // WEEK
int adress = 0;

//template <typename TypeEEPROM> // Шаблон функции WriteEEPROM()

void setup(void) 
{   
  //rtc.halt(false); // Set the clock to run-mode
  rtc.begin();
  
  TIME = rtc.getTime(); // текущее время и дата
  DAY = TIME.date, MONTH = TIME.mon, WEEK = 1, DOW = TIME.dow, YEAR = TIME.year; // день месяц год ДЛЯ работы в ОКНАХ МЕНЮ //DayOfWeekF(TIME.date, TIME.mon, TIME.year)
  TIME_Timer.hour = 0; TIME_Timer_Previous.min = 0; TIME_Timer_Previous.sec = 0;

  SPI.begin(); // TABLO//
   //set pins to output 
  pinMode(LatchPin, OUTPUT);
  pinMode(ClockPin, OUTPUT);
  pinMode(DataPin, OUTPUT);
  
  Serial.begin(115200);
  Serial.println(F("Paint!"));
  
  // The following lines can be uncommented to set the date and time
  //rtc.setDOW(4);        // Set Day-of-Week to SUNDAY
  //rtc.setDOW(WEDNESDAY);     // Set Day-of-Week to SUNDAY
  //rtc.setTime(12, 0, 0);     // Set the time to 12:00:00 (24hr format)
  //rtc.setDate(1, 1, 2014);   // Set the date to January 1st, 2014
  
  //!!!к этому мосенту все перенные настроек жолжны быть определены!!!
  //reedEEPROM();  //читаем настройки из ПЗУ и сохраняем в соответствующие переменные
  
  tft.reset();
  tft.begin(0x9341); // SDFP5408  
  tft.setRotation(1); // Need for the Mega, please changed for your choice or rotation initial
  tft.cp437(true);//Русификация 
  
  //Пробуем писать по Русски
  tft.setCursor(111, 111);
  tft.setTextSize(3); tft.setTextColor(BLACK);
  tft.println(utf8rus("Шрифт 1 (самый маленький)")); tft.print("TIME.dow"); tft.println(TIME.dow);

textTime_or_Date(Date_D_Month_Year_DOW, 5, 50, 2, BLUE, '.', 0); 
textTime_or_Date(Date_D_MonthStr_Year, 5, 70, 2, GREEN, '.', 0); 
textTime_or_Date(Date_D_MonthStr_Year_DOW, 5, 90, 2, RED, '.', 0); 
  //Пробуем писать по Русски

  //drawCalendar();
  
  ReadEEPROM();
  delay(500);
  Sortirovka(LastTimer);
  // Wait touch
  waitOneTouch(); 
  
  //tft.setCursor (20, 50); tft.setTextSize (6); tft.setTextColor(BLUE); tft.print(Hour1); tft.print(Hour2); tft.print(":"); tft.print(Minet1); tft.print(Minet2); tft.print(":"); tft.print(Seconds1); tft.print(Seconds2);

  // Пин ОТКРЫТИЯ/ЗАКРЫТИЯ Двери
  pinMode(Pin_OpenCloseDoor, OUTPUT);
}

//////Перекодировки для РУССКОГО/////START//////////////
/* Recode russian fonts from UTF-8 to Windows-1251 */
String utf8rus(String source)
{
  int i,k;
  String target;
  unsigned char n;
  char m[2] = { '0', '\0' };

  k = source.length(); i = 0;

  while (i < k) 
  {
    n = source[i]; i++;

    if (n >= 0xC0) {
      switch (n) {
        case 0xD0: {
          n = source[i]; i++;
          if (n == 0x81) { n = 0xA8; break; }
          if (n >= 0x90 && n <= 0xBF) n = n + 0x30;
          break;
        }
        case 0xD1: {
          n = source[i]; i++;
          if (n == 0x91) { n = 0xB8; break; }
          if (n >= 0x80 && n <= 0x8F) n = n + 0x70;
          break;
        }
      }
    }
    m[0] = n; target = target + String(m);
  }
return target;
}


/* Recode russian fonts from UTF-8 to Windows-1251 */
char utf8rus(char source)
{    
  char target;
  unsigned char n;    
  
  n = source;

  if (n >= 0xC0) 
  {
    switch (n) 
    {
      case 0xD0: 
      {
        n = source; 
        if (n == 0x81) { n = 0xA8; break; }
        if (n >= 0x90 && n <= 0xBF) n = n + 0x30;
        break;
      }
      case 0xD1: 
      {
        n = source; 
        if (n == 0x91) { n = 0xB8; break; }
        if (n >= 0x80 && n <= 0x8F) n = n + 0x70;
        break;
      }
    }
  }
  target = n; 
  return target;
}

char * utf8rus(String source, bool Char)
{
  int i,k;
  String target;
  unsigned char n;
  char m[2] = { '0', '\0' };

  k = source.length(); i = 0;

  while (i < k) 
  {
    n = source[i]; i++;
    if (n >= 0xC0) 
    {
      switch (n) 
      {
        case 0xD0: 
        {
          n = source[i]; i++;
          if (n == 0x81) { n = 0xA8; break; }
          if (n >= 0x90 && n <= 0xBF) n = n + 0x30;
          break;
        }
        case 0xD1: 
        {
          n = source[i]; i++;
          if (n == 0x91) { n = 0xB8; break; }
          if (n >= 0x80 && n <= 0x8F) n = n + 0x70;
          break;
        }
      }
    }
    m[0] = n; target = target + String(m);
  }
  //String str = "hello";
  //const char *str2 = str.c_str();
  //return target;
  //const char* a;
  //char* b;
  //b=(char*)a;
  const char* str1 = target.c_str();
  char* str2 = (char*)str1; 
  return str2; 
}
//#define FORMAT_SHORT  1 //#define FORMAT_LONG   2
String My_getDOWStr(uint8_t format, uint8_t DOW)
{
  //Time t;
  //t = rtc.getTime();
  if (format == 0)
  {
    switch(DOW)
    {
      case 1: return utf8rus("Понедель");
      case 2: return utf8rus("Вторник");
      case 3: return utf8rus("Среда");
      case 4: return utf8rus("Четверг");
      case 5: return utf8rus("Пятница");
      case 6: return utf8rus("Суббота");
      case 7: return utf8rus("Воскрес");
      default: return utf8rus("Ошибка!");
    }
  }else
  {
    switch(DOW)
    {
      case 1: return utf8rus("Понедельник");
      case 2: return utf8rus("Вторник");
      case 3: return utf8rus("Среда");
      case 4: return utf8rus("Четверг");
      case 5: return utf8rus("Пятница");
      case 6: return utf8rus("Суббота");
      case 7: return utf8rus("Воскресенье");
      default: return utf8rus("Ошибка!");
    }
  } 
}

String My_getMonthStr(uint8_t format, uint8_t month)
{  
  //Time t;
  //t = rtc.getTime();
  if (format == 0)
  {
    switch(month)
    {
      case 1: return utf8rus("Янв");
      case 2: return utf8rus("Фев");
      case 3: return utf8rus("Мар");
      case 4: return utf8rus("Апр");
      case 5: return utf8rus("Май");
      case 6: return utf8rus("Июн");
      case 7: return utf8rus("Июл");
      case 8: return utf8rus("Авг");
      case 9: return utf8rus("Сен");
      case 10: return utf8rus("Окт");
      case 11: return utf8rus("Ноя");
      case 12: return utf8rus("Дек"); 
      default: return utf8rus("Ошибка!");
    }
  }else
  {
    switch(month)
    {
      case 1: return utf8rus("Январь");
      case 2: return utf8rus("Февраль");
      case 3: return utf8rus("Март");
      case 4: return utf8rus("Апрель");
      case 5: return utf8rus("Май");
      case 6: return utf8rus("Июнь");
      case 7: return utf8rus("Июль");
      case 8: return utf8rus("Август");
      case 9: return utf8rus("Сентябрь");
      case 10: return utf8rus("Октябрь");
      case 11: return utf8rus("Ноябрь");
      case 12: return utf8rus("Декабрь");
      default: return utf8rus("Ошибка!");
    }
  } 
}
//////Перекодировки для РУССКОГО/////END//////////////

//long previousMillis = 0;        // храним время последнего переключения светодиода 
//long interval = 2000;           // интервал между включение/выключением светодиода (1 секунда)
 
void loop()
{    
  TIME = rtc.getTime(); // текущее время и дата
   
  unsigned long ATimer = millis(); // чтение таймера 
  // запуск цикла каждые 100 мс
  if (!OnTimeTablo) // bool OnTimeTablo = 0; // 0 - Otschet na Tablo, 1 - Time
  {
    if(ATimer - set_time >= 10000 && !(TIME_Timer.hour == 0 && TIME_Timer.min == 0 && TIME_Timer.sec <= 30 && TIME_Timer.sec != 0))
    {
      OnTimeTablo = 1; 
      set_time = ATimer;
    }    
  }else
  {
    if((ATimer - set_time >= 5000 || (TIME_Timer.hour == 0 && TIME_Timer.min == 0 && TIME_Timer.sec <= 30)) && (TIME_Timer.hour + TIME_Timer.min + TIME_Timer.sec != 0))
    {
      OnTimeTablo = 0; 
      set_time = ATimer;
    }    
  }  

  if(FirstTime)
  {
    //рисуем Рабочий стол
    CurrentVisibleWindow = DESKTOP;
    drawDesktop(); 
    //рисуем Боковое Меню
    drawBoxSizeMenu();     
    delay(2000);
    //Проверяем Таймеры На Срабатывание
    VerifyWorkOfTimers(); 
    FirstTime = 0;   
  } 

  /*unsigned long currentMillis = millis();  
  //проверяем не прошел ли нужный интервал, если прошел то
  if(currentMillis - previousMillis > interval) 
  {    
    Serial.print(t.hour, DEC);
    Serial.print(" hour(s), ");
    Serial.print(t.min, DEC);
    Serial.print(" minute(s) and ");
    Serial.print(t.sec, DEC);
    Serial.println("  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -");
    // сохраняем время последнего переключения
    previousMillis = currentMillis;      
  }  */  

  TouchEvents(tft); // вызываем обработку нажитий Тача передаём АктивноеОкно
  
  if(TIME.sec != TIME_Previous.sec)
  {
    //Проверяем Таймеры На Срабатывание
    VerifyWorkOfTimers(); 
    
    if(TIME.date != TIME_Previous.date)
    {      
      DelOldTimers(); // Удаляем Старые Таймеры
      Sortirovka(LastTimer);
    }
  }  
  
  //drawTimeDate(CurrentVisibleWindow); 
  // рисуем время и если надо дату для АктивногоОкна
  switch(CurrentVisibleWindow) 
  {    
    case DESKTOP: 
    {
      /*Serial.print(" CurrentVisibleWindow "); Serial.println(CurrentVisibleWindow, DEC); 
      Serial.print(" case DESKTOP "); Serial.println(DESKTOP, DEC); 
      Serial.println(" LOOP drawTimeDate case DESKTOP");*/
      if(TIME.sec != TIME_Previous.sec)
      {//Date_D_MonthStr_Year_DOW//textTime_or_Date(Date_D_Month_Year_DOW, 
        textTime_or_Date(Date_D_MonthStr_Year_DOW, 2*BORDER_DESKTOP + BOXSIZE_MENU + 2*BORDER_DESKTOP, BORDER_DESKTOP + 2, 2, GREEN, '.', 0); //ButSetTimeDateSegment = 0; Снимаем Выделение Сегмента Времени/даты  
        textTime_or_Date(Time_H_M_S, 2*BORDER_DESKTOP + BOXSIZE_MENU + (TFT_WIDTH - 2*BORDER_DESKTOP - BOXSIZE_MENU - 5*5*9)/2 + 0, BORDER_DESKTOP + 2 + 8*2, 5, BLUE, ':', 0);  
        textTime_or_Date(PRINT_WEEK, 2*BORDER_DESKTOP + BOXSIZE_MENU + 10, BORDER_DESKTOP + 2 + 8*2 + 8*5, 2, CYAN, ':', 0);  
        textTime_or_Date(TIMER_H_M_S, 2*BORDER_DESKTOP + BOXSIZE_MENU + (TFT_WIDTH - 2*BORDER_DESKTOP - BOXSIZE_MENU - 5*5*9)/2 + 0, BORDER_DESKTOP + 2 + 8*2 + 8*5 + 8*2 + BOXSIZE_MENU, 5, RED, ':', 0);    
        if(!OnTimeTablo) // set_time ATimer
        {
          WriteOnTablo(TIME_Timer); //TIME_Timer            
        }else
        {
          WriteOnTablo(Convert_TimeToMyTime(TIME)); //TIME            
        }
                    
        TimeDateFirstTime = 0;        
      }               
      break;
    }    
    case CALENDAR: ; break; //рисуем так
    case LIST_TIMERS_FIRST_WEEK: case LIST_TIMERS_SECOND_WEEK: ; break; //рисуем так
    case LIST_TIMERS_SET_DAY: ; break; //рисуем так
    case SET_TIMER: 
    {
      if(TimersFirstTime)
      {
        tft.setCursor(X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER - BOXSIZE_MENU); tft.setTextSize(SIZE_TEXT_LECTURE_SET_TIMER - 1); tft.setTextColor(GREEN); tft.print(utf8rus("Лекция:"));
        textTime_or_Date(SET_TIMER_LECTURE, X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER, SIZE_TEXT_LECTURE_SET_TIMER, BLUE, ':', ButSetTimerSegment); 
        tft.setCursor(X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER - BOXSIZE_MENU); tft.setTextSize(SIZE_TEXT_BREAK_SET_TIMER - 1); tft.setTextColor(GREEN); tft.print(utf8rus("Перерыв:"));
        textTime_or_Date(SET_TIMER_BREAK, X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER, SIZE_TEXT_BREAK_SET_TIMER, BLUE, ':', ButSetTimerSegment);                      
      }       
      TimersFirstTime = 0;   
      //TimeDateFirstTime = 0;
      break; //рисуем так
    }
    case EDIT_TIMER:
    {
      if(TimersFirstTime)
      {
        tft.setCursor(X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER - BOXSIZE_MENU); tft.setTextSize(SIZE_TEXT_LECTURE_SET_TIMER - 1); tft.setTextColor(GREEN); tft.print(utf8rus("Лекция:"));
        textTime_or_Date(SET_TIMER_LECTURE, X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER, SIZE_TEXT_LECTURE_SET_TIMER, BLUE, ':', ButSetTimerSegment); 
        tft.setCursor(X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER - BOXSIZE_MENU); tft.setTextSize(SIZE_TEXT_BREAK_SET_TIMER - 1); tft.setTextColor(GREEN); tft.print(utf8rus("Перерыв:"));
        textTime_or_Date(SET_TIMER_BREAK, X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER, SIZE_TEXT_BREAK_SET_TIMER, BLUE, ':', ButSetTimerSegment);                      
      }       
      TimersFirstTime = 0;   
      //TimeDateFirstTime = 0;
      break; //рисуем так
    }
    case SET_TIME_DATE: 
    {
      //if(TIME.sec != TIME_Previous.sec)
      //{
        //textTime_or_Date(Time_H_M_S, X_TIME_SET_TIME_DATE, Y_TIME_SET_TIME_DATE, SIZE_TEXT_TIME_SET_TIME_DATE, BLUE, ':', ButSetTimeDateSegment);
        if(TimeDateFirstTime)
        {      
          //tft.setCursor(X_LECTURE_SET_TIMER, Y_TIME_SET_TIME_DATE - BOXSIZE_MENU); tft.setTextSize(SIZE_TEXT_LECTURE_SET_TIMER - 2); tft.setTextColor(GREEN); tft.print(utf8rus("НАСТРОЙКА"));    
          tft.setCursor(X_LECTURE_SET_TIMER, Y_TIME_SET_TIME_DATE - BOXSIZE_MENU + 10); tft.setTextSize(SIZE_TEXT_LECTURE_SET_TIMER - 1); tft.setTextColor(GREEN); tft.print(utf8rus("Время:")); 
          textTime_or_Date(Time_H_M_S, X_TIME_SET_TIME_DATE, Y_TIME_SET_TIME_DATE, SIZE_TEXT_TIME_SET_TIME_DATE, BLUE, ':', ButSetTimeDateSegment); //добавил из сверху
          tft.setCursor(X_BREAK_SET_TIMER, Y_DATE_SET_TIME_DATE - BOXSIZE_MENU + 10); tft.setTextSize(SIZE_TEXT_BREAK_SET_TIMER - 1); tft.setTextColor(GREEN); tft.print(utf8rus("Дата:"));
          textTime_or_Date(Date_D_Month_Year, X_DATE_SET_TIME_DATE, Y_DATE_SET_TIME_DATE, SIZE_TEXT_DATE_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment); 
          tft.setCursor(X_DOW_SET_TIME_DATE, Y_DOW_SET_TIME_DATE - BOXSIZE_MENU + 10); tft.setTextSize(SIZE_TEXT_DOW_SET_TIME_DATE - 1); tft.setTextColor(GREEN); tft.print(utf8rus("День недели:")); 
          textTime_or_Date(Day_Of_Week, X_DOW_SET_TIME_DATE, Y_DOW_SET_TIME_DATE, SIZE_TEXT_DOW_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);  
        }        
        TimeDateFirstTime = 0;
      //}            
      break; 
    }
    case SETTINGS: 
    { 
      if(TimeDateFirstTime)
      {  
        tft.setCursor(X_WEEK_SET_WEEK, Y_WEEK_SET_WEEK); tft.setTextSize(SIZE_TEXT_DOW_SET_TIME_DATE - 1); tft.setTextColor(GREEN); tft.print(utf8rus("Учебная неделя:")); 
        textTime_or_Date(SET_WEEK, X_WEEK_SET_WEEK + 5*(strlen("Учебная неделя:") + 3), Y_WEEK_SET_WEEK, SIZE_TEXT_WEEK_SET_WEEK, BLUE, '.', ButSetTimeDateSegment);   
      }
      break; //рисуем так
    }
  }
  
  // обработка всех действий связанных с таймерами // САМА Работа Устройства!!! БеЗ интерфейса 
  
  TIME_Previous = Convert_TimeToMyTime(TIME); // сохраняем текущее время и дату как старые  
  TIME_Timer_Previous = TIME_Timer; 
}

///////////////////////////////////////Пошли ФУНКЦИИ!!//////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void textTime_or_Date(uint8_t Time_or_Date, uint16_t CursorX, uint16_t CursorY, uint8_t TextSize, uint16_t TextColor, char Spacer, byte ButSetTimeDateSegment) //Time_or_Date==true=Time//==false=Date
{//textTime_or_Date(Time_H_M_S, 20, 40, 6, BLUE, ':'); textTime_or_Date(Date_D_MonthStr_Year_DOW, 20, 15, 2, GREEN, '.')
  //TIME = rtc.getTime(); // текущее время и дата 
  short TEXT_WIDTH = 5*TextSize*8;      
  short TEXT_HIGH = 8*TextSize;    
//Serial.print("TIME.hour"); Serial.print(TIME.hour, DEC); Serial.print(" TIME_Previous.hour "); Serial.println(TIME_Previous.hour, DEC);
 // Serial.print("TIME.min"); Serial.print(TIME.min, DEC); Serial.print(" TIME_Previous.min "); Serial.println(TIME_Previous.min, DEC);  
 // Serial.print("TIME.sec"); Serial.print(TIME.sec, DEC); Serial.print(" TIME_Previous.sec "); Serial.println(TIME_Previous.sec, DEC);
  short CursorHour = CursorX; //начало часов
  short CursorMin = CursorHour + 5*TextSize*3 + 5*TextSize/2; //начало минут
  short CursorSec = CursorMin + 5*TextSize*3 + 5*TextSize/2; //начало секунд
  short CursorTimerStartHour = CursorX; //начало часов
  short CursorTimerStartMin = CursorTimerStartHour + 5*TextSize*3 + 5*TextSize/2; //начало минут
  short CursorTimerEndHour = CursorTimerStartMin + 5*TextSize*3 + 5*TextSize/2; //конец часов
  short CursorTimerEndMin = CursorTimerEndHour + 5*TextSize*3 + 5*TextSize/2; //конец минут
  short EndCursorTimer = CursorTimerEndMin + 5*TextSize*3; //конец Текста
  //short CursorDay = CursorX; //начало дней
  //short CursorMonth = CursorHour + 5*TextSize*3 + 5*TextSize/2; //начало месяца
  //short CursorYear = CursorMin + 5*TextSize*3 + 5*TextSize/2; //начало года
 // Serial.print(" CursorHour "); Serial.print(CursorHour, DEC); Serial.print(" CursorMin "); Serial.print(CursorMin, DEC); Serial.print(" CursorSec "); Serial.println(CursorSec, DEC);      
  //Serial.print(" Time_or_Date "); Serial.print(Time_or_Date, DEC); Serial.print(" Time_H_M_S "); Serial.println(Time_H_M_S, DEC);
  switch(Time_or_Date)
  {      
    case Time_H_M_S: case Time_H_M:
    {
    //Serial.println(" case Time_H_M_S: case Time_H_M: ");        
    //Serial.println(" TIME_Previous.sec!=TIME.sec "); Serial.println(TIME_Previous.sec!=TIME.sec, DEC);    
    //Serial.println(" (TIME_Previous.sec!=TIME.sec) || TimeDateFirstTime "); Serial.println((TIME_Previous.sec!=TIME.sec) || TimeDateFirstTime, DEC);      
      if((TIME_Previous.sec!=TIME.sec) || TimeDateFirstTime || ButSetTimeDateSegment) 
      {            
        //Serial.print(" TIME_Previous.sec!=TIME.sec) || TimeDateFirstTime "); Serial.println((TIME_Previous.sec!=TIME.sec) || TimeDateFirstTime, DEC);
        //Serial.print(" Time_or_Date "); Serial.println(Time_or_Date, DEC);
        if(Time_or_Date == Time_H_M_S || ButSetTimeDateSegment == 3) 
        {
          tft.fillRect(CursorSec - 1, CursorY - 1, 5*TextSize*2 + 7, TEXT_HIGH + 2, COLOR_TFT);
          tft.setCursor(CursorSec, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
          if(ButSetTimeDateSegment == 3) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
          if((byte)TIME.sec/10 == 0){tft.print("0");} tft.print(TIME.sec); 
          //Serial.print(" (byte)TIME.sec/10 == 0 "); Serial.print((byte)TIME.sec/10 == 0, DEC); 
        }        
        if((TIME_Previous.min!=TIME.min) || TimeDateFirstTime || ButSetTimeDateSegment)
        {    
           //Serial.print(" TIME_Previous.min!=TIME.min) || TimeDateFirstTime "); Serial.println((TIME_Previous.min!=TIME.min) || TimeDateFirstTime, DEC);
          tft.fillRect(CursorMin - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
          tft.setCursor(CursorMin, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
          if(ButSetTimeDateSegment == 2) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
          if((byte)TIME.min/10 == 0){tft.print("0");} tft.print(TIME.min); tft.print(Spacer);   

          if((TIME_Previous.hour!=TIME.hour) || TimeDateFirstTime || ButSetTimeDateSegment)
          {  
             //Serial.print(" TIME_Previous.hour!=TIME.hour) || TimeDateFirstTime "); Serial.println((TIME_Previous.hour!=TIME.hour) || TimeDateFirstTime, DEC);
            tft.fillRect(CursorHour - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
            tft.setCursor(CursorHour, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
            if(ButSetTimeDateSegment == 1) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
            if((byte)TIME.hour/10 == 0){tft.print("0");} tft.print(TIME.hour); tft.print(Spacer); 
          }           
        }        
      }      
      break;
    } 
    case Date_D_Month_Year: 
    {
      if(TIME_Previous.date!=TIME.date || TimeDateFirstTime || ButSetTimeDateSegment) 
      {
        tft.fillRect(CursorHour - 1, CursorY - 1, 5*TextSize*2 + 7, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorHour, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor); 
        if(ButSetTimeDateSegment == 4) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
        if((byte)TIME.date/10 == 0){tft.print("0");} tft.print(TIME.date); tft.print(Spacer);
        //tft.print(TIME.mon); tft.print(Spacer); tft.print(TIME.year);
        
        if(TIME_Previous.mon!=TIME.mon || TimeDateFirstTime || ButSetTimeDateSegment) 
        {
          tft.fillRect(CursorMin - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
          tft.setCursor(CursorMin, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
          if(ButSetTimeDateSegment == 5) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
          if((byte)TIME.mon/10 == 0){tft.print("0");} tft.print(TIME.mon); tft.print(Spacer); 

          if((TIME_Previous.year!=TIME.year) || TimeDateFirstTime || ButSetTimeDateSegment)
          {             
            tft.fillRect(CursorSec - 1, CursorY - 1, 5*TextSize*5 + 2, TEXT_HIGH + 2, COLOR_TFT);
            tft.setCursor(CursorSec, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
            if(ButSetTimeDateSegment == 6) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
            tft.print(TIME.year); 
          }   
        }
      } 
      break;
    }
    case Date_D_Month_Year_DOW: if(TIME_Previous.date!=TIME.date || TimeDateFirstTime) {tft.fillRect(CursorX - 1, CursorY - 1, 5*TextSize*21 + 2, TEXT_HIGH + 2, COLOR_TFT); tft.setCursor(CursorX, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor); tft.print(TIME.date); tft.print(Spacer); tft.print(TIME.mon); tft.print(Spacer); tft.print(TIME.year); tft.print(' '); tft.print(My_getDOWStr(1, TIME.dow));} break;
    case Date_D_MonthStr_Year: if(TIME_Previous.date!=TIME.date || TimeDateFirstTime) {tft.setCursor(CursorX, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor); tft.print(TIME.date); tft.setTextSize(TextSize - 1); tft.print(' '); tft.setTextSize(TextSize); tft.print(My_getMonthStr(1, TIME.mon)); tft.setTextSize(TextSize - 1); tft.print(' '); tft.setTextSize(TextSize); tft.print(TIME.year);} break;
    case Date_D_MonthStr_Year_DOW: if(TIME_Previous.date!=TIME.date || TimeDateFirstTime) {tft.setCursor(CursorX, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor); tft.print(TIME.date); tft.setTextSize(TextSize - 1); tft.print(' '); tft.setTextSize(TextSize); tft.print(My_getMonthStr(0, TIME.mon)); tft.setTextSize(TextSize - 1); tft.print(' '); tft.setTextSize(TextSize); tft.print(TIME.year); tft.setTextSize(TextSize - 1); tft.print(' '); tft.setTextSize(TextSize); tft.print(My_getDOWStr(1, TIME.dow));} break;
    //case TimeR_H_M_S: tft.setCursor(CursorX, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor); tft.print(timer.hour); tft.print(Spacer); tft.print(timer.min); tft.print(Spacer); tft.print(timer.sec); break;
    case Day_Of_Week:
    {
      if(TIME_Previous.dow!=TIME.dow || TimeDateFirstTime || ButSetTimeDateSegment)
      {
        tft.fillRect(CursorX - 1, CursorY - 1, 5*TextSize*11 + 2, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorX, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor); 
        if(ButSetTimeDateSegment == 7) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
        tft.print(My_getDOWStr(1, TIME.dow));
      } 
      break;         
    }
    case SET_TIMER_LECTURE: 
    {
      if(TimersFirstTime || ButSetTimerSegment)
      { 
        tft.fillRect(CursorTimerStartHour - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorTimerStartHour, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
        if(ButSetTimerSegment == 1) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
        if((byte)HOUR_START_LECTURE/10 == 0){tft.print("0");} tft.print(HOUR_START_LECTURE); tft.print(Spacer);   
               
        tft.fillRect(CursorTimerStartMin - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorTimerStartMin, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
        if(ButSetTimerSegment == 2) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
        if(MINET_START_LECTURE/10 == 0){tft.print("0");} tft.print(MINET_START_LECTURE); tft.print(" ");   

        tft.fillRect(CursorTimerEndHour - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorTimerEndHour, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
        if(ButSetTimerSegment == 3) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
        if(HOUR_END_LECTURE/10 == 0){tft.print("0");} tft.print(HOUR_END_LECTURE); tft.print(Spacer);   
               
        tft.fillRect(CursorTimerEndMin - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorTimerEndMin, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
        if(ButSetTimerSegment == 4) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
        if(MINET_END_LECTURE/10 == 0){tft.print("0");} tft.print(MINET_END_LECTURE);           
      }
      break;        
    }
    case SET_TIMER_BREAK:
    {      
      if(TimersFirstTime || ButSetTimerSegment)
      { 
        tft.fillRect(CursorTimerStartHour - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorTimerStartHour, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
        if(ButSetTimerSegment == 5) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
        if((byte)HOUR_START_BREAK/10 == 0){tft.print("0");} tft.print(HOUR_START_BREAK); tft.print(Spacer);   
               
        tft.fillRect(CursorTimerStartMin - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorTimerStartMin, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
        if(ButSetTimerSegment == 6) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
        if(MINET_START_BREAK/10 == 0){tft.print("0");} tft.print(MINET_START_BREAK); tft.print(" ");   
  
        tft.fillRect(CursorTimerEndHour - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorTimerEndHour, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
        if(ButSetTimerSegment == 7) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
        if(HOUR_DELTA_BREAK/10 == 0){tft.print("0");} tft.print(HOUR_DELTA_BREAK); tft.print(".");   
               
        tft.fillRect(CursorTimerEndMin - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorTimerEndMin, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
        if(ButSetTimerSegment == 8) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
        if(MINET_DELTA_BREAK/10 == 0){tft.print("0");} tft.print(MINET_DELTA_BREAK);   
      }
      break;
    }    
    case PRINT_WEEK:
    {
      if(TIME_Previous.dow != TIME.dow && TIME.dow == 1 || TimeDateFirstTime)
      {
        NOW_WEEK = (TIME_Previous.dow != TIME.dow && TIME.dow == 1) ? !NOW_WEEK : NOW_WEEK; 
        tft.fillRect(CursorX - 1, CursorY - 1, 5*TextSize*2 + 7, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorX, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);      
        if(!NOW_WEEK) tft.print(utf8rus("Первая учебная неделя")); else tft.print(utf8rus("Вторая учебная неделя"));      
      }      
      break;
    }

    case SET_WEEK:
    {
      if(TimeDateFirstTime || ButSetTimeDateSegment)
      {
        tft.fillRect(CursorX - 1, CursorY - 1, 5*TextSize*11 + 2, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorX, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor); 
        if(ButSetTimeDateSegment == 9) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
        if(WEEK == 1) tft.print(utf8rus("ПЕРВАЯ")); else tft.print(utf8rus("ВТОРАЯ"));   
      } 
      break;         
    }
    
    case TIMER_H_M_S:    
    {
    //Serial.println(" case Time_H_M_S: case Time_H_M: ");        
    //Serial.println(" TIME_Previous.sec!=TIME.sec "); Serial.println(TIME_Previous.sec!=TIME.sec, DEC);    
    //Serial.println(" (TIME_Previous.sec!=TIME.sec) || TimeDateFirstTime "); Serial.println((TIME_Previous.sec!=TIME.sec) || TimeDateFirstTime, DEC);      
      if((TIME_Previous.sec!=TIME.sec) || TimeDateFirstTime || ButSetTimeDateSegment) 
      {            
        //Serial.print(" TIME_Previous.sec!=TIME.sec) || TimeDateFirstTime "); Serial.println((TIME_Previous.sec!=TIME.sec) || TimeDateFirstTime, DEC);
        //Serial.print(" Time_or_Date "); Serial.println(Time_or_Date, DEC);
        tft.fillRect(CursorSec - 1, CursorY - 1, 5*TextSize*2 + 7, TEXT_HIGH + 2, COLOR_TFT);
        tft.setCursor(CursorSec, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor); 
        if((byte)TIME_Timer.sec/10 == 0){tft.print("0");} tft.print(TIME_Timer.sec); 
        //Serial.print(" (byte)TIME.sec/10 == 0 "); Serial.print((byte)TIME.sec/10 == 0, DEC); 
        if((TIME_Timer_Previous.min!=TIME_Timer.min) || TimeDateFirstTime || ButSetTimeDateSegment)
        {    
          //Serial.print(" TIME_Previous.min!=TIME.min) || TimeDateFirstTime "); Serial.println((TIME_Previous.min!=TIME.min) || TimeDateFirstTime, DEC);
          tft.fillRect(CursorMin - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
          tft.setCursor(CursorMin, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
          if(ButSetTimeDateSegment == 2) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
          if((byte)TIME_Timer.min/10 == 0){tft.print("0");} tft.print(TIME_Timer.min); tft.print(Spacer);   
          if((TIME_Timer_Previous.hour!=TIME_Timer.hour) || TimeDateFirstTime || ButSetTimeDateSegment)
          {  
             //Serial.print(" TIME_Previous.hour!=TIME.hour) || TimeDateFirstTime "); Serial.println((TIME_Previous.hour!=TIME.hour) || TimeDateFirstTime, DEC);
            tft.fillRect(CursorHour - 1, CursorY - 1, 5*TextSize*3 + 2, TEXT_HIGH + 2, COLOR_TFT);
            tft.setCursor(CursorHour, CursorY); tft.setTextSize(TextSize); tft.setTextColor(TextColor);
            if(ButSetTimeDateSegment == 1) tft.setTextColor(COLOR_TEXT_SET_TIME_DATE); // Индикация Для РЕД в Настр Времени и Даты
            if((byte)TIME_Timer.hour/10 == 0){tft.print("0");} tft.print(TIME_Timer.hour); tft.print(Spacer); 
          }           
        }        
      }      
      break;
    }// END //case PRINT_TABLO   
    default: break;     
  } 
  //FirstTime = (FirstTime) ? 0 : 0; // закончился первый раз
   //Serial.print(" textTime_or_Date() FirstTime ");Serial.println(FirstTime, DEC);   
}

//*******************************************************************************************************************************************
// обработка событий ОКОН // START ////////////////////////////////////////////////////////////////////////////////  
bool onMoveEventRun = false;
//p.x0_MoveEvent = p.x, p.y0_MoveEvent = p.y;//вынести для сохранения значений//для класса class TouchEventsTSPoint : public TSPoint
int16_t x0_MoveEvent = 0;
int16_t y0_MoveEvent = 0;//вынести для сохранения значений
int16_t MoveUpEvent = 0, MoveDownEvent = 0, MoveRightEvent = 0, MoveLeftEvent = 0, MoveEvent = 0, ClickEvent = 0, TouchEvent = 0;
long previousMillis = 0;

void onClickEvent(Adafruit_TFTLCD tft, TSPoint p)
{
  /*Serial.println("onClickEvent"); Serial.println(ClickEvent++); //пишем в монитор координату  
  Serial.println("BOXSIZE_MENU"); Serial.println(BOXSIZE_MENU); //пишем в монитор координату  
  Serial.println("p.x"); Serial.println(p.x); //пишем в монитор координату
  Serial.println("p.y"); Serial.println(p.y); //пишем в монитор координату
  Serial.println("BOXSIZE_MENU"); Serial.println(BOXSIZE_MENU); //пишем в монитор координатуэ
  */
  //  Обработка нажатия ОКОН
  if(OK_WindowIsWork)
  {    
    if(p.y >= Y_OK_Window + DEL_Y_OK_Window - BOXSIZE_MENU && p.y <= Y_OK_Window + DEL_Y_OK_Window && p.x >= X_OK_Window && p.x <= X_OK_Window + DEL_X_OK_Window)
    {
      if(p.x < X_OK_Window + DEL_X_OK_Window/2) 
      {        
        //Выбор Источника События        
        switch(OK_WindowIsWork)
        {
          case OK_Window_COPY_TIMERS: 
          {
            if(WEEK == 1) //WEEK 1 - for 1st week, 2 - for 2nd week, 3 - All weeks, 0 - each day
            {
              for(byte i = 0; i < LastTimer; i++)
              {
                if(Timers[i].WEEK_OR_EACH_DAY == ((WEEK == 1) ? 2 : 0) || Timers[i].WEEK_OR_EACH_DAY == ((WEEK == 2) ? 1 : 0) && Timers[i].WEEK_OR_EACH_DAY) // WEEK_OR_EACH_DAY 1 - 1st week, 2 - 2nd week, 0 - each day
                {
                  AddDeleteTimer(3, i); // AddDelTimer = 3 = COPY //                     
                }
              }
            }
            DrawWindow(CurrentVisibleWindow);
            break;
          }
          case OK_Window_CLEAR_EEPROM: 
          {
            ClearEEPROM();
            // Очистка Таймеров ОЗУ
            for(byte i = 0; i < LastTimer; i++)
            {
              Timers[i].ID_TIMER = 0;
              Timers[i].WEEK_OR_EACH_DAY = 1; // 1 for 1st week, 2 for 2nd week, 0 - each day
              //Timers[i].FIRST_WEEK = true; 
              Timers[i].ACTIVE_TIMER = true; 
              Timers[i].DOW = 0;              
              Timers[i].TIME[0] = 0; Timers[i].TIME[1] = 0; Timers[i].TIME[2] = 0;  Timers[i].TIME[3] = 0;  Timers[i].TIME[4] = 0;  Timers[i].TIME[5] = 0;  Timers[i].TIME[6] = 0; Timers[i].TIME[7] = 0;                     
              Timers[i].DAY = 0;
              Timers[i].MONTH = 0;
              Timers[i].YEAR = 0; //format XX    
            }
            LastTimer = 0; 
            NOW_WEEK = 0;
            Sortirovka(LastTimer);
            /*for (int i = 0 ; i < EEPROM.length() ; i++) 
            {
              EEPROM.write(i, 0);
              Serial.print("EEPROM i  "); Serial.println(EEPROM.read(i));
              if(i/256 != 0 && i%256 == 0) {Serial.println("");Serial.println("*************256bit**************");}
            }*/
            Serial.println(F("EEPROM is Clear!"));
            DrawWindow(CurrentVisibleWindow);
            break;
          }         
          case OK_Window_SLEEP: 
          {
            DrawWindow(CurrentVisibleWindow);        
            Sleep(); //Serial.println("Sleep");                    
            break;
          }
        }
        DrawWindow(OldVisibleWindow);
      }else
      {
        DrawWindow(CurrentVisibleWindow);              
      }
    }
    OK_WindowIsWork = 0;    
  }
  if(CurrentVisibleWindow == LIST_TIMERS_FIRST_WEEK || CurrentVisibleWindow == LIST_TIMERS_SECOND_WEEK || CurrentVisibleWindow == LIST_TIMERS_SET_DAY)
  //case LIST_TIMERS_FIRST_WEEK: case LIST_TIMERS_SECOND_WEEK: case LIST_TIMERS_SET_DAY: //#define LIST_TIMERS_FIRST_WEEK 3 #define LIST_TIMERS_SECOND_WEEK 4 #define LIST_TIMERS_SET_DAY 5 // Обработка нажатия Списков Таймеров
  {
    if(p.x >= BOXSIZE_MENU + BORDER_DESKTOP && p.x <= TFT_WIDTH - BORDER_DESKTOP && p.y > PANEL_MONTH_CALENDAR + BORDER_DESKTOP)
    {
      // Обработка нажатий на Таймер/ы
      byte dY = 2*8*SIZE_TEXT_LIST_TIMERS + 3*BORDER_TEXT_LIST_TIMERS; // Полная Высота Строки Таймера
      byte n = (Y2_LIST_TIMERS - Y1_LIST_TIMERS)/dY; // число Строк Таймеров (реальное)
      
      short TouchStroka = (short)(p.y - Y1_LIST_TIMERS)/dY; // Нажатая строка
       Serial.print(F("TouchStroka ")); Serial.println(TouchStroka); 
      for(byte i = 0, k = 0, m = 0; i < LastTimer; i++) 
      {
        if(Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && WEEK == 0 && Timers[IDSortTimers[i]].DAY == DAY || Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && Timers[IDSortTimers[i]].DOW == DOW && WEEK != 0)
        {Serial.println(F("if(Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEE")); 
          // Условие вывода Списка Таймеров начиная с номера i_FirstStrokaListTimers
          if(k >= i_FirstStrokaListTimers && k < n + i_FirstStrokaListTimers)
          {   Serial.println(F("if(k >= i_FirstStrokaListTimers && k < n + i_FirstStrokaListTimers)")); 
            if(TouchStroka == m) // Нажатая Кнопка
            {Serial.print(F("m ")); Serial.println(m); 
              // Если Нажат Сам Таймер
              if(p.x > X1_LIST_TIMERS + 5 && p.x < X2_LIST_TIMERS - PANEL_MONTH_CALENDAR - 5)
              {
                Serial.println(utf8rus("Нажат Сам Таймер")); 
                IDSelectTimer = IDSortTimers[i];
                
                WEEK = Timers[IDSelectTimer].WEEK_OR_EACH_DAY; // 1 - for 1st week, 2 - for 2nd week, 3 - All weeks, 0 - each day
                //Timers[IDSelectTimer].FIRST_WEEK = WEEK; // true - 1 неделя, false - 2 неделя                
                DOW = Timers[IDSelectTimer].DOW; // = 0 если для Конкретного Дня  
                HOUR_START_LECTURE = Timers[IDSelectTimer].TIME[0];
                MINET_START_LECTURE = Timers[IDSelectTimer].TIME[1];
                HOUR_END_LECTURE = Timers[IDSelectTimer].TIME[2];
                MINET_END_LECTURE = Timers[IDSelectTimer].TIME[3];
                HOUR_START_BREAK = Timers[IDSelectTimer].TIME[4];
                MINET_START_BREAK = Timers[IDSelectTimer].TIME[5];
                HOUR_DELTA_BREAK = Timers[IDSelectTimer].TIME[6];
                MINET_DELTA_BREAK = Timers[IDSelectTimer].TIME[7];    
                DAY = Timers[IDSelectTimer].DAY; // =0 если для Недели
                MONTH = Timers[IDSelectTimer].MONTH; // =0 если для Недели
                YEAR = Timers[IDSelectTimer].YEAR; // =0 если для Недели
                
                OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = EDIT_TIMER; 
                drawSetTimer();
              } 
              // Если Нажата Кнопка Таймера       
              if(p.x > X2_LIST_TIMERS - PANEL_MONTH_CALENDAR && p.x < X2_LIST_TIMERS)
              {
                Serial.println(utf8rus("Нажата Кнопка Таймера")); 
                Timers[IDSortTimers[i]].ACTIVE_TIMER = (Timers[IDSortTimers[i]].ACTIVE_TIMER) ? 0 : 1; // Меняем Активность
                Sortirovka(LastTimer);
                WriteTimerEEPROM((byte)IDSortTimers[i]);
                drawTimers(1); // Обновляем Кнопки Таймеров
              }         
              break;
            }
            m += 1; // Номер строки Списка Таймеров
          }
          k += 1; // считаем кол-во выведенных таймеров 
        }
      }
    }
    //drawListTimers(SET_TIMER);
    //break;
  }
  
  switch(CurrentVisibleWindow) //  Обработка нажатия ОКОН
  {
    case DESKTOP: //#define DESKTOP 1 // Обработка нажатия Рабочего стола
    {      
      //drawListTimers(LIST_TIMERS_FIRST_WEEK);      
      break;
    }
    case CALENDAR: //#define CALENDAR 2 // Обработка нажатия Дней на КАЛЕНДАРЕ
    {   
     // uint16_t X_Day = X_DAY - X_DATESIZE;
     int Y_Day = Y_DAY; int X_Day = X_DAY + X_DATESIZE;
    // Serial.print("X_Day IF "); Serial.println(X_Day); Serial.print("Y_Day IF "); Serial.println(Y_Day); 
      if((DayOfWeekF(1, MONTH, YEAR) >= 6 && DaysInMonthF(MONTH, YEAR) == 31) || (DayOfWeekF(1, MONTH, YEAR) == 7 && DaysInMonthF(MONTH, YEAR) == 30))
      {
         Y_Day = Y_Day - Y_DATESIZE;
      }
      
      byte EndStrokaOfMonth = (DaysInMonthF(MONTH, YEAR) + DayOfWeekF(1, MONTH, YEAR) - 1 - 1)/7 + 1, stroka = (p.y - Y_Day)/Y_DATESIZE + 1;
      byte EndStolbecOfMonth = (DaysInMonthF(MONTH, YEAR) + DayOfWeekF(1, MONTH, YEAR) - 1 - 1)%7 + 1, stolbec = (p.x - X_Day)/X_DATESIZE + 1;
      //Serial.print("X_Day "); Serial.println(X_Day); Serial.print("Y_Day "); Serial.println(Y_Day);
     // Serial.print("EndStrokaOfMonth "); Serial.println(EndStrokaOfMonth); Serial.print("stroka "); Serial.println(stroka);
      //Serial.print("EndStolbecOfMonth "); Serial.println(EndStolbecOfMonth); Serial.print("stolbec "); Serial.println(stolbec);
      bool Default = 0;
      if((stolbec < DayOfWeekF(1, MONTH, YEAR) && stroka == 1) || (stolbec > EndStolbecOfMonth && stroka >= EndStrokaOfMonth)) {Default = 1;}
      //Serial.print("!Default && (p.x > X_Day) && (p.y > Y_Day)  "); Serial.println(!Default && (p.x > X_Day) && (p.y > Y_Day));
      //Serial.print("!Default  "); Serial.println(!Default);
      //Serial.print("(p.x > X_Day)"); Serial.println(p.x > X_Day);
     // Serial.print("p.y > Y_Day "); Serial.println(p.y > Y_Day);
      if(!Default && (p.x > X_Day) && (p.y > Y_Day))
      {
        DAY = stroka*7 - (7 - stolbec) - DayOfWeekF(1, MONTH, YEAR) + 1;     
        OldVisibleWindow = CurrentVisibleWindow; //Serial.println("drawSetTimeDate();"); 
        CurrentVisibleWindow = LIST_TIMERS_SET_DAY; //#define LIST_TIMERS_SET_DAY 5 
        WEEK = 0; // на конкретный день 
        i_FirstStrokaListTimers = 0; // первая строка списка таймеров
        drawListTimers(LIST_TIMERS_SET_DAY); // Рисуем ОКНО Списка Таймеров //drawListTimers(byte TypeList, uint8_t Day, uint8_t Month, uint16_t Year); 
        drawTimers(0); // рисуем Таймеры         
        //Serial.print("  DAY "); Serial.print(DAY); 
        //Serial.print("CurrentVisibleWindow"); Serial.println(CurrentVisibleWindow); Serial.println("drawCalendar()");        
      } 
      break; 
    } //#define CALENDAR 2 // Обработка нажатия Дней на КАЛЕНДАРЕ\

    
    case SET_TIMER: //#define SET_TIMER 6 // Обработка нажатия Кнопок на настройке Таймера
    { 
      //Считываем нажатие сегментов LECTURE 
      if(p.y >= Y_LECTURE_SET_TIMER && p.y <= Y_LECTURE_SET_TIMER + 8*SIZE_TEXT_LECTURE_SET_TIMER && p.x >= X_LECTURE_SET_TIMER) 
      {
        if(p.x < X_LECTURE_SET_TIMER + 5*SIZE_TEXT_LECTURE_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 1; // HOUR_START_LECTURE
        }
        if(p.x > X_LECTURE_SET_TIMER + 5*SIZE_TEXT_LECTURE_SET_TIMER*3 && p.x < X_LECTURE_SET_TIMER + 2*5*SIZE_TEXT_LECTURE_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 2; // MINET_START_LECTURE
        }
        if(p.x > X_LECTURE_SET_TIMER + 2*5*SIZE_TEXT_LECTURE_SET_TIMER*3 && p.x < X_LECTURE_SET_TIMER + 3*5*SIZE_TEXT_LECTURE_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 3; // HOUR_END_LECTURE
        }
        if(p.x > X_LECTURE_SET_TIMER + 3*5*SIZE_TEXT_LECTURE_SET_TIMER*3 && p.x < X_LECTURE_SET_TIMER + 4*5*SIZE_TEXT_LECTURE_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 4; // MINET_END_LECTURE
        }
        textTime_or_Date(SET_TIMER_LECTURE, X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER, SIZE_TEXT_LECTURE_SET_TIMER, BLUE, ':', ButSetTimerSegment);     
        textTime_or_Date(SET_TIMER_BREAK, X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER, SIZE_TEXT_BREAK_SET_TIMER, BLUE, ':', ButSetTimerSegment);   
      }   
      
      //Считываем нажатие сегментов BREAK
      if(p.y >= Y_BREAK_SET_TIMER && p.y <= Y_BREAK_SET_TIMER + 8*SIZE_TEXT_BREAK_SET_TIMER && p.x >= X_BREAK_SET_TIMER) 
      {
        if(p.x < X_BREAK_SET_TIMER + 5*SIZE_TEXT_BREAK_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 5; // HOUR_START_BREAK
        }
        if(p.x > X_BREAK_SET_TIMER + 5*SIZE_TEXT_BREAK_SET_TIMER*3 && p.x < X_BREAK_SET_TIMER + 2*5*SIZE_TEXT_BREAK_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 6; // MINET_START_BREAK
        }
        if(p.x > X_BREAK_SET_TIMER + 2*5*SIZE_TEXT_BREAK_SET_TIMER*3 && p.x < X_BREAK_SET_TIMER + 3*5*SIZE_TEXT_BREAK_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 7; // HOUR_DELTA_BREAK
        }
        if(p.x > X_BREAK_SET_TIMER + 3*5*SIZE_TEXT_BREAK_SET_TIMER*3 && p.x < X_BREAK_SET_TIMER + 4*5*SIZE_TEXT_BREAK_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 8; // MINET_DELTA_BREAK
        }
        textTime_or_Date(SET_TIMER_LECTURE, X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER, SIZE_TEXT_LECTURE_SET_TIMER, BLUE, ':', ButSetTimerSegment);     
        textTime_or_Date(SET_TIMER_BREAK, X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER, SIZE_TEXT_BREAK_SET_TIMER, BLUE, ':', ButSetTimerSegment);           
      }      
      break;
    }
    case EDIT_TIMER: //#define EDIT_TIMER 9 // Обработка нажатия Кнопок на настройке Таймера
    { 
      //Считываем нажатие сегментов LECTURE 
      if(p.y >= Y_LECTURE_SET_TIMER && p.y <= Y_LECTURE_SET_TIMER + 8*SIZE_TEXT_LECTURE_SET_TIMER && p.x >= X_LECTURE_SET_TIMER) 
      {
        if(p.x < X_LECTURE_SET_TIMER + 5*SIZE_TEXT_LECTURE_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 1; // HOUR_START_LECTURE
        }
        if(p.x > X_LECTURE_SET_TIMER + 5*SIZE_TEXT_LECTURE_SET_TIMER*3 && p.x < X_LECTURE_SET_TIMER + 2*5*SIZE_TEXT_LECTURE_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 2; // MINET_START_LECTURE
        }
        if(p.x > X_LECTURE_SET_TIMER + 2*5*SIZE_TEXT_LECTURE_SET_TIMER*3 && p.x < X_LECTURE_SET_TIMER + 3*5*SIZE_TEXT_LECTURE_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 3; // HOUR_END_LECTURE
        }
        if(p.x > X_LECTURE_SET_TIMER + 3*5*SIZE_TEXT_LECTURE_SET_TIMER*3 && p.x < X_LECTURE_SET_TIMER + 4*5*SIZE_TEXT_LECTURE_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 4; // MINET_END_LECTURE
        }
        textTime_or_Date(SET_TIMER_LECTURE, X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER, SIZE_TEXT_LECTURE_SET_TIMER, BLUE, ':', ButSetTimerSegment);     
        textTime_or_Date(SET_TIMER_BREAK, X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER, SIZE_TEXT_BREAK_SET_TIMER, BLUE, ':', ButSetTimerSegment);   
      }   
      
      //Считываем нажатие сегментов BREAK
      if(p.y >= Y_BREAK_SET_TIMER && p.y <= Y_BREAK_SET_TIMER + 8*SIZE_TEXT_BREAK_SET_TIMER && p.x >= X_BREAK_SET_TIMER) 
      {
        if(p.x < X_BREAK_SET_TIMER + 5*SIZE_TEXT_BREAK_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 5; // HOUR_START_BREAK
        }
        if(p.x > X_BREAK_SET_TIMER + 5*SIZE_TEXT_BREAK_SET_TIMER*3 && p.x < X_BREAK_SET_TIMER + 2*5*SIZE_TEXT_BREAK_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 6; // MINET_START_BREAK
        }
        if(p.x > X_BREAK_SET_TIMER + 2*5*SIZE_TEXT_BREAK_SET_TIMER*3 && p.x < X_BREAK_SET_TIMER + 3*5*SIZE_TEXT_BREAK_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 7; // HOUR_DELTA_BREAK
        }
        if(p.x > X_BREAK_SET_TIMER + 3*5*SIZE_TEXT_BREAK_SET_TIMER*3 && p.x < X_BREAK_SET_TIMER + 4*5*SIZE_TEXT_BREAK_SET_TIMER*3)
        {
          LastButSetTimerSegment = ButSetTimerSegment; ButSetTimerSegment = 8; // MINET_DELTA_BREAK
        }
        textTime_or_Date(SET_TIMER_LECTURE, X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER, SIZE_TEXT_LECTURE_SET_TIMER, BLUE, ':', ButSetTimerSegment);     
        textTime_or_Date(SET_TIMER_BREAK, X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER, SIZE_TEXT_BREAK_SET_TIMER, BLUE, ':', ButSetTimerSegment);           
      }      
      break;
    }
    case SET_TIME_DATE: //#define SET_TIME_DATE 7 // Обработка нажатия Кнопок на Настройке часов
    {
      //Считываем нажатие сегментов Времени 
      if(p.y >= Y_TIME_SET_TIME_DATE && p.y <= Y_TIME_SET_TIME_DATE + 8*SIZE_TEXT_TIME_SET_TIME_DATE && p.x >= X_TIME_SET_TIME_DATE) 
      {
        if(p.x < X_TIME_SET_TIME_DATE + 5*SIZE_TEXT_TIME_SET_TIME_DATE*3)
        {
          LastButSetTimeDateSegment = ButSetTimeDateSegment; ButSetTimeDateSegment = 1; // HOUR
        }
        if(p.x > X_TIME_SET_TIME_DATE + 5*SIZE_TEXT_TIME_SET_TIME_DATE*3 && p.x < X_TIME_SET_TIME_DATE + 2*5*SIZE_TEXT_TIME_SET_TIME_DATE*3)
        {
          LastButSetTimeDateSegment = ButSetTimeDateSegment; ButSetTimeDateSegment = 2; // MIN
        }
        if(p.x > X_TIME_SET_TIME_DATE + 2*5*SIZE_TEXT_TIME_SET_TIME_DATE*3 && p.x < X_TIME_SET_TIME_DATE + 3*5*SIZE_TEXT_TIME_SET_TIME_DATE*3)
        {
          LastButSetTimeDateSegment = ButSetTimeDateSegment; ButSetTimeDateSegment = 3; // SEC
        }
        textTime_or_Date(Time_H_M_S, X_TIME_SET_TIME_DATE, Y_TIME_SET_TIME_DATE, SIZE_TEXT_TIME_SET_TIME_DATE, BLUE, ':', ButSetTimeDateSegment);       
        textTime_or_Date(Date_D_Month_Year, X_DATE_SET_TIME_DATE, Y_DATE_SET_TIME_DATE, SIZE_TEXT_DATE_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);  
        textTime_or_Date(Day_Of_Week, X_DOW_SET_TIME_DATE, Y_DOW_SET_TIME_DATE, SIZE_TEXT_DOW_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);              
      }
      
      //Считываем нажатие сегментов Даты 
      if(p.y >= Y_DATE_SET_TIME_DATE && p.y <= Y_DATE_SET_TIME_DATE + 8*SIZE_TEXT_DATE_SET_TIME_DATE && p.x >= X_DATE_SET_TIME_DATE)  
      {
        if(p.x < X_DATE_SET_TIME_DATE + 5*SIZE_TEXT_DATE_SET_TIME_DATE*3)
        {
          LastButSetTimeDateSegment = ButSetTimeDateSegment; ButSetTimeDateSegment = 4; // DAY
        }
        if(p.x > X_DATE_SET_TIME_DATE + 5*SIZE_TEXT_DATE_SET_TIME_DATE*3 && p.x < X_DATE_SET_TIME_DATE + 2*5*SIZE_TEXT_DATE_SET_TIME_DATE*3)
        {
          LastButSetTimeDateSegment = ButSetTimeDateSegment; ButSetTimeDateSegment = 5; // MONTH
        }
        if(p.x > X_DATE_SET_TIME_DATE + 2*5*SIZE_TEXT_DATE_SET_TIME_DATE*3 && p.x < X_DATE_SET_TIME_DATE + 2*5*SIZE_TEXT_DATE_SET_TIME_DATE*3 + 5*SIZE_TEXT_DATE_SET_TIME_DATE*4)
        {
          LastButSetTimeDateSegment = ButSetTimeDateSegment; ButSetTimeDateSegment = 6; // YEAR
        }
        textTime_or_Date(Time_H_M_S, X_TIME_SET_TIME_DATE, Y_TIME_SET_TIME_DATE, SIZE_TEXT_TIME_SET_TIME_DATE, BLUE, ':', ButSetTimeDateSegment);
        textTime_or_Date(Date_D_Month_Year, X_DATE_SET_TIME_DATE, Y_DATE_SET_TIME_DATE, SIZE_TEXT_DATE_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);  
        textTime_or_Date(Day_Of_Week, X_DOW_SET_TIME_DATE, Y_DOW_SET_TIME_DATE, SIZE_TEXT_DOW_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);             
      }

      //String str = My_getDOWStr(0, DOW); const char *str2 = str.c_str();
        // strlen(str2))
      //Считываем нажатие сегментов Дня Недели
      if(p.y >= Y_DOW_SET_TIME_DATE && p.y <= Y_DOW_SET_TIME_DATE + 8*SIZE_TEXT_DOW_SET_TIME_DATE)  
      {
        String str = My_getDOWStr(1, TIME.dow); const char *str2 = str.c_str();
        if(p.x >= X_DOW_SET_TIME_DATE && p.x <= X_DOW_SET_TIME_DATE + 5*SIZE_TEXT_DOW_SET_TIME_DATE*strlen(str2))
        {
          LastButSetTimeDateSegment = ButSetTimeDateSegment; 
          ButSetTimeDateSegment = 7; // DOW
        }
        textTime_or_Date(Time_H_M_S, X_TIME_SET_TIME_DATE, Y_TIME_SET_TIME_DATE, SIZE_TEXT_TIME_SET_TIME_DATE, BLUE, ':', ButSetTimeDateSegment);
        textTime_or_Date(Date_D_Month_Year, X_DATE_SET_TIME_DATE, Y_DATE_SET_TIME_DATE, SIZE_TEXT_DATE_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);  
        textTime_or_Date(Day_Of_Week, X_DOW_SET_TIME_DATE, Y_DOW_SET_TIME_DATE, SIZE_TEXT_DOW_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);  
      }      
      break;
    }
    case SETTINGS: //#define SETTINGS 8
    {      
      //SET_WEEK
      //Считываем нажатие сегментов WEEK 
      if(p.y >= Y_WEEK_SET_WEEK && p.y <= Y_WEEK_SET_WEEK + 8*SIZE_TEXT_WEEK_SET_WEEK && p.x >= X_WEEK_SET_WEEK) 
      {
        //textTime_or_Date(SET_WEEK, X_WEEK_SET_WEEK + 5*(strlen("Учебная неделя:") + 3), Y_WEEK_SET_WEEK, SIZE_TEXT_WEEK_SET_WEEK, BLUE, '.', ButSetTimeDateSegment);  
        if(p.x < X_WEEK_SET_WEEK + 5*SIZE_TEXT_WEEK_SET_WEEK*(strlen("Учебная неделя:") + 3) + 5*SIZE_TEXT_WEEK_SET_WEEK*7)
        {
          LastButSetTimeDateSegment = ButSetTimeDateSegment; ButSetTimeDateSegment = 9; // WEEK
        }
        /*if(p.x > X_SET_WEEK + 5*SIZE_TEXT_TIME_SET_TIME_DATE*3 && p.x < X_SET_WEEK + 2*5*SIZE_TEXT_TIME_SET_TIME_DATE*3)
        {
          LastButSetTimeDateSegment = ButSetTimeDateSegment; ButSetTimeDateSegment = 2; // MIN
        }*/
        /*if(p.x > X_SET_WEEK + 2*5*SIZE_TEXT_TIME_SET_TIME_DATE*3 && p.x < X_SET_WEEK + 3*5*SIZE_TEXT_TIME_SET_TIME_DATE*3)
        {
          LastButSetTimeDateSegment = ButSetTimeDateSegment; ButSetTimeDateSegment = 3; // SEC
        }*/
        textTime_or_Date(SET_WEEK, X_TIME_SET_WEEK, Y_TIME_SET_WEEK, SIZE_TEXT_WEEK_SET_WEEK, BLUE, ' ', ButSetTimeDateSegment);       
        //textTime_or_Date(Date_D_Month_Year, X_DATE_SET_TIME_DATE, Y_DATE_SET_TIME_DATE, SIZE_TEXT_DATE_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);  
        //textTime_or_Date(Day_Of_Week, X_DOW_SET_TIME_DATE, Y_DOW_SET_TIME_DATE, SIZE_TEXT_DOW_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);              
      }
      break;
    }    
  }//END Switch Обработка нажатия ОКОН

///////Меню слева во всех окнах!!! /// START ////////    
  if(p.x <= BOXSIZE_MENU + BORDER_DESKTOP)
  {    
    // общие Для ВСЕХ ОКОН Кнопки
    switch((short)(p.y + BORDER_DESKTOP)/BOXSIZE_MENU)
    {      
      case 0: //DESKTOP 1
      {
        OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = DESKTOP;
        DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year; 
        drawDesktop(); //Serial.println("drawDesktop()"); 
        break;
      }
      /*case 1: //CALENDAR 2
      {
        OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = CALENDAR; 
        DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
        drawCalendar(); //Serial.print("CurrentVisibleWindow"); Serial.println(CurrentVisibleWindow); Serial.println("drawCalendar()"); 
        break; 
      }*/
      /*case 2: //LIST_TIMERS_FIRST_WEEK 3
      {  
        OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = LIST_TIMERS_FIRST_WEEK;
        DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
        WEEK = 1; // Первая неделя 
        i_FirstStrokaListTimers = 0; // Выделить Первый Таймер
        drawListTimers(LIST_TIMERS_FIRST_WEEK); // рисуем Окно Списка Таймеров //Serial.println("drawListTimersFirstWeek();");    
        drawTimers(0); // рисуем Таймеры
        
        break;
      }*/
    }// общие Для ВСЕХ ОКОН Кнопки
    
    switch(CurrentVisibleWindow)
    {      
      case DESKTOP: 
      { 
        switch((short)(p.y + BORDER_DESKTOP)/BOXSIZE_MENU)
        {
          case 1: //CALENDAR 2
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = CALENDAR; 
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            drawCalendar(); //Serial.print("CurrentVisibleWindow"); Serial.println(CurrentVisibleWindow); Serial.println("drawCalendar()"); 
            break; 
          }
          case 2: //LIST_TIMERS_FIRST_WEEK 3
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = LIST_TIMERS_FIRST_WEEK;
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            WEEK = NOW_WEEK + 1; // Первая неделя 
            i_FirstStrokaListTimers = 0; // Выделить Первый Таймер
            drawListTimers(LIST_TIMERS_FIRST_WEEK); // рисуем Окно Списка Таймеров //Serial.println("drawListTimersFirstWeek();");    
            drawTimers(0); // рисуем Таймеры
            
            break;
          }
          case 3: //Настройка Время 4 //#define SET_TIME_DATE 7
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = SET_TIME_DATE;
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year; 
            drawSetTimeDate(); //Serial.println("drawSetTimeDate()"); 
            break;
          }
          case 4: //НАСТРОЙКА 5 //#define SETTINGS 8
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = SETTINGS; 
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            drawSettings(); //Serial.println("drawSettings)"); 
            break; 
          }
          case 5: //OpenCloseDoor 6
          {           
            OpenCloseDoor(); //Serial.println("OpenClose");         
            break;
          }
        }                
        break;
      }//case DESKTOP: case CALENDAR:

      case CALENDAR:
      { 
        switch((short)(p.y + BORDER_DESKTOP)/BOXSIZE_MENU)
        {
          case 1: //COPY from Other WEEK
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = CALENDAR; 
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            drawCalendar(); //Serial.print("CurrentVisibleWindow"); Serial.println(CurrentVisibleWindow); Serial.println("drawCalendar()"); 
            break; 
          }
          case 2: //LIST_TIMERS_FIRST_WEEK 3
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = LIST_TIMERS_FIRST_WEEK;
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            WEEK = NOW_WEEK + 1; // Первая неделя 
            i_FirstStrokaListTimers = 0; // Выделить Первый Таймер
            drawListTimers(LIST_TIMERS_FIRST_WEEK); // рисуем Окно Списка Таймеров //Serial.println("drawListTimersFirstWeek();");    
            drawTimers(0); // рисуем Таймеры
            
            break;
          }
          case 3: //Настройка Время 4 //#define SET_TIME_DATE 7
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = SET_TIME_DATE;
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year; 
            drawSetTimeDate(); //Serial.println("drawSetTimeDate()"); 
            break;
          }
          case 4: //НАСТРОЙКА 5 //#define SETTINGS 8
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = SETTINGS; 
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            drawSettings(); //Serial.println("drawSettings)"); 
            break; 
          }
          case 5: //OpenCloseDoor 6
          {           
            OpenCloseDoor(); //Serial.println("OpenClose");         
            break;
          }
        }                
        break;
      }// case CALENDAR:
            
      case LIST_TIMERS_FIRST_WEEK: case LIST_TIMERS_SECOND_WEEK: case LIST_TIMERS_SET_DAY: 
      {        
        switch((short)(p.y + BORDER_DESKTOP)/BOXSIZE_MENU)
        {
          case 1: //CALENDAR 2
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = CALENDAR; 
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            drawCalendar(); //Serial.print("CurrentVisibleWindow"); Serial.println(CurrentVisibleWindow); Serial.println("drawCalendar()"); 
            break; 
          }
          case 2: //COPY from Other WEEK
          {            
            OK_WindowIsWork = OK_Window_COPY_TIMERS;
            drawOK_Window(); // рисуем Окно  
            break;
          }
          case 3: //Добавить Таймер //AddDeleteTimer(bool AddDelTimer, byte ID_TIMER) // AddDelTimer = true = Add // если Добавляем то аргумент ID_TIMER = 0
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = SET_TIMER; //void drawSetTimer() // #define SET_TIMER 6    
            //Задаём ПЕРЕРЫВ внутри Границ Времени ЛЕКЦИЙ
            HOUR_START_BREAK = HOUR_START_LECTURE; MINET_START_BREAK = MINET_START_LECTURE; HOUR_DELTA_BREAK = HOUR_END_LECTURE; MINET_DELTA_BREAK = MINET_END_LECTURE;       
            drawSetTimer(); //Serial.println("drawSetTimer()"); 
            break;
          }
          case 4: //Button_UP для Списка Таймеров
          {            
            i_FirstStrokaListTimers = (i_FirstStrokaListTimers == 0) ? 0 : i_FirstStrokaListTimers -= 1; // Листать Список Таймеров Вверх             
            drawTimers(0); // рисуем Таймеры     
            break; 
          }
          case 5: //Button_DOWN для Списка Таймеров
          {            
            i_FirstStrokaListTimers += 1; // Листать Список Таймеров Вниз               
            drawTimers(0); // рисуем Таймеры    
            break;
          }
        }                
        break;
      }//case LIST_TIMERS_FIRST_WEEK: case LIST_TIMERS_SECOND_WEEK: case LIST_TIMERS_SET_DAY: 
              
      case SET_TIMER: //#define SET_TIMER 6
      {
        switch((short)(p.y + BORDER_DESKTOP)/BOXSIZE_MENU)
        {
          case 1: //CALENDAR 2
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = CALENDAR; 
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            drawCalendar(); //Serial.print("CurrentVisibleWindow"); Serial.println(CurrentVisibleWindow); Serial.println("drawCalendar()"); 
            break; 
          }
          case 2: //LIST_TIMERS_FIRST_WEEK 3
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = LIST_TIMERS_FIRST_WEEK;
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            WEEK = NOW_WEEK + 1; // Первая неделя 
            i_FirstStrokaListTimers = 0; // Выделить Первый Таймер
            drawListTimers(LIST_TIMERS_FIRST_WEEK); // рисуем Окно Списка Таймеров //Serial.println("drawListTimersFirstWeek();");    
            drawTimers(0); // рисуем Таймеры            
            break;
          }
          case 3: // Сохранить Таймер //AddDeleteTimer(bool AddDelTimer, byte ID_TIMER) // AddDelTimer = true = Add // если Добавляем то аргумент ID_TIMER = 0
          {
            // Сохраняем таймер
            AddDeleteTimer(1, 0); // AddDelTimer = 1 = Add // если Добавляем то аргумент ID_TIMER = 0         
            CurrentVisibleWindow = OldVisibleWindow; OldVisibleWindow = SET_TIMER;  //void drawSetTimer() // #define SET_TIMER 6            
            drawListTimers(CurrentVisibleWindow); //функция рисования Списка Таймеров 
            i_FirstStrokaListTimers = 0; // Выделить Первый Таймер
            drawTimers(0); // рисуем Таймеры        
            break;
          }
          case 4: //Button_UP для Настройки Таймера
          {
            switch(ButSetTimerSegment)
            {
              case 1: //HOUR_START_LECTURE +
              {
                HOUR_START_LECTURE += 1; if(HOUR_START_LECTURE >= 24) {HOUR_START_LECTURE = 0;}  
                
                //Ограничение
                if(HOUR_START_BREAK <= HOUR_START_LECTURE) 
                {
                  HOUR_START_BREAK = HOUR_START_LECTURE;
                  if(MINET_START_BREAK <= MINET_START_LECTURE) MINET_START_BREAK = MINET_START_LECTURE;
                } 
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK) 
                {
                  HOUR_END_LECTURE = HOUR_START_BREAK + HOUR_DELTA_BREAK;
                  if(MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;
                }//Ограничение 
                break;
              }
              case 2: //MINET_START_LECTURE +
              {
                MINET_START_LECTURE += 1; if(MINET_START_LECTURE >= 60) {MINET_START_LECTURE = 0;} 
                
                //Ограничение
                if(HOUR_START_BREAK <= HOUR_START_LECTURE && MINET_START_BREAK <= MINET_START_LECTURE) 
                {
                  MINET_START_BREAK = MINET_START_LECTURE;                  
                } 
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK && MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) 
                {
                  MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;                  
                }//Ограничение 
                break;
              }
              case 3: {HOUR_END_LECTURE += 1; if(HOUR_END_LECTURE >= 24) {HOUR_END_LECTURE = 0;} break;}
              case 4: {MINET_END_LECTURE += 1; if(MINET_END_LECTURE >= 60) {MINET_END_LECTURE = 0;} break;}         
              case 5: //HOUR_START_BREAK +
              {
                HOUR_START_BREAK += 1; if(HOUR_START_BREAK >= HOUR_END_LECTURE) {HOUR_START_BREAK = HOUR_END_LECTURE;} 
                
                //Ограничение                
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK) 
                {
                  HOUR_END_LECTURE = HOUR_START_BREAK + HOUR_DELTA_BREAK;
                  if(MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;
                }//Ограничение 
                break;
              }
              case 6: //MINET_START_BREAK +
              {
                MINET_START_BREAK += 1; if(MINET_START_BREAK >= 60) {MINET_START_BREAK = 0;}                 
                
                //Ограничение    
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK && MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) 
                {
                  MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;                  
                }//Ограничение 
                break;
              }
              case 7: //HOUR_DELTA_BREAK +
              {
                HOUR_DELTA_BREAK += 1; if(HOUR_DELTA_BREAK >= 7) {HOUR_DELTA_BREAK = 0;} //if(HOUR_DELTA_BREAK + HOUR_START_BREAK >= HOUR_END_LECTURE) {HOUR_DELTA_BREAK = HOUR_END_LECTURE - HOUR_START_BREAK;} 
                
                //Ограничение                
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK) 
                {
                  HOUR_END_LECTURE = HOUR_START_BREAK + HOUR_DELTA_BREAK;
                  if(MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;
                }//Ограничение 
                break;
              }
              case 8: //MINET_DELTA_BREAK +
              {
                MINET_DELTA_BREAK += 1; if(MINET_DELTA_BREAK >= 60) {MINET_DELTA_BREAK = 0;} //if(HOUR_DELTA_BREAK == HOUR_END_LECTURE - HOUR_START_BREAK && MINET_DELTA_BREAK + MINET_START_BREAK >= MINET_END_LECTURE) {MINET_DELTA_BREAK = MINET_END_LECTURE - MINET_START_BREAK;} 
                
                //Ограничение    
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK && MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) 
                {
                  MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;                  
                }//Ограничение 
                break;
              }              
            }//Serial.println("//Button_UP TIME");           
            textTime_or_Date(SET_TIMER_LECTURE, X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER, SIZE_TEXT_LECTURE_SET_TIMER, BLUE, ':', ButSetTimerSegment);             
            textTime_or_Date(SET_TIMER_BREAK, X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER, SIZE_TEXT_BREAK_SET_TIMER, BLUE, ':', ButSetTimerSegment);  
            break; 
          }
          case 5: //Button_DOWN для Настройки Таймера
          {
            switch(ButSetTimerSegment)
            {
              case 1: //HOUR_START_LECTURE -
              {
                if(HOUR_START_LECTURE <= 0) 
                {
                  HOUR_START_LECTURE = 23;

                  //Ограничение
                  if(HOUR_START_BREAK <= HOUR_START_LECTURE) 
                  {
                    HOUR_START_BREAK = HOUR_START_LECTURE;
                    if(MINET_START_BREAK <= MINET_START_LECTURE) MINET_START_BREAK = MINET_START_LECTURE;
                  } 
                  if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK) 
                  {
                    HOUR_END_LECTURE = HOUR_START_BREAK + HOUR_DELTA_BREAK;
                    if(MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;
                  }//Ограничение 
                } else {HOUR_START_LECTURE -= 1;}                 
                break;
              }
              case 2: //MINET_START_LECTURE -
              {
                if(MINET_START_LECTURE <= 0) 
                {
                  MINET_START_LECTURE = 59;

                  //Ограничение
                  if(HOUR_START_BREAK <= HOUR_START_LECTURE && MINET_START_BREAK <= MINET_START_LECTURE) 
                  {
                    MINET_START_BREAK = MINET_START_LECTURE;                  
                  } 
                  if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK && MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) 
                  {
                    MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;                  
                  }//Ограничение 
                } else {MINET_START_LECTURE -= 1;}
                break;
              }
              case 3: //HOUR_END_LECTURE -
              {
                if(HOUR_END_LECTURE <= 0) 
                {
                  HOUR_END_LECTURE = 23;
                } else 
                {
                  HOUR_END_LECTURE -= 1;
                  
                  //Ограничение
                  if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK) 
                  {
                    HOUR_END_LECTURE = HOUR_START_BREAK + HOUR_DELTA_BREAK;
                    if(MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;
                  }//Ограничение 
                } 
              break;
              }
              case 4: //MINET_END_LECTURE -
              {
                if(MINET_END_LECTURE <= 0) 
                {
                  MINET_END_LECTURE = 59;
                } else 
                {
                  MINET_END_LECTURE -= 1;
                  
                  //Ограничение    
                  if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK && MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) 
                  {
                    MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;                  
                  }//Ограничение 
                } 
                break;
              }
              case 5: //HOUR_START_BREAK -
              {
                if(HOUR_START_BREAK <= HOUR_START_LECTURE) 
                {
                  HOUR_START_BREAK = HOUR_START_LECTURE;
                } else 
                {
                  HOUR_START_BREAK -= 1;

                  //Ограничение
                  if(HOUR_START_BREAK <= HOUR_START_LECTURE) 
                  {
                    HOUR_START_BREAK = HOUR_START_LECTURE;
                    if(MINET_START_BREAK <= MINET_START_LECTURE) MINET_START_BREAK = MINET_START_LECTURE;
                  }//Ограничение                   
                } 
                break;
              }
              case 6: //MINET_START_BREAK -
              {
                if(MINET_START_BREAK <= 0) 
                {
                  MINET_START_BREAK = 59;
                } else 
                {
                  MINET_START_BREAK -= 1;
                  
                  //Ограничение
                  if(HOUR_START_BREAK <= HOUR_START_LECTURE && MINET_START_BREAK <= MINET_START_LECTURE) 
                  {
                    MINET_START_BREAK = MINET_START_LECTURE;                  
                  }//Ограничение
                }
                break;
              }
              case 7: //HOUR_DELTA_BREAK -
              {
                if(HOUR_DELTA_BREAK != 0) {HOUR_DELTA_BREAK -= 1;} else HOUR_DELTA_BREAK = 0;
                break;
              }
              case 8: //MINET_DELTA_BREAK -
              {
                if(MINET_DELTA_BREAK != 0) {MINET_DELTA_BREAK -= 1;} else MINET_DELTA_BREAK = 0;
                break;
              }         
            }//Serial.println("//Button_DOWN TIME");     
            textTime_or_Date(SET_TIMER_LECTURE, X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER, SIZE_TEXT_LECTURE_SET_TIMER, BLUE, ':', ButSetTimerSegment);             
            textTime_or_Date(SET_TIMER_BREAK, X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER, SIZE_TEXT_BREAK_SET_TIMER, BLUE, ':', ButSetTimerSegment);  
            break;
          }
        }                
        break; //рисуем так
      }
      case EDIT_TIMER: //#define EDIT_TIMER 9
      {
        switch((short)(p.y + BORDER_DESKTOP)/BOXSIZE_MENU)
        {
          case 1: //CALENDAR 2
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = CALENDAR; 
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            drawCalendar(); //Serial.print("CurrentVisibleWindow"); Serial.println(CurrentVisibleWindow); Serial.println("drawCalendar()"); 
            break; 
          }
          case 2: // Удалить Таймер //AddDeleteTimer(bool AddDelTimer, byte ID_TIMER) 
          {
            // Удаляем таймер
            AddDeleteTimer(0, IDSelectTimer); // AddDelTimer = 1 = Add // если Добавляем то аргумент ID_TIMER = 0         
            Serial.print(F("del IDSelectTimer ")); Serial.println(IDSelectTimer);
            CurrentVisibleWindow = OldVisibleWindow; OldVisibleWindow = EDIT_TIMER;  //void drawSetTimer() // #define EDIT_TIMER 9           
            drawListTimers(CurrentVisibleWindow); //функция рисования Списка Таймеров 
            i_FirstStrokaListTimers = 0; // Выделить Первый Таймер
            drawTimers(0); // рисуем Таймеры        
            break;            
          }
          case 3: //AddDeleteTimer(bool AddDelTimer, byte ID_TIMER) // AddDelTimer = true = Add // если Добавляем то аргумент ID_TIMER = 0
          {
            // Сохраняем таймер
            AddDeleteTimer(2, IDSelectTimer); // AddDelTimer = 1 = Add // если Добавляем то аргумент ID_TIMER = 0         
            CurrentVisibleWindow = OldVisibleWindow; OldVisibleWindow = SET_TIMER;  //void drawSetTimer() // #define SET_TIMER 6            
            drawListTimers(CurrentVisibleWindow); //функция рисования Списка Таймеров 
            i_FirstStrokaListTimers = 0; // Выделить Первый Таймер
            drawTimers(0); // рисуем Таймеры        
            break;
          }
          case 4: //Button_UP для Настройки Таймера
          {
            switch(ButSetTimerSegment)
            {
              case 1: //HOUR_START_LECTURE +
              {
                HOUR_START_LECTURE += 1; if(HOUR_START_LECTURE >= 24) {HOUR_START_LECTURE = 0;}  
                
                //Ограничение
                if(HOUR_START_BREAK <= HOUR_START_LECTURE) 
                {
                  HOUR_START_BREAK = HOUR_START_LECTURE;
                  if(MINET_START_BREAK <= MINET_START_LECTURE) MINET_START_BREAK = MINET_START_LECTURE;
                } 
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK) 
                {
                  HOUR_END_LECTURE = HOUR_START_BREAK + HOUR_DELTA_BREAK;
                  if(MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;
                }//Ограничение 
                break;
              }
              case 2: //MINET_START_LECTURE +
              {
                MINET_START_LECTURE += 1; if(MINET_START_LECTURE >= 60) {MINET_START_LECTURE = 0;} 
                
                //Ограничение
                if(HOUR_START_BREAK <= HOUR_START_LECTURE && MINET_START_BREAK <= MINET_START_LECTURE) 
                {
                  MINET_START_BREAK = MINET_START_LECTURE;                  
                } 
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK && MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) 
                {
                  MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;                  
                }//Ограничение 
                break;
              }
              case 3: {HOUR_END_LECTURE += 1; if(HOUR_END_LECTURE >= 24) {HOUR_END_LECTURE = 0;} break;}
              case 4: {MINET_END_LECTURE += 1; if(MINET_END_LECTURE >= 60) {MINET_END_LECTURE = 0;} break;}         
              case 5: //HOUR_START_BREAK +
              {
                HOUR_START_BREAK += 1; if(HOUR_START_BREAK >= HOUR_END_LECTURE) {HOUR_START_BREAK = HOUR_END_LECTURE;} 
                
                //Ограничение                
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK) 
                {
                  HOUR_END_LECTURE = HOUR_START_BREAK + HOUR_DELTA_BREAK;
                  if(MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;
                }//Ограничение 
                break;
              }
              case 6: //MINET_START_BREAK +
              {
                MINET_START_BREAK += 1; if(MINET_START_BREAK >= 60) {MINET_START_BREAK = 0;}                 
                
                //Ограничение    
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK && MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) 
                {
                  MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;                  
                }//Ограничение 
                break;
              }
              case 7: //HOUR_DELTA_BREAK +
              {
                HOUR_DELTA_BREAK += 1; if(HOUR_DELTA_BREAK >= 7) {HOUR_DELTA_BREAK = 0;} //if(HOUR_DELTA_BREAK + HOUR_START_BREAK >= HOUR_END_LECTURE) {HOUR_DELTA_BREAK = HOUR_END_LECTURE - HOUR_START_BREAK;} 
                
                //Ограничение                
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK) 
                {
                  HOUR_END_LECTURE = HOUR_START_BREAK + HOUR_DELTA_BREAK;
                  if(MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;
                }//Ограничение 
                break;
              }
              case 8: //MINET_DELTA_BREAK +
              {
                MINET_DELTA_BREAK += 1; if(MINET_DELTA_BREAK >= 60) {MINET_DELTA_BREAK = 0;} //if(HOUR_DELTA_BREAK == HOUR_END_LECTURE - HOUR_START_BREAK && MINET_DELTA_BREAK + MINET_START_BREAK >= MINET_END_LECTURE) {MINET_DELTA_BREAK = MINET_END_LECTURE - MINET_START_BREAK;} 
                
                //Ограничение    
                if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK && MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) 
                {
                  MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;                  
                }//Ограничение 
                break;
              }              
            }//Serial.println("//Button_UP TIME");           
            textTime_or_Date(SET_TIMER_LECTURE, X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER, SIZE_TEXT_LECTURE_SET_TIMER, BLUE, ':', ButSetTimerSegment);             
            textTime_or_Date(SET_TIMER_BREAK, X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER, SIZE_TEXT_BREAK_SET_TIMER, BLUE, ':', ButSetTimerSegment);  
            break; 
          }
          case 5: //Button_DOWN для Настройки Таймера
          {
            switch(ButSetTimerSegment)
            {
              case 1: //HOUR_START_LECTURE -
              {
                if(HOUR_START_LECTURE <= 0) 
                {
                  HOUR_START_LECTURE = 23;

                  //Ограничение
                  if(HOUR_START_BREAK <= HOUR_START_LECTURE) 
                  {
                    HOUR_START_BREAK = HOUR_START_LECTURE;
                    if(MINET_START_BREAK <= MINET_START_LECTURE) MINET_START_BREAK = MINET_START_LECTURE;
                  } 
                  if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK) 
                  {
                    HOUR_END_LECTURE = HOUR_START_BREAK + HOUR_DELTA_BREAK;
                    if(MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;
                  }//Ограничение 
                } else {HOUR_START_LECTURE -= 1;}                 
                break;
              }
              case 2: //MINET_START_LECTURE -
              {
                if(MINET_START_LECTURE <= 0) 
                {
                  MINET_START_LECTURE = 59;

                  //Ограничение
                  if(HOUR_START_BREAK <= HOUR_START_LECTURE && MINET_START_BREAK <= MINET_START_LECTURE) 
                  {
                    MINET_START_BREAK = MINET_START_LECTURE;                  
                  } 
                  if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK && MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) 
                  {
                    MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;                  
                  }//Ограничение 
                } else {MINET_START_LECTURE -= 1;}
                break;
              }
              case 3: //HOUR_END_LECTURE -
              {
                if(HOUR_END_LECTURE <= 0) 
                {
                  HOUR_END_LECTURE = 23;
                } else 
                {
                  HOUR_END_LECTURE -= 1;
                  
                  //Ограничение
                  if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK) 
                  {
                    HOUR_END_LECTURE = HOUR_START_BREAK + HOUR_DELTA_BREAK;
                    if(MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;
                  }//Ограничение 
                } 
              break;
              }
              case 4: //MINET_END_LECTURE -
              {
                if(MINET_END_LECTURE <= 0) 
                {
                  MINET_END_LECTURE = 59;
                } else 
                {
                  MINET_END_LECTURE -= 1;
                  
                  //Ограничение    
                  if(HOUR_END_LECTURE <= HOUR_START_BREAK + HOUR_DELTA_BREAK && MINET_END_LECTURE <= MINET_START_BREAK + MINET_DELTA_BREAK) 
                  {
                    MINET_END_LECTURE = MINET_START_BREAK + MINET_DELTA_BREAK;                  
                  }//Ограничение 
                } 
                break;
              }
              case 5: //HOUR_START_BREAK -
              {
                if(HOUR_START_BREAK <= HOUR_START_LECTURE) 
                {
                  HOUR_START_BREAK = HOUR_START_LECTURE;
                } else 
                {
                  HOUR_START_BREAK -= 1;

                  //Ограничение
                  if(HOUR_START_BREAK <= HOUR_START_LECTURE) 
                  {
                    HOUR_START_BREAK = HOUR_START_LECTURE;
                    if(MINET_START_BREAK <= MINET_START_LECTURE) MINET_START_BREAK = MINET_START_LECTURE;
                  }//Ограничение                   
                } 
                break;
              }
              case 6: //MINET_START_BREAK -
              {
                if(MINET_START_BREAK <= 0) 
                {
                  MINET_START_BREAK = 59;
                } else 
                {
                  MINET_START_BREAK -= 1;
                  
                  //Ограничение
                  if(HOUR_START_BREAK <= HOUR_START_LECTURE && MINET_START_BREAK <= MINET_START_LECTURE) 
                  {
                    MINET_START_BREAK = MINET_START_LECTURE;                  
                  }//Ограничение
                }
                break;
              }
              case 7: //HOUR_DELTA_BREAK -
              {
                if(HOUR_DELTA_BREAK != 0) {HOUR_DELTA_BREAK -= 1;} else HOUR_DELTA_BREAK = 0;
                break;
              }
              case 8: //MINET_DELTA_BREAK -
              {
                if(MINET_DELTA_BREAK != 0) {MINET_DELTA_BREAK -= 1;} else MINET_DELTA_BREAK = 0;
                break;
              }         
            }//Serial.println("//Button_DOWN TIME");     
            textTime_or_Date(SET_TIMER_LECTURE, X_LECTURE_SET_TIMER, Y_LECTURE_SET_TIMER, SIZE_TEXT_LECTURE_SET_TIMER, BLUE, ':', ButSetTimerSegment);             
            textTime_or_Date(SET_TIMER_BREAK, X_BREAK_SET_TIMER, Y_BREAK_SET_TIMER, SIZE_TEXT_BREAK_SET_TIMER, BLUE, ':', ButSetTimerSegment);  
            break;
          }
        }                
        break; //рисуем так
      }
      case SET_TIME_DATE: //#define SET_TIME_DATE 7
      {
        //HOUR = TIME.hour, MIN = TIME.min, SEC = TIME.sec, DAY = TIME.date, MONTH = TIME.mon, YEAR = TIME.year; // обновляем переменные Настроек
        switch((short)(p.y + BORDER_DESKTOP)/BOXSIZE_MENU)
        { 
          case 1: //CALENDAR 2
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = CALENDAR; 
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            drawCalendar(); //Serial.print("CurrentVisibleWindow"); Serial.println(CurrentVisibleWindow); Serial.println("drawCalendar()"); 
            break; 
          }     
          case 2: //LIST_TIMERS_FIRST_WEEK 3
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = LIST_TIMERS_FIRST_WEEK;
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            WEEK = NOW_WEEK + 1; // Первая неделя 
            i_FirstStrokaListTimers = 0; // Выделить Первый Таймер
            drawListTimers(LIST_TIMERS_FIRST_WEEK); // рисуем Окно Списка Таймеров //Serial.println("drawListTimersFirstWeek();");    
            drawTimers(0); // рисуем Таймеры
            
            break;
          }  
          case 3: //Синхронизировать ВРЕМЯ // void SinchronizeTime()
          {
           //Serial.println("drawSetTimer()"); 
            break;
          }
          case 4: //Button_UP для Настройки ВРЕМЕНИ И ДАТЫ
          {                     
            switch(ButSetTimeDateSegment)
            {// Hour //byte HOUR = 0, MIN = 0, SEC = 0, DAY = 0, MONTH = 0, WEEK = 1, DOW = 0; short YEAR = 0; // день месяц год ДЛЯ работы в ОКНАХ МЕНЮ
              case 1: {HOUR += 1; if(HOUR >= 24) {HOUR = 0;} rtc.setTime(HOUR, MIN, TIME.sec); break;}
              case 2: {MIN += 1; if(MIN >= 60) {MIN = 0;} rtc.setTime(HOUR, MIN, TIME.sec); break;}
              case 3: {SEC += 5; if(SEC >= 60) {SEC = 0;} rtc.setTime(HOUR, MIN, SEC); break;}              
              case 4: {DAY += 1; if(DAY >= DaysInMonthF(MONTH, YEAR) + 1) {DAY = 1;} rtc.setDOW(DayOfWeekF(DAY, MONTH, YEAR)); rtc.setDate(DAY, MONTH, YEAR); break;}
              case 5: {MONTH += 1; if(MONTH >= 13) {MONTH = 1;} rtc.setDOW(DayOfWeekF(DAY, MONTH, YEAR)); rtc.setDate(DAY, MONTH, YEAR); break;}
              case 6: {YEAR += 1; if(YEAR >= 2100) {YEAR = 2010;} rtc.setDOW(DayOfWeekF(DAY, MONTH, YEAR)); rtc.setDate(DAY, MONTH, YEAR); break;}
              case 7: {LastDOW = DOW; DOW += 1; if(DOW >= 8) {DOW = 1;} rtc.setDOW(DOW); break;}
            }//Serial.println("//Button_UP TIME");    
            TIME = rtc.getTime(); // текущее время и дата
            textTime_or_Date(Time_H_M_S, X_TIME_SET_TIME_DATE, Y_TIME_SET_TIME_DATE, SIZE_TEXT_TIME_SET_TIME_DATE, BLUE, ':', ButSetTimeDateSegment);             
            textTime_or_Date(Date_D_Month_Year, X_DATE_SET_TIME_DATE, Y_DATE_SET_TIME_DATE, SIZE_TEXT_DATE_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);  
            textTime_or_Date(Day_Of_Week, X_DOW_SET_TIME_DATE, Y_DOW_SET_TIME_DATE, SIZE_TEXT_DOW_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);            
            break; 
          }
          case 5: //Button_DOWN для Настройки ВРЕМЕНИ И ДАТЫ
          {
            switch(ButSetTimeDateSegment)
            {// Hour //byte HOUR = 0, MIN = 0, SEC = 0, DAY = 0, MONTH = 0, WEEK = 1, DOW = 0; short YEAR = 0; // день месяц год ДЛЯ работы в ОКНАХ МЕНЮ
              case 1: {if(HOUR <= 0) {HOUR = 23;} else {HOUR -= 1;} rtc.setTime(HOUR, MIN, TIME.sec); break;}
              case 2: {if(MIN <= 0) {MIN = 59;} else {MIN -= 1;} rtc.setTime(HOUR, MIN, TIME.sec); break;}
              case 3: {if(SEC <= 0) {SEC = 59;} else {SEC -= 5;} rtc.setTime(HOUR, MIN, SEC); break;}              
              case 4: {DAY -= 1; if(DAY <= 0) {DAY = DaysInMonthF(MONTH, YEAR);} rtc.setDOW(DayOfWeekF(DAY, MONTH, YEAR)); rtc.setDate(DAY, MONTH, YEAR); break;}
              case 5: {MONTH -= 1; if(MONTH <= 0) {MONTH = 12;} rtc.setDOW(DayOfWeekF(DAY, MONTH, YEAR)); rtc.setDate(DAY, MONTH, YEAR); break;}
              case 6: {YEAR -= 1; if(YEAR <= 2010) {YEAR = 2100;} rtc.setDOW(DayOfWeekF(DAY, MONTH, YEAR)); rtc.setDate(DAY, MONTH, YEAR); break;}
              case 7: {LastDOW = DOW; if(DOW <= 0) {DOW = 7;} else {DOW -= 1;} rtc.setDOW(DOW); break;}
            }//Serial.println("//Button_DOWN TIME");     
            TIME = rtc.getTime(); // текущее время и дата     
            textTime_or_Date(Time_H_M_S, X_TIME_SET_TIME_DATE, Y_TIME_SET_TIME_DATE, SIZE_TEXT_TIME_SET_TIME_DATE, BLUE, ':', ButSetTimeDateSegment);               
            textTime_or_Date(Date_D_Month_Year, X_DATE_SET_TIME_DATE, Y_DATE_SET_TIME_DATE, SIZE_TEXT_DATE_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);  
            textTime_or_Date(Day_Of_Week, X_DOW_SET_TIME_DATE, Y_DOW_SET_TIME_DATE, SIZE_TEXT_DOW_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);
            break; 
          }
        }        
      }//case SET_TIME_DATE: 
      case SETTINGS: 
      {
        switch((short)(p.y + BORDER_DESKTOP)/BOXSIZE_MENU)
        {
          /*case 1: //CALENDAR 2
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = CALENDAR; 
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            drawCalendar(); //Serial.print("CurrentVisibleWindow"); Serial.println(CurrentVisibleWindow); Serial.println("drawCalendar()"); 
            break; 
          }
          case 2: //LIST_TIMERS_FIRST_WEEK 3
          {
            OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = LIST_TIMERS_FIRST_WEEK;
            DAY = TIME.date; MONTH = TIME.mon; YEAR = TIME.year;
            WEEK = 1; // Первая неделя 
            i_FirstStrokaListTimers = 0; // Выделить Первый Таймер
            drawListTimers(LIST_TIMERS_FIRST_WEEK); // рисуем Окно Списка Таймеров //Serial.println("drawListTimersFirstWeek();");    
            drawTimers(0); // рисуем Таймеры            
            break;
          }
          case 3: // Сохраняем в ПЗУ!!!
          {
            WriteEEPROM();
            
            break;
          }*/ 
          case 1: // Вывод СПиска ВСЕХ ТАЙМЕРОВ 
          {
            
            break; 
          }
          case 2: // ОЧИТСКА ПЗУ!!!
          {
            drawOK_Window();
            OK_WindowIsWork = OK_Window_CLEAR_EEPROM;  
            break; 
          }
          case 3: // СПЯЩИЙ РЕЖИМ
          {       
            drawOK_Window();
            OK_WindowIsWork = OK_Window_SLEEP;   
            break;
          }
          case 4: //Button_UP для SETTINGS
          {                     
            switch(ButSetTimeDateSegment)
            {// Hour //byte HOUR = 0, MIN = 0, SEC = 0, DAY = 0, MONTH = 0, WEEK = 1, DOW = 0; short YEAR = 0; // день месяц год ДЛЯ работы в ОКНАХ МЕНЮ
              case 9: {WEEK = (WEEK == 1) ? 2 : 1; break;}             
            }//Serial.println("//Button_UP SETTINGS");    
            TIME = rtc.getTime(); // текущее время и дата            
            textTime_or_Date(SET_WEEK, X_WEEK_SET_WEEK + 5*(strlen("Учебная неделя:") + 3), Y_WEEK_SET_WEEK, SIZE_TEXT_WEEK_SET_WEEK, BLUE, '.', ButSetTimeDateSegment);              
            break; 
          }
          case 5: //Button_DOWN для SETTINGS
          {
            switch(ButSetTimeDateSegment)
            {// Hour //byte HOUR = 0, MIN = 0, SEC = 0, DAY = 0, MONTH = 0, WEEK = 1, DOW = 0; short YEAR = 0; // день месяц год ДЛЯ работы в ОКНАХ МЕНЮ
              case 9: {WEEK = (WEEK == 1) ? 2 : 1; break;}                
            }//Serial.println("//Button_DOWN SETTINGS");     
            TIME = rtc.getTime(); // текущее время и дата     
            textTime_or_Date(SET_WEEK, X_WEEK_SET_WEEK + 5*(strlen("Учебная неделя:") + 3), Y_WEEK_SET_WEEK, SIZE_TEXT_WEEK_SET_WEEK, BLUE, '.', ButSetTimeDateSegment);   
            break; 
          }
        }
        break; 
      }//case SETTINGS:
    }   
  }
///////Меню слева во всех окнах!!! /// END ////////

///////Шапка Сверху в Списках Таймеров 1нед 2неж конкр.дня /// START ////////  
  if(p.x > 2*BORDER_DESKTOP + BOXSIZE_MENU && p.y < BORDER_DESKTOP + PANEL_MONTH_CALENDAR)
  {
    //bool needScan = false; // если это окно на котором нужно сканировать 
    if(p.x > 2*BORDER_DESKTOP + BOXSIZE_MENU && p.x < 2*BORDER_DESKTOP + BOXSIZE_MENU + PANEL_MONTH_CALENDAR) // Left Button
    {
      switch(CurrentVisibleWindow)
      {      
        case 2: //#define CALENDAR 2
        {
          MONTH -= 1;
          if(MONTH <= 0)
          {       
            MONTH = 12; YEAR -= 1; 
          }
          drawTopMenuOfList(CALENDAR); //Serial.println("drawTopMenuOfList() case 2: //#define CALENDAR 2 --");
          draw_calendar(); //рисуем Календарь    
          break;
        }
        case 3: case 4: //#define LIST_TIMERS_FIRST_WEEK 3 // #define LIST_TIMERS_SECOND_WEEK 4
        {
          DOW -= 1;
          if(DOW <= 0)
          {       
            DOW = 7;  
          }
          drawTopMenuOfList(LIST_TIMERS_FIRST_WEEK); //Serial.println("drawTopMenuOfList() case 3: //#define LIST_TIMERS_FIRST_WEEK 3 --");
          i_FirstStrokaListTimers = 0;
          TimersFirstTime = 1;
          drawTimers(0); // рисуем Таймеры
          break;
        } 
        case 5: //#define LIST_TIMERS_SET_DAY 5
        {
          DAY -= 1;
          if(DAY <= 0)
          { 
            MONTH -= 1; 
            if(MONTH <= 0)
            {       
              MONTH = 12; YEAR -= 1; 
            }      
            DAY = DaysInMonthF(MONTH, YEAR);  
          }
          drawTopMenuOfList(LIST_TIMERS_SET_DAY); //Serial.println("drawTopMenuOfList() case 5: //#define LIST_TIMERS_SET_DAY 5 --");
          i_FirstStrokaListTimers = 0;
          TimersFirstTime = 1;
          drawTimers(0); // рисуем Таймеры
          break;
        }
        case 6: // #define SET_TIMER 6
        {
          if(OldVisibleWindow == LIST_TIMERS_FIRST_WEEK || CurrentVisibleWindow == LIST_TIMERS_SECOND_WEEK)
          {
            DOW -= 1;
            if(DOW <= 0)
            {       
              DOW = 7;  
            }
            drawTopMenuOfList(SET_TIMER); //Serial.println("drawTopMenuOfList() case 3: //#define LIST_TIMERS_FIRST_WEEK 3 --");    
            //drawSetTimer(); //Serial.println("drawSetTimer()");     
            break;
          }
          if(OldVisibleWindow == LIST_TIMERS_SET_DAY)
          {
            DAY -= 1;
            if(DAY <= 0)
            { 
              MONTH -= 1; 
              if(MONTH <= 0)
              {       
                MONTH = 12; YEAR -= 1; 
              }      
              DAY = DaysInMonthF(MONTH, YEAR);  
            }
            drawTopMenuOfList(SET_TIMER); //Serial.println("drawTopMenuOfList() case 5: //#define LIST_TIMERS_SET_DAY 5 --");    
            //drawSetTimer(); //Serial.println("drawSetTimer()"); 
            break;
          }
        }
      }//end Switch      
    }// Left Button
        
    if(p.x > TFT_WIDTH - BORDER_DESKTOP - PANEL_MONTH_CALENDAR && p.x < TFT_WIDTH - BORDER_DESKTOP) // Right Button
    {
      switch(CurrentVisibleWindow)
      {      
        case 2: //#define CALENDAR 2
        {
          MONTH += 1; 
          if(MONTH >= 13)
          {       
            MONTH = 1; YEAR += 1; 
          }
          drawTopMenuOfList(CALENDAR);// Serial.println("drawTopMenuOfList() case 2: //#define CALENDAR 2 ++");  // void drawTopMenuOfList() //рисуем Шапку Списков Таймеров
          draw_calendar(); //рисуем Календарь    
          break;
        }
        case 3: case 4: //#define LIST_TIMERS_FIRST_WEEK 3 // #define LIST_TIMERS_SECOND_WEEK 4
        {
          DOW += 1;
          if(DOW >= 8)
          {       
            DOW = 1;  
          }
          drawTopMenuOfList(LIST_TIMERS_FIRST_WEEK); //Serial.println("drawTopMenuOfList() case 3: //#define LIST_TIMERS_FIRST_WEEK 3 --");
          i_FirstStrokaListTimers = 0; 
          TimersFirstTime = 1;
          drawTimers(0); // рисуем Таймеры
          break;
        }
        case 5: //#define LIST_TIMERS_SET_DAY 5
        {
          DAY += 1;
          if(DAY == DaysInMonthF(MONTH, YEAR) + 1)
          { 
            MONTH += 1; 
            if(MONTH >= 13)
            {       
              MONTH = 1; YEAR += 1; 
            }      
            DAY = 1;  
          }
          drawTopMenuOfList(LIST_TIMERS_SET_DAY); //Serial.println("drawTopMenuOfList() case 5: //#define LIST_TIMERS_SET_DAY 5 --");
          i_FirstStrokaListTimers = 0;
          TimersFirstTime = 1;
          drawTimers(0); // рисуем Таймеры
          break;
        }
        case 6: // #define SET_TIMER 6
        {
          if(OldVisibleWindow == LIST_TIMERS_FIRST_WEEK || CurrentVisibleWindow == LIST_TIMERS_SECOND_WEEK)
          {
            DOW += 1;
            if(DOW >= 8)
            {       
              DOW = 1;  
            }
            drawTopMenuOfList(SET_TIMER); //Serial.println("drawTopMenuOfList() case 3: //#define LIST_TIMERS_FIRST_WEEK 3 --");    
            //drawSetTimer(); //Serial.println("drawSetTimer()");          
            break;
          }
          if(OldVisibleWindow == LIST_TIMERS_SET_DAY)
          {
            DAY += 1;
            if(DAY == DaysInMonthF(MONTH, YEAR) + 1)
            { 
              MONTH += 1; 
              if(MONTH >= 13)
              {       
                MONTH = 1; YEAR += 1; 
              }      
              DAY = 1;  
            }
            drawTopMenuOfList(SET_TIMER); //Serial.println("drawTopMenuOfList() case 5: //#define LIST_TIMERS_SET_DAY 5 --");    
            //drawSetTimer(); //Serial.println("drawSetTimer()");  
            break;
          }
        }
      }//end Switch          
    }// Right Button 
    // Смена Учебной Недели //1Нед/2Нед
    if((CurrentVisibleWindow == 3 || CurrentVisibleWindow ==4) && p.x > TFT_WIDTH - BORDER_DESKTOP - 3*PANEL_MONTH_CALENDAR && p.x < TFT_WIDTH - BORDER_DESKTOP - PANEL_MONTH_CALENDAR) // WEEK Button
    {
      WEEK = (WEEK == 2 || WEEK != 1) ? 1 : 2; 
      drawTopMenuOfList(LIST_TIMERS_FIRST_WEEK); //Serial.println("drawTopMenuOfList() WEEK Button //#define LIST_TIMERS_FIRST_WEEK "); 
      i_FirstStrokaListTimers = 0;
      TimersFirstTime = 1;
      drawTimers(0); // рисуем Таймеры
    }// 1St || 2nd WEEK 
  }
///////Шапка Сверху в Списках Таймеров 1нед 2неж конкр.дня /// END ////////  


}//void onClickEvent

void TouchEvents(Adafruit_TFTLCD tft)
{
  #define MINPRESSURE 10
  #define MAXPRESSURE 1000
  #define STEP_MoveEvent 10
  #define STEP_ClickEvent 50
  #define INTERVAL_Click 500  

  tft.setRotation(1); //мой код!!!!
  digitalWrite(13, HIGH);
  p = ts.getPoint();
  digitalWrite(13, LOW);
  p.x = map(p.x, TS_MINX, TS_MAXX, 0, tft.width());
  p.y = map(p.y, TS_MINY, TS_MAXY, 0, tft.height());

  // if sharing pins, you'll need to fix the directions of the touchscreen pins
  //pinMode(XP, OUTPUT);
  pinMode(XM, OUTPUT);
  pinMode(YP, OUTPUT);
  //pinMode(YM, OUTPUT);
    
  int16_t dX = 0, dY = 0;  //#if #endif
  if (dX == 0) dX = 1; if (dY == 0) dY = 1;
  if (p.z > MINPRESSURE && p.z < MAXPRESSURE) //считываем нажатие TouchEvent
  {    
    int16_t x0_ClickEvent = p.x, y0_ClickEvent = p.y; // сохраняем предыдущие значения координат
    unsigned long currentMillis = millis(); //текущее время ms
    //delay(INTERVAL_Click);     // задержка для распознавания клика ClicksEvent     
    if(currentMillis - previousMillis > INTERVAL_Click) 
    {
      previousMillis = currentMillis;
      dX = p.x - x0_ClickEvent; dY = p.y - y0_ClickEvent; 
      if (fabs(dX) + fabs(dY) < STEP_ClickEvent) //считываем клик onClickEvent
      {
        onClickEvent(tft, p); //вызов метода по событию // надо определить в программе       
      } else
      {
        //отпускание!!!
      }          
    }            
  }  
}

//Events
/*
    onTouchEvent
    {
      onMoveEvent
      {
        onMoveUpEvent
        onMoveDownEvent
        onMoveRightEvent 
        onMoveLeftEvent       
      }      
      onClickEvent
      {
        onDbClickEvent
      }      
      onLongClickEvent    
    }
      */
//Events End
//************************************************************************************************************************************************************
// обработка событий ОКОН // END //////////////////////////////////////////////////////////////////////////////////

//рисуем Боковое Меню
void drawBoxSizeMenu() 
{
  //рисуем Пиктограммы DESKTOP 1    
  tft.fillRect(BORDER_DESKTOP, BORDER_DESKTOP, BOXSIZE_MENU, BOXSIZE_MENU, COLOR_FIELD_BOXSIZE_MENU);  
  tft.drawBitmap((int16_t) BORDER_DESKTOP, (int16_t) BORDER_DESKTOP, Icon_Desktop40, (int16_t) BOXSIZE_MENU, (int16_t) BOXSIZE_MENU, (int16_t) ICONS_COLOR);
  //рисуем квадратики       
  tft.drawRect(BORDER_DESKTOP + 1, BORDER_DESKTOP + 1, BOXSIZE_MENU - 2, BOXSIZE_MENU - 2, COLOR_BORDER_MENU); 
    
  switch(CurrentVisibleWindow) 
  {     
    case DESKTOP:  
    {           
      drawPictogram(Icon_Calendar40, 1);
      drawPictogram(Icon_Spisok40, 2);
      drawPictogram(Icon_Clock40, 3);
      drawPictogram(Icon_Nastroyki40, 4);

      if(OpenDoor) //открыто
      {
        drawPictogram(Icon_Lock40, 5);               
      }else //закрыто
      {
        drawPictogram(Icon_Key40, 5);              
      }         
      break;
    }   
    case CALENDAR: 
    {           
      drawPictogram(Icon_Calendar40, 1);
      drawPictogram(Icon_Spisok40, 2);
      drawPictogram(Icon_Clock40, 3);
      drawPictogram(Icon_Nastroyki40, 4); 

      if(OpenDoor) //открыто
      {
        drawPictogram(Icon_Lock40, 5);               
      }else //закрыто
      {
        drawPictogram(Icon_Key40, 5);              
      }         
      break;
    }    
    case LIST_TIMERS_FIRST_WEEK: case LIST_TIMERS_SECOND_WEEK: case LIST_TIMERS_SET_DAY: 
    {
      drawPictogram(Icon_Calendar40, 1);
      drawPictogram(Icon_Copy3_40, 2);
      drawPictogram(Icon_Add40, 3);
      drawPictogram(Icon_StrelkaUp40, 4);
      drawPictogram(Icon_StrelkaDown40, 5);    
      break; 
    }    
    case SET_TIMER:
    {
      drawPictogram(Icon_Calendar40, 1);
      drawPictogram(Icon_Spisok40, 2);
      drawPictogram(Icon_Ok40, 3);
      drawPictogram(Icon_StrelkaUp40, 4);
      drawPictogram(Icon_StrelkaDown40, 5);
      break; 
    }
    case EDIT_TIMER:
    {
      drawPictogram(Icon_Calendar40, 1);
      drawPictogram(Icon_Close40, 2);
      drawPictogram(Icon_Ok40, 3);
      drawPictogram(Icon_StrelkaUp40, 4);
      drawPictogram(Icon_StrelkaDown40, 5);
      break; 
    }
    case SET_TIME_DATE: 
    {
      drawPictogram(Icon_Calendar40, 1);
      drawPictogram(Icon_Spisok40, 2);
      drawPictogram(Icon_Spisok40, 3);
      drawPictogram(Icon_StrelkaUp40, 4);
      drawPictogram(Icon_StrelkaDown40, 5);
      break;  
    }
    case SETTINGS: 
    {  
      drawPictogram(Icon_Spisok40, 1);
      drawPictogram(Icon_ClearEEPROM40, 2);
      drawPictogram(Icon_Sleep40, 3);
      drawPictogram(Icon_StrelkaUp40, 4);
      drawPictogram(Icon_StrelkaDown40, 5);   
      break; 
    }
  }//switch(CurrentVisibleWindow)  
  
  // Перегородки в МЕНЮ
    tft.fillRect(BORDER_DESKTOP, BOXSIZE_MENU + BORDER_DESKTOP, BOXSIZE_MENU, BORDER_DESKTOP, COLOR_BORD_DESKTOP); //1
    tft.fillRect(BORDER_DESKTOP, 2*BOXSIZE_MENU + BORDER_DESKTOP, BOXSIZE_MENU, BORDER_DESKTOP, COLOR_BORD_DESKTOP); //2
    tft.fillRect(BORDER_DESKTOP, 3*BOXSIZE_MENU + BORDER_DESKTOP, BOXSIZE_MENU, BORDER_DESKTOP, COLOR_BORD_DESKTOP); //3
    tft.fillRect(BORDER_DESKTOP, 4*BOXSIZE_MENU + BORDER_DESKTOP, BOXSIZE_MENU, BORDER_DESKTOP, COLOR_BORD_DESKTOP); //4
    tft.fillRect(BORDER_DESKTOP, 5*BOXSIZE_MENU + BORDER_DESKTOP, BOXSIZE_MENU, BORDER_DESKTOP, COLOR_BORD_DESKTOP); //5  
    tft.fillRect(BORDER_DESKTOP, 6*BOXSIZE_MENU + BORDER_DESKTOP, BOXSIZE_MENU, BORDER_DESKTOP, COLOR_BORD_DESKTOP); //6 
}//рисуем Боковое Меню

void drawPictogram(const uint8_t *Pictogram, uint8_t n)
{  
  //рисуем Пиктограммы 
  tft.fillRect(BORDER_DESKTOP, BORDER_DESKTOP + n*BOXSIZE_MENU, BOXSIZE_MENU, BOXSIZE_MENU, COLOR_FIELD_BOXSIZE_MENU);       
  tft.drawBitmap((int16_t)BORDER_DESKTOP, (int16_t)BORDER_DESKTOP + n*BOXSIZE_MENU, Pictogram, (int16_t)BOXSIZE_MENU, (int16_t)BOXSIZE_MENU, (int16_t)ICONS_COLOR);
  //рисуем квадратики           
  tft.drawRect(BORDER_DESKTOP + 1, BORDER_DESKTOP + BOXSIZE_MENU + 1, BOXSIZE_MENU - 2, BOXSIZE_MENU - 2, COLOR_BORDER_MENU);  
}

//рисуем Верхнее МЕНЮ
void drawTopMenuOfList(byte TypeList) 
{//tft.drawRect(tft.width() - BORDER_DESKTOP - PANEL_MONTH_CALENDAR, BORDER_DESKTOP, PANEL_MONTH_CALENDAR, BORDER_DESKTOP + PANEL_MONTH_CALENDAR - 2, GREEN);
  short X_START_BUT_RIGHT = tft.width() - BORDER_DESKTOP - PANEL_MONTH_CALENDAR, Y_START_BUT_RIGHT = BORDER_DESKTOP;
  short X_START_BUT_LEFT = 2*BORDER_DESKTOP + BOXSIZE_MENU, Y_START_BUT_LEFT = BORDER_DESKTOP;
  short X_START_FIELD_CENTR = X_START_BUT_LEFT + PANEL_MONTH_CALENDAR + 3, Y_START_FIELD_CENTR = BORDER_DESKTOP;
  
  //очищаем поле Текст
  tft.fillRect(2*BORDER_DESKTOP + BOXSIZE_MENU + PANEL_MONTH_CALENDAR, BORDER_DESKTOP, tft.width() - 3*BORDER_DESKTOP - BOXSIZE_MENU - 2*PANEL_MONTH_CALENDAR, BORDER_DESKTOP + PANEL_MONTH_CALENDAR - 2, WHITE); 
  //рисуем Кнопоку Left
  tft.fillRect(X_START_BUT_LEFT + 1, Y_START_BUT_LEFT + 1, PANEL_MONTH_CALENDAR - 2, Y_START_BUT_LEFT + PANEL_MONTH_CALENDAR - 2 - 2, WHITE);
  tft.drawBitmap((int16_t) X_START_BUT_LEFT, (int16_t) Y_START_BUT_LEFT, Icon_StrelkaLeft40, (int16_t) BOXSIZE_MENU, (int16_t) BOXSIZE_MENU, (int16_t) RED);
  tft.drawRect(X_START_BUT_LEFT, Y_START_BUT_LEFT, PANEL_MONTH_CALENDAR, Y_START_BUT_LEFT + PANEL_MONTH_CALENDAR - 2, BLUE);
  //рисуем Поле Текста
  tft.drawRect(X_START_FIELD_CENTR, Y_START_FIELD_CENTR, X_START_BUT_RIGHT - X_START_FIELD_CENTR - 4, Y_START_FIELD_CENTR + PANEL_MONTH_CALENDAR - 2, BLUE);    
  //рисуем Кнопоку Right  
  tft.fillRect(X_START_BUT_RIGHT + 1, Y_START_BUT_RIGHT + 1, PANEL_MONTH_CALENDAR - 2, Y_START_BUT_RIGHT + PANEL_MONTH_CALENDAR - 2 - 2, WHITE);
  tft.drawBitmap((int16_t) X_START_BUT_RIGHT, (int16_t) Y_START_BUT_RIGHT, Icon_StrelkaRight40, (int16_t) BOXSIZE_MENU, (int16_t) BOXSIZE_MENU, (int16_t) RED);
  tft.drawRect(X_START_BUT_RIGHT, Y_START_BUT_RIGHT, PANEL_MONTH_CALENDAR, Y_START_BUT_RIGHT + PANEL_MONTH_CALENDAR - 2, BLUE);  
    
  tft.setTextSize(SIZE_TEXT_CALENDAR); tft.setTextColor(BLUE);   
  switch(TypeList)
  {
    case 2: //#define CALENDAR 2
    {String str = My_getMonthStr(1, MONTH); const char *str2 = str.c_str();
      tft.setCursor(2*BORDER_DESKTOP + BOXSIZE_MENU + PANEL_MONTH_CALENDAR + (TFT_WIDTH - 3*BORDER_DESKTOP - BOXSIZE_MENU - 2*PANEL_MONTH_CALENDAR - 5*SIZE_TEXT_CALENDAR*(strlen(str2) + 7))/2, BORDER_DESKTOP + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
      tft.print(My_getMonthStr(1, MONTH)); tft.print(" ");
      //tft.setCursor(2*BORDER_DESKTOP + BOXSIZE_MENU + PANEL_MONTH_CALENDAR + 100, BORDER_DESKTOP + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
      tft.print(YEAR);
      break;
    }
    case 3: case 4: //#define LIST_TIMERS_FIRST_WEEK 3 //#define LIST_TIMERS_SECOND_WEEK 4
    {String str = My_getDOWStr(0, DOW); const char *str2 = str.c_str();
      tft.setCursor(2*BORDER_DESKTOP + BOXSIZE_MENU + PANEL_MONTH_CALENDAR + (tft.width() - 3*BORDER_DESKTOP - BOXSIZE_MENU - 4*PANEL_MONTH_CALENDAR - 5*SIZE_TEXT_CALENDAR*strlen(str2))/2 - 3, BORDER_DESKTOP + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
      tft.print(My_getDOWStr(0, DOW));
      tft.setCursor(tft.width() - BORDER_DESKTOP - 3*PANEL_MONTH_CALENDAR + (2*PANEL_MONTH_CALENDAR - 5*SIZE_TEXT_CALENDAR*6)/2, BORDER_DESKTOP + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
      tft.print(WEEK); tft.print(utf8rus(" Нед"));
      tft.drawRect(tft.width() - BORDER_DESKTOP - 3*PANEL_MONTH_CALENDAR, BORDER_DESKTOP + 1, 2*PANEL_MONTH_CALENDAR - 1, BORDER_DESKTOP + PANEL_MONTH_CALENDAR - 3, GREEN);  
      break;
    }    
    case 5: //#define LIST_TIMERS_SET_DAY 5
    {
      //tft.drawRect(X_START_FIELD_CENTR, Y_START_FIELD_CENTR, X_START_BUT_RIGHT - 4, Y_START_FIELD_CENTR + PANEL_MONTH_CALENDAR - 2, GREEN);    
      tft.setCursor(X_START_FIELD_CENTR + (X_START_BUT_RIGHT - 4 - X_START_FIELD_CENTR - 5*SIZE_TEXT_CALENDAR*10)/2, Y_START_FIELD_CENTR + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
      tft.print(DAY); tft.print(".");
      //tft.setCursor(2*BORDER_DESKTOP + BOXSIZE_MENU + PANEL_MONTH_CALENDAR + 10 + 5*SIZE_TEXT_CALENDAR*3, BORDER_DESKTOP + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
      tft.print(MONTH); tft.print(".");
      //tft.setCursor(2*BORDER_DESKTOP + BOXSIZE_MENU + PANEL_MONTH_CALENDAR + 100, BORDER_DESKTOP + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
      tft.print(YEAR);
      break;
    }
    case 6: //#define SET_TIMER 6
    {
      if(OldVisibleWindow == LIST_TIMERS_SET_DAY)
      {
        //tft.drawRect(X_START_FIELD_CENTR, Y_START_FIELD_CENTR, X_START_BUT_RIGHT - 4, Y_START_FIELD_CENTR + PANEL_MONTH_CALENDAR - 2, GREEN);    
        tft.setCursor(X_START_FIELD_CENTR + (X_START_BUT_RIGHT - 4 - X_START_FIELD_CENTR - 5*SIZE_TEXT_CALENDAR*10)/2, Y_START_FIELD_CENTR + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
        tft.print(DAY); tft.print(".");
        //tft.setCursor(2*BORDER_DESKTOP + BOXSIZE_MENU + PANEL_MONTH_CALENDAR + 10 + 5*SIZE_TEXT_CALENDAR*3, BORDER_DESKTOP + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
        tft.print(MONTH); tft.print(".");
        //tft.setCursor(2*BORDER_DESKTOP + BOXSIZE_MENU + PANEL_MONTH_CALENDAR + 100, BORDER_DESKTOP + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
        tft.print(YEAR);
      }
      if(OldVisibleWindow == LIST_TIMERS_FIRST_WEEK || OldVisibleWindow == LIST_TIMERS_SECOND_WEEK)
      {
        String str = My_getDOWStr(0, DOW); const char *str2 = str.c_str();
        tft.setCursor(2*BORDER_DESKTOP + BOXSIZE_MENU + PANEL_MONTH_CALENDAR + (tft.width() - 3*BORDER_DESKTOP - BOXSIZE_MENU - 4*PANEL_MONTH_CALENDAR - 5*SIZE_TEXT_CALENDAR*strlen(str2))/2 - 3, BORDER_DESKTOP + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
        tft.print(My_getDOWStr(0, DOW));
        tft.setCursor(tft.width() - BORDER_DESKTOP - 3*PANEL_MONTH_CALENDAR + (2*PANEL_MONTH_CALENDAR - 5*SIZE_TEXT_CALENDAR*6)/2, BORDER_DESKTOP + (PANEL_MONTH_CALENDAR - 8*SIZE_TEXT_CALENDAR)/2); 
        tft.print(WEEK); tft.print(utf8rus(" Нед"));
        tft.drawRect(tft.width() - BORDER_DESKTOP - 3*PANEL_MONTH_CALENDAR, BORDER_DESKTOP + 1, 2*PANEL_MONTH_CALENDAR - 1, BORDER_DESKTOP + PANEL_MONTH_CALENDAR - 3, GREEN);  
      }
      break;
    }
  }  
}//рисуем Верхнее МЕНЮ

//функция рисования Рабочего стола
void drawDesktop()
{    //Serial.println("Внутри drawDesktop ");
  if(CurrentVisibleWindow == DESKTOP)
  {   // Serial.println("CurrentVisibleWindow == DESKTOP");
    tft.fillScreen(COLOR_TFT);
    //Serial.print("FirstTime");Serial.println(FirstTime, DEC);      
    // Draw a border   
    uint16_t width = tft.width() - 1;
    uint16_t height = tft.height() - 1;
    // рисуем Фон(рамку) Кнопки
    //tft.drawRect(0, 0, tft.width(), tft.height(), BLUE); tft.drawRect(1, 1, tft.width()-2, tft.height()-2, BLUE);   
    tft.fillRect(0, 0, tft.width(), BORDER_DESKTOP, COLOR_BORD_DESKTOP); //Up
    tft.fillRect(0, tft.height() - BORDER_DESKTOP, tft.width(), BORDER_DESKTOP, COLOR_BORD_DESKTOP); //Down
    tft.fillRect(0, BORDER_DESKTOP, BORDER_DESKTOP, tft.height() - BORDER_DESKTOP, COLOR_BORD_DESKTOP); //Left
    tft.fillRect(BORDER_DESKTOP + BOXSIZE_MENU, 0, BORDER_DESKTOP, tft.height(), COLOR_BORD_DESKTOP); //Left MENU
    tft.fillRect(tft.width() - BORDER_DESKTOP, BORDER_DESKTOP, tft.width(), tft.height() - BORDER_DESKTOP, COLOR_BORD_DESKTOP); //Right
    //tft.fillRect(BORDER_DESKTOP, BORDER_DESKTOP, (width - BORDER_DESKTOP * 2), (height - BORDER_DESKTOP * 2), BLUE); 

    drawBoxSizeMenu(); //рисуем Боковое Меню   
    TimeDateFirstTime = 1; //рисуем Время и Дату      
  }
}
/////////////////////////////////////////////рисования Рабочего стола//END/////////////////////////////////////////////////////////

//функция ОКНА Календаря
void drawCalendar()
{    
  //Serial.println("Inside drawCalendar()");
  //TIME = rtc.getTime(); // текущее время и дата

//if(CurrentVisibleWindow == CALENDAR)

 //Serial.println("CurrentVisibleWindow == CALENDAR");
  //код    
  tft.fillScreen(COLOR_TFT);
  // Draw a border   
  uint16_t width = tft.width() - 1;
  uint16_t height = tft.height() - 1;  
  //tft.fillRect(border, border, (width - border * 2), (height - border * 2), WHITE);   
  tft.fillRect(0, 0, tft.width(), BORDER_DESKTOP, COLOR_BORD_CALENDAR); //Up
  tft.fillRect(0, tft.height() - BORDER_DESKTOP, tft.width(), BORDER_DESKTOP, COLOR_BORD_CALENDAR); //Down    
  tft.fillRect(0, BORDER_DESKTOP, BORDER_DESKTOP, tft.height() - BORDER_DESKTOP, COLOR_BORD_CALENDAR); //Left
  tft.fillRect(BORDER_DESKTOP + BOXSIZE_MENU, BORDER_DESKTOP, BORDER_DESKTOP, tft.height() - BORDER_DESKTOP, COLOR_BORD_CALENDAR); //Left MENU
  tft.fillRect(tft.width() - BORDER_DESKTOP, BORDER_DESKTOP, tft.width(), tft.height() - BORDER_DESKTOP, COLOR_BORD_CALENDAR); //Down

  MONTH = TIME.mon, YEAR = TIME.year;
  
  drawBoxSizeMenu(); //рисуем Боковое Меню    
  drawTopMenuOfList(CALENDAR); //рисуем ШАПКУ
  draw_calendar(); //рисуем Календарь     
  //********************************************************
  //в конце отменяем Видимость для последуешего запуска
  //VisibleCalendar = false; // Calendar не будет Видим  
}

void draw_calendar() //рисуем Календарь
{    
  uint16_t X_Day = X_DAY, Y_Day = Y_DAY;
  // X_DAY = 2*BORDER_DESKTOP + BOXSIZE_MENU + LEFT_FIELD_CALENDAR - X_DATESIZE
  //Y_DAY = tft.height() - BORDER_DESKTOP/2 - 5*Y_DATESIZE;
  uint16_t Month = MONTH, Year = YEAR;//Month = TIME.mon, Year = TIME.year;
  // Очистка поля перед Рисованием            
  tft.fillRect(2*BORDER_DESKTOP + BOXSIZE_MENU + LEFT_FIELD_CALENDAR, 2*BORDER_DESKTOP + PANEL_MONTH_CALENDAR, 7*X_DATESIZE, 6*Y_DATESIZE, COLOR_TFT);       
  
  // Кнопка Влево Месяц
  /*struct Button ButLeftMonth;
ButLeftMonth.DIR_STRELKA = 3; ButLeftMonth.BUTTON_LOCATION_X = LEFT_FIELD_CALENDAR + 1; ButLeftMonth.BUTTON_LOCATION_Y = Y_Day + 2; 
ButLeftMonth.BUTTON_WIDTH = X_DATESIZE; ButLeftMonth.BUTTON_HIGH = Y_DATESIZE; 
  DrawButton(ButLeftMonth);*/
  // Кнопка Вправо Месяц
  /*struct Button ButRightMonth; // {true, 1, true, LEFT_FIELD_CALENDAR + 100, Y_Day + 2, X_DATESIZE, Y_DATESIZE, "", 2, WHITE, 0, 0, BLUE, 2, CYAN};
ButRightMonth.DIR_STRELKA = 3; ButRightMonth.BUTTON_LOCATION_X = LEFT_FIELD_CALENDAR + 1; ButRightMonth.BUTTON_LOCATION_Y = Y_Day + 2; 
ButRightMonth.BUTTON_WIDTH = X_DATESIZE; ButRightMonth.BUTTON_HIGH = Y_DATESIZE; 
  DrawButton(ButRightMonth);*/  

  //Подписываем Дни Недели
  tft.setCursor(2*BORDER_DESKTOP + BOXSIZE_MENU + LEFT_FIELD_CALENDAR + 2, Y_Day - Y_DATESIZE + 8*SIZE_TEXT_CALENDAR/2); 
  tft.setTextSize(SIZE_TEXT_CALENDAR); tft.setTextColor(COLOR_TEXT_CALENDAR); tft.print(utf8rus("Пн Вт Ср Чт Пт Сб Вс")); 
//Serial.print(" Day "); Serial.print(TIME.date, DEC); Serial.print(" mon "); Serial.print(TIME.mon, DEC); Serial.print(" year "); Serial.println(TIME.year, DEC);
//Serial.print(" dow "); Serial.print(TIME.dow, DEC); Serial.print(" rtc "); Serial.print(My_getDOWStr(0, TIME.dow));   
//  Serial.print(DaysInMonthF(TIME.mon, TIME.year), DEC);
//  Serial.print(" DaysInMonthF ");
//  Serial.print(DayOfWeekF(1, Month, Year), DEC);
//  Serial.println(" DayOfWeekF(1, Month, Year) ");

//  Serial.print(Month, DEC);  Serial.print(" Month "); Serial.print(Year, DEC);  Serial.println(" Year ");
  /*if((DayOfWeekF(1, Month, Year) >= 6 && DaysInMonthF(Month, Year) == 31) || (DayOfWeekF(1, Month, Year) == 7 && DaysInMonthF(Month, Year) == 30)) 
    {
      Y_Day -= Y_DATESIZE;
    }  */
  Y_Day -= (DayOfWeekF(1, Month, Year) >= 6 && DaysInMonthF(Month, Year) == 31 || DayOfWeekF(1, Month, Year) == 7 && DaysInMonthF(Month, Year) == 30) ? Y_DATESIZE : 0;
  for (uint8_t Day = 1, DOW = DayOfWeekF(1, Month, Year); Day<=DaysInMonthF(Month, Year); Day++, DOW++)
  {     
     //Serial.print(" Day "); Serial.print(Day, DEC); Serial.print(" Month "); Serial.print(Month, DEC); Serial.print(" Year "); Serial.print(Year, DEC);  
     //Serial.print(" DayOfWeekF(i) ");Serial.print(DayOfWeekF(Day, Month, Year), DEC);
    X_Day = X_DATESIZE*DOW + X_DAY; 
    
    //Serial.print(" Day"); Serial.println(Day, DEC); Serial.print(" DOW"); Serial.print(DOW, DEC); Serial.println(" X_Day"); Serial.print(X_Day, DEC); 
    /*Button ButDay; //{1, 0, 1, X_Day, Y_Day, X_DATESIZE, Y_DATESIZE, Day, SIZE_TEXT_CALENDAR, COLOR_TEXT_CALENDAR, COLOR_FIELD_CALENDAR, 2, COLOR_BORD_CALENDAR};
 ButDay.DIR_STRELKA = TEXT_;  ButDay.BUTTON_LOCATION_X = X_Day + BOXSIZE_MENU;  ButDay.BUTTON_LOCATION_Y = Y_Day; ButDay.BUTTON_WIDTH = X_DATESIZE;  ButDay.BUTTON_HIGH = Y_DATESIZE;
 ButDay.LABEL[0] = (char)Day/10; ButDay.LABEL[1] = (char)(Day%10); ButDay.TEXTSIZE = SIZE_TEXT_CALENDAR; ButDay.TEXTCOLOR = COLOR_TEXT_CALENDAR; ButDay.BUTTON_COLOR = WHITE; ButDay.BUTTON_BORDER = 1; //WHITE   0xFFFF
 ButDay.to_be_BUTTON_COLOR = false; ButDay.BUTTON_BORDER_COLOR = 0x001F; //#define BLUE    0x001F
*/    
    //if (TIME.year == Year && TIME.mon == Month) {ButDay.BUTTON_BORDER_COLOR = 0xF800;}  //рисуем рамку вокруг Текущего дня #define RED     0xF800
    // DrawButton(ButDay);     
    
    //рисуем поля дней      
    tft.fillRect(X_Day + 1, Y_Day + 1, X_DATESIZE - 2, Y_DATESIZE - 2, COLOR_FIELD_CALENDAR);       
    //рисуем квадратики дней      
    tft.drawRect(X_Day + 1, Y_Day + 1, X_DATESIZE - 2, Y_DATESIZE - 2, COLOR_BORD_CALENDAR);     //COLOR_BORD_CALENDAR #define RED     0xF800
    //рисуем рамку/поле вокруг Текущего дня
    if (TIME.year == Year && TIME.mon == Month && TIME.date == Day) 
    {
      tft.fillRect(X_Day + 1, Y_Day + 1, X_DATESIZE - 2, Y_DATESIZE - 2, GREEN);
      tft.drawRect(X_Day + 1, Y_Day + 1, X_DATESIZE - 2, Y_DATESIZE - 2, RED);
    }    
    uint16_t X_Day_Text = X_Day + (X_DATESIZE - 5*SIZE_TEXT_CALENDAR*2)/2;
    if(Day/10 == 0) {X_Day_Text += 5*SIZE_TEXT_CALENDAR/2;} // чтобы Одноциферные дни отображались посреди
    //пишем значения дней
    tft.setCursor(X_Day_Text, Y_Day + (Y_DATESIZE - 8*SIZE_TEXT_CALENDAR)/2); tft.setTextSize(SIZE_TEXT_CALENDAR); 
    tft.setTextColor(COLOR_TEXT_CALENDAR); tft.print(Day); 
    
    if(DOW == 7) //перевод на следующую строку дней //д.б. в конце
    {
      DOW = 0;       
      Y_Day += Y_DATESIZE;
    }
  }
}

//функция рисования Списка Таймеров ///START//////////////////////////////////////
// LIST_TIMERS
void drawListTimers(byte TypeList) //функция рисования Списка Таймеров 
{
  tft.fillScreen(COLOR_TFT);
  // Draw a border   
  uint16_t width = tft.width() - 1;
  uint16_t height = tft.height() - 1;  
  //tft.fillRect(border, border, (width - border * 2), (height - border * 2), WHITE);   
  tft.fillRect(0, 0, tft.width(), BORDER_DESKTOP, COLOR_BORD_LIST_TIMERS); //Up
  tft.fillRect(0, tft.height() - BORDER_DESKTOP, tft.width(), BORDER_DESKTOP, COLOR_BORD_LIST_TIMERS); //Down
  tft.fillRect(0, BORDER_DESKTOP, BORDER_DESKTOP, tft.height() - BORDER_DESKTOP, COLOR_BORD_LIST_TIMERS); //Left
  tft.fillRect(BORDER_DESKTOP + BOXSIZE_MENU, BORDER_DESKTOP, BORDER_DESKTOP, tft.height() - BORDER_DESKTOP, COLOR_BORD_LIST_TIMERS); //Left MENU
  tft.fillRect(tft.width() - BORDER_DESKTOP, BORDER_DESKTOP, tft.width(), tft.height() - BORDER_DESKTOP, COLOR_BORD_LIST_TIMERS); //Right

  drawBoxSizeMenu(); //рисуем Боковое Меню    
  drawTopMenuOfList(TypeList); //рисуем ШАПКУ 
  //drawListTimers(TypeList); //функция рисования Списка Таймеров    
  i_FirstStrokaListTimers = 0; // выводить таймеры с 1 строки

  TimersFirstTime = 1;
}
////////функция рисования Списка Таймеров Конкретного дня END //////////////////////

////////функция рисования Настройки Таймеров START ////////////////////// 
void drawSetTimer() // #define SET_TIMER 6 // #define EDIT_TIMER 
{
  tft.fillScreen(COLOR_TFT);
  // Draw a border   
  uint16_t width = tft.width() - 1;
  uint16_t height = tft.height() - 1;  
  //tft.fillRect(border, border, (width - border * 2), (height - border * 2), WHITE);   
  tft.fillRect(0, 0, tft.width(), BORDER_DESKTOP, COLOR_BORD_SET_TIMER); //Up
  tft.fillRect(0, tft.height() - BORDER_DESKTOP, tft.width(), BORDER_DESKTOP, COLOR_BORD_SET_TIMER); //Down
  tft.fillRect(0, BORDER_DESKTOP, BORDER_DESKTOP, tft.height() - BORDER_DESKTOP, COLOR_BORD_SET_TIMER); //Left
  tft.fillRect(BORDER_DESKTOP + BOXSIZE_MENU, BORDER_DESKTOP, BORDER_DESKTOP, tft.height() - BORDER_DESKTOP, COLOR_BORD_SET_TIMER); //Left MENU
  tft.fillRect(tft.width() - BORDER_DESKTOP, BORDER_DESKTOP, tft.width(), tft.height() - BORDER_DESKTOP, COLOR_BORD_SET_TIMER); //Right

  drawBoxSizeMenu(); //рисуем Боковое Меню    
  drawTopMenuOfList(SET_TIMER); //рисуем ШАПКУ // 

  TimeDateFirstTime = 1;
  ButSetTimerSegment = 0;
  LastButSetTimerSegment = 0;  
  TimersFirstTime = 1;
}
////////функция рисования Настройки Таймеров END //////////////////////

////////функция рисования Настройки Времени и Даты START ////////////////////// 
void drawSetTimeDate() //#define SET_TIME_DATE 7
{  
  tft.fillScreen(COLOR_TFT);
  // Draw a border   
  uint16_t width = tft.width() - 1;
  uint16_t height = tft.height() - 1;  
  //tft.fillRect(border, border, (width - border * 2), (height - border * 2), WHITE);   
  tft.fillRect(0, 0, tft.width(), BORDER_DESKTOP, RED); //Up
  tft.fillRect(0, tft.height() - BORDER_DESKTOP, tft.width(), BORDER_DESKTOP, COLOR_BORD_SET_TIME_DATE); //Down
  tft.fillRect(0, BORDER_DESKTOP, BORDER_DESKTOP, tft.height() - BORDER_DESKTOP, COLOR_BORD_SET_TIME_DATE); //Left
  tft.fillRect(BORDER_DESKTOP + BOXSIZE_MENU, BORDER_DESKTOP, BORDER_DESKTOP, tft.height() - BORDER_DESKTOP, COLOR_BORD_SET_TIME_DATE); //Left MENU
  tft.fillRect(tft.width() - BORDER_DESKTOP, BORDER_DESKTOP, tft.width(), tft.height() - BORDER_DESKTOP, COLOR_BORD_SET_TIME_DATE); //Right

  drawBoxSizeMenu(); //рисуем Боковое Меню    

  //textTime_or_Date(Time_H_M_S, X_TIME_SET_TIME_DATE, Y_TIME_SET_TIME_DATE, SIZE_TEXT_TIME_SET_TIME_DATE, BLUE, ':', ButSetTimeDateSegment);       
  //textTime_or_Date(Date_D_Month_Year, X_DATE_SET_TIME_DATE, Y_DATE_SET_TIME_DATE, SIZE_TEXT_DATE_SET_TIME_DATE, BLUE, '.', ButSetTimeDateSegment);  

  
  TimeDateFirstTime = 1;
  ButSetTimeDateSegment = 0;
  LastButSetTimeDateSegment = 0;   
}
////////функция рисования Настройки Времени и Даты END //////////////////////

////////функция рисования НАСТРОЕК START ////////////////////// 
void drawSettings() //#define SETTINGS 8
{  
  tft.fillScreen(COLOR_TFT);
  // Draw a border   
  uint16_t width = tft.width() - 1;
  uint16_t height = tft.height() - 1;  
  //tft.fillRect(border, border, (width - border * 2), (height - border * 2), WHITE);   
  tft.fillRect(0, 0, tft.width(), BORDER_DESKTOP, RED); //Up
  tft.fillRect(0, tft.height() - BORDER_DESKTOP, tft.width(), BORDER_DESKTOP, COLOR_BORD_SETTINGS); //Down
  tft.fillRect(0, BORDER_DESKTOP, BORDER_DESKTOP, tft.height() - BORDER_DESKTOP, COLOR_BORD_SETTINGS); //Left
  tft.fillRect(BORDER_DESKTOP + BOXSIZE_MENU, BORDER_DESKTOP, BORDER_DESKTOP, tft.height() - BORDER_DESKTOP, COLOR_BORD_SETTINGS); //Left MENU
  tft.fillRect(tft.width() - BORDER_DESKTOP, BORDER_DESKTOP, tft.width(), tft.height() - BORDER_DESKTOP, COLOR_BORD_SETTINGS); //Right

  drawBoxSizeMenu(); //рисуем Боковое Меню    
  //drawTopMenuOfList(SETTINGS); //рисуем ШАПКУ //

  for(byte i = 0; i < LastTimer; i++)  
  {
      //Timers[IDSortTimers[i]].TIME[j];
      //Serial.print("Timers[IDSortTimers[i]].TIME[0]  "); Serial.println(Timers[IDSortTimers[i]].TIME[0]);      
  }
  for(byte i = 0; i < LastTimer; i++)  
  {
      //Timers[IDSortTimers[i]].TIME[j];     
      //Serial.print("IDSortTimers[i]  "); Serial.println(IDSortTimers[i]);
  }  
 // Serial.print("LastTimer  "); Serial.println(LastTimer);

  //Serial.print("i_LastTimer  "); Serial.println(i_LastTimer);
  
}
////////функция рисования НАСТРОЕК END //////////////////////

void DrawWindow(uint8_t Window) 
{
  switch(Window)
  {
    case DESKTOP: OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = Window; drawDesktop(); break;
    case CALENDAR: OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = Window; drawCalendar(); break;
    case LIST_TIMERS_FIRST_WEEK: case LIST_TIMERS_SECOND_WEEK: case LIST_TIMERS_SET_DAY: OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = Window; drawListTimers(Window); break;
    case SET_TIMER: OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = Window; drawSetTimer(); break;
    case SET_TIME_DATE: OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = Window; drawSetTimeDate(); break;
    case SETTINGS: case EDIT_TIMER: OldVisibleWindow = CurrentVisibleWindow; CurrentVisibleWindow = Window; drawSettings(); break;
  }
}
/////////////////// uint8_t DayOfWeek()///START/////////////////////////////////////
int8_t DaysInMonthF(uint8_t Month, uint16_t Year)
{    
  uint8_t DaysInMonth = 30;
    bool VisokYear = false; //высокосный год VisokYear == true 
  if(Year%4==0)
  {    
    if(Year%100==0)
    {
      if(Year%400==0) VisokYear = true; else VisokYear = false;             
    }else VisokYear = true;      
  }else VisokYear = false;
  switch(Month)
  {
    case 1: case 3: case 5: case 7: case 8: case 10: case 12: DaysInMonth = 31; break;;
    case 2: if(VisokYear == true) {DaysInMonth = 29;} else {DaysInMonth = 28;}; break;
    case 4: case 6: case 9: case 11: DaysInMonth = 30; break;
    default: DaysInMonth = 0;
  }
  return DaysInMonth;
}////////////////////////// дней в месяце 

uint8_t DayOfWeekF(uint8_t Day, uint8_t Month, uint16_t Year)
{      
  byte a = (14 - Month) / 12, y = Year - a;
  uint16_t m = Month + 12*a - 2;  
  byte DOW = (7000 + (Day + y + y/4 - y/100 + y/400 + 31*m/12))%7 + 1;   
  return DOW;// = (DOW <=0) ? 7 : DOW;
} /////////////////// uint8_t DayOfWeek()///END/////////////////////////////////////


void AddDeleteTimer(byte AddDelTimer, byte ID_TIMER) // AddDelTimer = 1 = Add // если Добавляем то аргумент ID_TIMER = 0
{
  if(AddDelTimer == 0) // если УДАЛИТЬ Таймер
  { 
    Serial.println(F("*************************************")); 
    Serial.println(F("DEL Timer ")); 
    Serial.print(F("LastTimer ")); Serial.println(LastTimer); 
    //AddDelTimerEEPROM();
    //AddDeleteTimer(0, IDSelectTimer);
    //AddDeleteTimer(bool AddDelTimer, byte ID_TIMER)
    if(LastTimer != 0) 
    {
      Timers[ID_TIMER] = Timers[LastTimer - 1]; 
      WriteTimerEEPROM(ID_TIMER); // Запись в ПЗУ     
      ClearTimerEEPROM(LastTimer - 1); // Удаление из ПЗУ       
      //IDSortTimers[ID_TIMER] = IDSortTimers[LastTimer - 1]; // сохраняем Новый ID Таймера, который переместили (был последним)
    }

    Sortirovka(LastTimer - 1);
       
    if(LastTimer != 0) LastTimer -= 1; // Число Таймеров -1 
    for(byte i = 0; i < LastTimer; i++)
    {
      Serial.print(F("i = ")); Serial.println(i); Serial.print(F("   IDSortTimers[i] = ")); Serial.println(IDSortTimers[i]); 
      Serial.print(Timers[IDSortTimers[i]].TIME[0]); Serial.print(F(" : ")); Serial.println(Timers[IDSortTimers[i]].TIME[1]);
      Serial.print(Timers[i].TIME[0]); Serial.print(F(" . ")); Serial.println(Timers[i].TIME[1]);
    }
    Serial.print(F("LastTimer ")); Serial.println(LastTimer); 
  }
  
  if(AddDelTimer == 1)// если ДОБАВИТЬ Таймер
  {//if(Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && WEEK == 0 && Timers[IDSortTimers[i]].DAY == DAY /*Вывод Конкр День */ ||
  // || Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && Timers[IDSortTimers[i]].DOW == DOW && WEEK != 0 /*Вывод Неделя День */
  // }} Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && WEEK == 0 && Timers[IDSortTimers[i]].DAY == DAY /*Вывод Недельного для Календаря День */ )
  Serial.println(F("*************************************")); 
  Serial.print(F("LastTimer ")); Serial.println(LastTimer); 
    Timers[LastTimer].ID_TIMER = LastTimer; 
    //Timers[LastTimer].MUMBER_IN_LIST = 0; //?????????
    Timers[LastTimer].WEEK_OR_EACH_DAY = WEEK; // 1 - for 1st week, 2 - for 2nd week, 3 - All weeks, 0 - each day
    //Timers[LastTimer].FIRST_WEEK = (WEEK; // true - 1 неделя, false - 2 неделя
    Timers[LastTimer].ACTIVE_TIMER = true; // Включен ли Таймер
    Timers[LastTimer].DOW = DOW; // = 0 если для Конкретного Дня  
    Timers[LastTimer].TIME[0] = HOUR_START_LECTURE;
    Timers[LastTimer].TIME[1] = MINET_START_LECTURE;
    Timers[LastTimer].TIME[2] = HOUR_END_LECTURE;
    Timers[LastTimer].TIME[3] = MINET_END_LECTURE;
    Timers[LastTimer].TIME[4] = HOUR_START_BREAK;
    Timers[LastTimer].TIME[5] = MINET_START_BREAK;
    Timers[LastTimer].TIME[6] = HOUR_DELTA_BREAK;
    Timers[LastTimer].TIME[7] = MINET_DELTA_BREAK; 
    /*Timers[LastTimer].HOUR_START_LECTURE = HOUR_START_LECTURE;
    Timers[LastTimer].MINET_START_LECTURE = MINET_START_LECTURE;
    Timers[LastTimer].HOUR_END_LECTURE = HOUR_END_LECTURE;
    Timers[LastTimer].MINET_END_LECTURE = MINET_END_LECTURE;
    Timers[LastTimer].HOUR_START_BREAK = HOUR_START_BREAK;
    Timers[LastTimer].MINET_START_BREAK = MINET_START_BREAK;
    Timers[LastTimer].HOUR_DELTA_BREAK = HOUR_DELTA_BREAK;
    Timers[LastTimer].MINET_DELTA_BREAK = MINET_DELTA_BREAK;   */
    Timers[LastTimer].DAY = DAY; // =0 если для Недели
    Timers[LastTimer].MONTH = MONTH; // =0 если для Недели
    Timers[LastTimer].YEAR = YEAR; // =0 если для Недели

    //IDSortTimers[LastTimer] = LastTimer;
    
    // Сортировка по времени    byte i_LastTimer[WEEK] = {0, 0, 0}; byte IDSortTimers[WEEK][i];
    Sortirovka(LastTimer + 1);
   
    for(byte i = 0; i <= LastTimer; i++)
    {
      Serial.print(F("i = ")); Serial.println(i); Serial.print(F("   IDSortTimers[i] = ")); Serial.println(IDSortTimers[i]); 
      Serial.print(Timers[IDSortTimers[i]].TIME[0]); Serial.print(F(" : ")); Serial.println(Timers[IDSortTimers[i]].TIME[1]);
      Serial.print(Timers[i].TIME[0]); Serial.print(F(" . ")); Serial.println(Timers[i].TIME[1]);
    }    
    LastTimer += 1; 
    WriteTimerEEPROM(LastTimer - 1); // Запись в ПЗУ   
  }
  
  if(AddDelTimer == 2) // ИЗМЕНИТЬ Таймер
  {
    Timers[ID_TIMER].ID_TIMER = ID_TIMER; 
    //Timers[LastTimer].MUMBER_IN_LIST = 0; //?????????
    Timers[ID_TIMER].WEEK_OR_EACH_DAY = WEEK; // 1 - for 1st week, 2 - for 2nd week, 3 - All weeks, 0 - each day
    //Timers[ID_TIMER].FIRST_WEEK = WEEK; // true - 1 неделя, false - 2 неделя
    Timers[ID_TIMER].ACTIVE_TIMER = true; // Включен ли Таймер
    Timers[ID_TIMER].DOW = DOW; // = 0 если для Конкретного Дня  
    Timers[ID_TIMER].TIME[0] = HOUR_START_LECTURE;
    Timers[ID_TIMER].TIME[1] = MINET_START_LECTURE;
    Timers[ID_TIMER].TIME[2] = HOUR_END_LECTURE;
    Timers[ID_TIMER].TIME[3] = MINET_END_LECTURE;
    Timers[ID_TIMER].TIME[4] = HOUR_START_BREAK;
    Timers[ID_TIMER].TIME[5] = MINET_START_BREAK;
    Timers[ID_TIMER].TIME[6] = HOUR_DELTA_BREAK;
    Timers[ID_TIMER].TIME[7] = MINET_DELTA_BREAK; 
    Timers[ID_TIMER].DAY = DAY; // =0 если для Недели
    Timers[ID_TIMER].MONTH = MONTH; // =0 если для Недели
    Timers[ID_TIMER].YEAR = YEAR; // =0 если для Недели
    //Сортировка
    Sortirovka(LastTimer);
        
    for(byte i = 0; i <= LastTimer; i++)
    {
      Serial.print(F("i = ")); Serial.println(i); Serial.print(F("   IDSortTimers[i] = ")); Serial.println(IDSortTimers[i]); 
      Serial.print(Timers[IDSortTimers[i]].TIME[0]); Serial.print(F(" : ")); Serial.println(Timers[IDSortTimers[i]].TIME[1]);
    } 
    WriteTimerEEPROM(ID_TIMER); // ПереЗапись в ПЗУ   
  }
  
  if(AddDelTimer == 3) // КОПИРОВАТЬ Таймер
  {
    Timers[LastTimer].ID_TIMER = LastTimer; 
    //Timers[LastTimer].MUMBER_IN_LIST = Timers[LastTimer].MUMBER_IN_LIST; //?????????
    Timers[LastTimer].WEEK_OR_EACH_DAY = (Timers[ID_TIMER].WEEK_OR_EACH_DAY == 1) ? 2 : 0 + (Timers[ID_TIMER].WEEK_OR_EACH_DAY == 2) ? 1 : 0 + (Timers[ID_TIMER].WEEK_OR_EACH_DAY == 0) ? 0 : 0 + (Timers[ID_TIMER].WEEK_OR_EACH_DAY == 3) ? 3 : 0; 
    //Timers[ID_TIMER].FIRST_WEEK = Timers[ID_TIMER].FIRST_WEEK; // true - 1 неделя, false - 2 неделя
    Timers[LastTimer].ACTIVE_TIMER = Timers[ID_TIMER].ACTIVE_TIMER; // Включен ли Таймер
    Timers[LastTimer].DOW = Timers[ID_TIMER].DOW; // = 0 если для Конкретного Дня  
    Timers[LastTimer].TIME[0] = Timers[ID_TIMER].TIME[0];
    Timers[LastTimer].TIME[1] = Timers[ID_TIMER].TIME[1];
    Timers[LastTimer].TIME[2] = Timers[ID_TIMER].TIME[2];
    Timers[LastTimer].TIME[3] = Timers[ID_TIMER].TIME[3];
    Timers[LastTimer].TIME[4] = Timers[ID_TIMER].TIME[4];
    Timers[LastTimer].TIME[5] = Timers[ID_TIMER].TIME[5];
    Timers[LastTimer].TIME[6] = Timers[ID_TIMER].TIME[6];
    Timers[LastTimer].TIME[7] = Timers[ID_TIMER].TIME[7]; 
    Timers[LastTimer].DAY = Timers[ID_TIMER].DAY; // =0 если для Недели
    Timers[LastTimer].MONTH = Timers[ID_TIMER].MONTH; // =0 если для Недели
    Timers[LastTimer].YEAR = Timers[ID_TIMER].YEAR; // =0 если для Недели
    
    Sortirovka(LastTimer + 1);
   
    for(byte i = 0; i <= LastTimer; i++)
    {
      Serial.print(F("i = ")); Serial.println(i); Serial.print(F("   IDSortTimers[i] = ")); Serial.println(IDSortTimers[i]); 
      Serial.print(Timers[IDSortTimers[i]].TIME[0]); Serial.print(F(" : ")); Serial.println(Timers[IDSortTimers[i]].TIME[1]);
      Serial.print(Timers[i].TIME[0]); Serial.print(F(" . ")); Serial.println(Timers[i].TIME[1]);
    }    
    LastTimer += 1; 
    WriteTimerEEPROM(LastTimer - 1); // Запись в ПЗУ   
  }
}//void AddDeleteTimer(bool AddDelTimer, byte ID_TIMER) // AddDelTimer = true = Add // если Добавляем то аргумент ID_TIMER = 0

void drawTimers(bool Segment)//, byte TypeList) // TypeList - Each DAY, 1WEEK, 2WEEK
{
  byte dY = 2*8*SIZE_TEXT_LIST_TIMERS + 3*BORDER_TEXT_LIST_TIMERS; // Полная Высота Строки Таймера
  byte dY_TimerTextCursor = BORDER_TEXT_LIST_TIMERS; 
  byte n = (Y2_LIST_TIMERS - Y1_LIST_TIMERS)/dY; // число Строк Таймеров (реальное)
  short TextColor = COLOR_TEXT_LIST_TIMERS;
  short TextColorIndication = MAGENTA;
  short TextSize = SIZE_TEXT_LIST_TIMERS;
  short Text_High = 8*TextSize;
  short CursorX = X1_LIST_TIMERS + 10*BORDER_TEXT_LIST_TIMERS;
  short CursorY = BOXSIZE_MENU + 2*BORDER_TEXT_LIST_TIMERS;
  short CursorTimerStartHour = CursorX; //начало часов
  short CursorTimerStartMin = CursorTimerStartHour + 5*TextSize*3 + 5*TextSize/2; //начало минут
  short CursorTimerEndHour = CursorTimerStartMin + 5*TextSize*3 + 5*TextSize/2; //конец часов
  short CursorTimerEndMin = CursorTimerEndHour + 5*TextSize*3 + 5*TextSize/2; //конец минут
  short EndCursorTimer = CursorTimerEndMin + 5*TextSize*3; //конец Текста

  //Очищаем Поле Списка Таймеров
  if(TimersFirstTime)
  {
    tft.fillRect(X1_LIST_TIMERS, Y1_LIST_TIMERS, X2_LIST_TIMERS - X1_LIST_TIMERS, TFT_HIGHT - Y1_LIST_TIMERS - BORDER_DESKTOP, COLOR_TFT);    
  }
  //рисуем Список Таймеров     
  for(byte i = 0, k = 0, m = 0; i < LastTimer; i++) // Лекции // 
  {         
    //if(Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && WEEK == 0 && Timers[IDSortTimers[i]].DAY == DAY || Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && Timers[IDSortTimers[i]].DOW == DOW && WEEK != 0)
    //CurrentVisibleWindow == //Timers[IDSortTimers[i]].DAY ==  || Timers[IDSortTimers[i]].DOW == 0 && Timers[IDSortTimers[i]].DAY == DAY && Timers[IDSortTimers[i]].MONTH == MONTH && Timers[IDSortTimers[i]].YEAR == YEAR)
    //if(Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && WEEK == 0 && Timers[IDSortTimers[i]].DAY == DAY || Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && Timers[IDSortTimers[i]].DOW == DOW && WEEK != 0)
    if((Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && WEEK == 0 && Timers[IDSortTimers[i]].DAY == DAY && Timers[IDSortTimers[i]].MONTH == MONTH && Timers[IDSortTimers[i]].YEAR == YEAR) || (Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && (WEEK == 1 || WEEK == 2) && Timers[IDSortTimers[i]].DOW == DOW))    
    {     
      Serial.println(F("if((Timers[IDSortTimers[i]].WEEK_OR_EACH_DAY == WEEK && WEEK == 0 && Timers[IDSortTimers[i]].DAY == DAY && Timers[IDSortTimers[i]].MONTH == MONTH && Tim "));
      Serial.print(F("i = ")); Serial.println(i); Serial.print(F("   IDSortTimers[i] = ")); Serial.println(IDSortTimers[i]); 
      Serial.print(Timers[IDSortTimers[i]].TIME[0]); Serial.print(F(" : ")); Serial.println(Timers[IDSortTimers[i]].TIME[1]);
      Serial.print(Timers[i].TIME[0]); Serial.print(F(" . ")); Serial.println(Timers[i].TIME[1]);         
      Serial.print(F("LastTimer ")); Serial.println(LastTimer); 
/*     
struct Timer
{  
  byte ID_TIMER = 0; 
  byte WEEK_OR_EACH_DAY = 1; // 1 for 1st week, 2 for 2nd week, 0 - each day 
  bool ACTIVE_TIMER = true; 
  byte DOW = 0;
  byte TIME[8];  
  byte DAY = 0;
  byte MONTH = 0;
  short YEAR = 0; //format XX   
};      */    
      // Условие вывода Списка Таймеров начиная с номера i_FirstStrokaListTimers
      if(k >= i_FirstStrokaListTimers && k < n + i_FirstStrokaListTimers)
      {
        if(!Segment)
        {
          Serial.println(F("Inside if(!Segment) "));
          Serial.print(F("i = ")); Serial.println(i); Serial.print(F("   IDSortTimers[i] = ")); Serial.println(IDSortTimers[i]); 
          Serial.print(Timers[IDSortTimers[i]].TIME[0]); Serial.print(F(" : ")); Serial.println(Timers[IDSortTimers[i]].TIME[1]);
          Serial.print(Timers[i].TIME[0]); Serial.print(F(" . ")); Serial.println(Timers[i].TIME[1]);         
          Serial.print(F("LastTimer ")); Serial.println(LastTimer); 
          
          short CursorX_TEXT = CursorX;// CursorY_TEXT = CursorY;
          //CursorY += i*dY;
          //Рисуем Рамку Таймера
          if(TimersFirstTime)
          {
            //tft.fillRect(X1_LIST_TIMERS, Y1_LIST_TIMERS, X2_LIST_TIMERS - X1_LIST_TIMERS, TFT_HIGHT - Y1_LIST_TIMERS - BORDER_DESKTOP, COLOR_TFT);    
            //tft.fillRect(X1_LIST_TIMERS + 1, Y1_LIST_TIMERS + (k - i_FirstStrokaListTimers)*dY, X2_LIST_TIMERS - X1_LIST_TIMERS + 1, dY + 1, COLOR_TFT);
            tft.drawRect(X1_LIST_TIMERS + 1, Y1_LIST_TIMERS + (k - i_FirstStrokaListTimers)*dY, X2_LIST_TIMERS - X1_LIST_TIMERS + 1, dY + 1, CYAN);
            TimersFirstTime = 0;
          }else 
          {                       
            // Очищаем поле под Номера Строк   
            tft.fillRect(CursorX_TEXT - 5*TextSize - 7, CursorY + BORDER_TEXT_LIST_TIMERS - 2, 5*TextSize + 2, Text_High + BORDER_TEXT_LIST_TIMERS + 8*TextSize + 1, COLOR_TFT);
            // Очищаем поле под Начала Лекций и Перерывов
            tft.fillRect(CursorX_TEXT - 4, CursorY + BORDER_TEXT_LIST_TIMERS - 1, 5*TextSize*6 + 2, Text_High + BORDER_TEXT_LIST_TIMERS + 8*TextSize + 1, COLOR_TFT);
            // Очищаем поле под Концы Лекций и Перерывов
            tft.fillRect(CursorX_TEXT + 5*TextSize*7 - 4, CursorY + BORDER_TEXT_LIST_TIMERS - 1, 5*TextSize*6 + 2, Text_High + BORDER_TEXT_LIST_TIMERS + 8*TextSize + 1, COLOR_TFT); 
            tft.drawRect(X1_LIST_TIMERS + 1, Y1_LIST_TIMERS + (k - i_FirstStrokaListTimers)*dY, X2_LIST_TIMERS - X1_LIST_TIMERS + 1, dY + 1, CYAN);                                      
          }
                    
          // Нумерация Строк
          tft.setCursor(CursorX_TEXT - 5*TextSize - 6, CursorY + Text_High/2 + BORDER_TEXT_LIST_TIMERS); tft.setTextSize(TextSize); tft.setTextColor(TextColor);            
          tft.print(k + 1);

          //рисуем Кнопоку ВКЛ/ОТКЛ            
          String VklOtkl = "ВКЛ";
          if(Timers[IDSortTimers[i]].ACTIVE_TIMER == true) {TIMER_BUT_COLOR = GREEN; VklOtkl = "ВКЛ";}else {TIMER_BUT_COLOR = RED; VklOtkl = "ОТК";}
          tft.fillRect(X2_LIST_TIMERS - PANEL_MONTH_CALENDAR + 1, Y1_LIST_TIMERS + (k - i_FirstStrokaListTimers)*dY, PANEL_MONTH_CALENDAR + 1, dY + 1, TIMER_BUT_COLOR);
          tft.drawRect(X2_LIST_TIMERS - PANEL_MONTH_CALENDAR + 1, Y1_LIST_TIMERS + (k - i_FirstStrokaListTimers)*dY, PANEL_MONTH_CALENDAR + 1, dY + 1, CYAN);          
          tft.setCursor(X2_LIST_TIMERS - PANEL_MONTH_CALENDAR + 4, Y1_LIST_TIMERS + (k - i_FirstStrokaListTimers)*dY + BORDER_DESKTOP + (dY - 8*TextSize)/2); 
          tft.setTextSize(TextSize); tft.setTextColor(COLOR_FIELD_LIST_TIMERS); tft.print(utf8rus(VklOtkl)); 
                   
          // Пишем Лекции и Перерывы
          for(byte j = 0; j < 4; j++)
          {         
            // Лекции
            tft.setCursor(CursorX_TEXT - 3, CursorY + BORDER_TEXT_LIST_TIMERS); tft.setTextSize(TextSize); tft.setTextColor(COLOR_FIELD_LIST_TIMERS);
            //if(SelectTimer == i) tft.setTextColor(TextColorIndication); // Индикация 
            if((byte)Timers[IDSortTimers[i]].TIME[j]/10 == 0){tft.print("0");} tft.print(Timers[IDSortTimers[i]].TIME[j]);   
            switch(j)
            {
              case 0: case 2: tft.print(":"); break;
              case 1: tft.print(" "); break;
              case 3: tft.setTextSize(1); tft.print(" "); tft.setTextSize(TextSize); tft.setTextColor(TextColor); tft.print(utf8rus("Лекция")); break;
            }
            // Перерывы
            tft.setCursor(CursorX_TEXT - 3, CursorY + Text_High + BORDER_TEXT_LIST_TIMERS); tft.setTextSize(TextSize); tft.setTextColor(COLOR_FIELD_LIST_TIMERS);
            //if(SelectTimer == i) tft.setTextColor(TextColorIndication); // Индикация 
            if((byte)Timers[IDSortTimers[i]].TIME[j+4]/10 == 0){tft.print("0");} tft.print(Timers[IDSortTimers[i]].TIME[j+4]); 
            switch(j)
            {
              case 0: tft.print(":"); break;           
              case 1: tft.print(" "); break;
              case 2: tft.print("."); break;
              case 3: tft.setTextSize(1); tft.print(" "); tft.setTextSize(TextSize); tft.setTextColor(TextColor); tft.print(utf8rus("Перерыв")); break;
            }        
            CursorX_TEXT += 5*TextSize*3 + 5*TextSize/2; // Следующий сегмент        
          }// End for // Пишем Лекции и Перерывы          
        CursorY += dY; CursorX_TEXT = CursorX;

        // доочищаем экран от последнего таймера до границы
        //tft.fillRect(X1_LIST_TIMERS + 1, Y1_LIST_TIMERS + k*dY, X2_LIST_TIMERS - X1_LIST_TIMERS + 1, dY + 1, COLOR_TFT);
        tft.fillRect(X1_LIST_TIMERS + 1, CursorY, X2_LIST_TIMERS - X1_LIST_TIMERS + 1, TFT_HIGHT - CursorY - BORDER_DESKTOP, COLOR_TFT);    
        }else // Условие вывода Списка Таймеров начиная с номера i_FirstStrokaListTimers       
        {
          //Segment = 1 // Перерисовываем Кнопоку ВКЛ/ОТКЛ            
          String VklOtkl = "ВКЛ";
          if(Timers[IDSortTimers[i]].ACTIVE_TIMER == true) {TIMER_BUT_COLOR = GREEN; VklOtkl = "ВКЛ";}else {TIMER_BUT_COLOR = RED; VklOtkl = "ОТК";}
          tft.fillRect(X2_LIST_TIMERS - PANEL_MONTH_CALENDAR + 1, Y1_LIST_TIMERS + (k - i_FirstStrokaListTimers)*dY, PANEL_MONTH_CALENDAR + 1, dY + 1, TIMER_BUT_COLOR);
          tft.drawRect(X2_LIST_TIMERS - PANEL_MONTH_CALENDAR + 1, Y1_LIST_TIMERS + (k - i_FirstStrokaListTimers)*dY, PANEL_MONTH_CALENDAR + 1, dY + 1, CYAN);          
          tft.setCursor(X2_LIST_TIMERS - PANEL_MONTH_CALENDAR + 4, Y1_LIST_TIMERS + (k - i_FirstStrokaListTimers)*dY + BORDER_DESKTOP + (dY - 8*TextSize)/2); 
          tft.setTextSize(TextSize); tft.setTextColor(COLOR_FIELD_LIST_TIMERS); tft.print(utf8rus(VklOtkl));                      
        }// if(!Segment)             
      }   
      k += 1; // считаем кол-во выведенных таймеров  // Номер строки Списка Таймеров       
    }// Конец Условия Вывода
  }       
}
 
void RefreshTimer() // обработка всех действий связанных с таймерами
{
 //код
  
}

// Wait one touch
TSPoint waitOneTouch()
{
  // wait 1 touch to exit function      
  do {
    digitalWrite(13, HIGH); 
    p=ts.getPoint();     
    digitalWrite(13, LOW);
    p.x = map(p.x, TS_MINX, TS_MAXX, 0, tft.width());
    p.y = map(p.y, TS_MINY, TS_MAXY, 0, tft.height());
    pinMode(XM, OUTPUT); //Pins configures again for TFT control
    pinMode(YP, OUTPUT);  
  } while((p.z < MINPRESSURE )|| (p.z > MAXPRESSURE)); 
  delay(2000); 
  return p;
}

// нажатие на кнопку да/нет
bool TSPointMatchButton(int X, int Y, int Width, int Hight)
{
  digitalWrite(13, HIGH);  
  p = ts.getPoint();
  digitalWrite(13, LOW);
  p.x = map(p.x, TS_MINX, TS_MAXX, 0, tft.width());
  p.y = map(p.y, TS_MINY, TS_MAXY, 0, tft.height());
  if(p.x >= X && p.x <= X + Width)
  {
    if(p.y >= Y && p.y <= Y + Hight) return 1;
  }
  else return 0;
}
//////////////////////////////START//////////////// EEPROM/////////////////////////////////////////////////////////////////////////

void ClearTimerEEPROM(byte ID) // Удаление из ПЗУ  
{
  Serial.println(F("******************************************************************************")); 
  Serial.print(F("void ClearTimerEEPROM(int adress)"));
  Serial.print(F("adress Start  "));Serial.println(adress); // выводим адрес в послед. порт 

  //byte LastTimer;
  adress += sizeof(NOW_WEEK);
  EEPROM.put(adress, LastTimer); // записали Array по адресу adress   
  Serial.print(F("adress LastTimer  "));Serial.println(adress); // выводим адрес в послед. порт 

  //byte LastTimerDay;
  adress += sizeof(LastTimer);
  EEPROM.put(adress, LastTimerDay); // записали Array по адресу adress   
  Serial.print(F("adress LastTimerDay  "));Serial.println(adress); // выводим адрес в послед. порт 

  //byte LastTimerDOW_1;
  adress += sizeof(LastTimerDay);
  EEPROM.put(adress, LastTimerDOW_1); // записали Array по адресу adress   
  Serial.print(F("adress LastTimerDOW_1  "));Serial.println(adress); // выводим адрес в послед. порт 

  //byte LastTimerDOW_2;
  adress += sizeof(LastTimerDOW_1);
  EEPROM.put(adress, LastTimerDOW_2); // записали Array по адресу adress   
  Serial.print(F("adress LastTimerDOW_2  "));Serial.println(adress); // выводим адрес в послед. порт 
  
  adress += sizeof(LastTimerDOW_2) + ID*sizeof(Timers[0]); // вычисляем ячейку памяти с нужным Таймером
  for (int i = adress ; i < sizeof(Timers[0]) + adress; i++) 
  {
    EEPROM.write(i, 0);
    Serial.print(F("    EEPROM i ")); Serial.println(EEPROM.read(i));
    if(i/256 != 0 && i%256 == 0) {Serial.println(F(" "));Serial.println(F("*************256bit**************"));}
  }
   
  Serial.print(F("adress Timer Timers[TIMERS]  ")); Serial.println(adress); // выводим адрес в послед. порт 
  Serial.println(F("END ClearTimerEEPROM")); // выводим адрес в послед. порт 
  Serial.println(F("******************************************************************************")); 
  
  adress = 0;
}

void WriteTimerEEPROM(byte ID)
{ 
  Serial.println(F("******************************************************************************")); 
  Serial.print(F("void WriteTimerEEPROM(int adress)"));
  Serial.print(F("adress Start  "));Serial.println(adress); // выводим адрес в послед. порт 

  //byte LastTimer;
  adress += sizeof(NOW_WEEK);
  EEPROM.put(adress, LastTimer); // записали Array по адресу adress   
  Serial.print(F("adress LastTimer  "));Serial.println(adress); // выводим адрес в послед. порт 

  //byte LastTimerDay;
  adress += sizeof(LastTimer);
  EEPROM.put(adress, LastTimerDay); // записали Array по адресу adress   
  Serial.print(F("adress LastTimer  "));Serial.println(adress); // выводим адрес в послед. порт 

  //byte LastTimerDOW_1;
  adress += sizeof(LastTimerDay);
  EEPROM.put(adress, LastTimerDOW_1); // записали Array по адресу adress   
  Serial.print(F("adress LastTimerDOW_1  "));Serial.println(adress); // выводим адрес в послед. порт 

  //byte LastTimerDOW_2;
  adress += sizeof(LastTimerDOW_1);
  EEPROM.put(adress, LastTimerDOW_2); // записали Array по адресу adress   
  Serial.print(F("adress LastTimerDOW_2  "));Serial.println(adress); // выводим адрес в послед. порт 
  
  //Timer Timers[TIMERS]; || Timer TimersFromEEPROM[TIMERS];
  adress += sizeof(LastTimerDOW_2) + ID*sizeof(Timers[0]); // вычисляем ячейку памяти с нужным Таймером
  EEPROM.put(adress, Timers[ID]); // записали Array по адресу adress   
  Serial.print(F("adress Timer Timers[TIMERS]  ")); Serial.println(adress); // выводим адрес в послед. порт 
  
  Serial.println(F("END WriteTimerEEPROM")); // выводим адрес в послед. порт 
  Serial.println(F("******************************************************************************")); 
  adress = 0;
}

void WriteEEPROM()
{ 
  /*Serial.println("******************************************************************************"); 
  Serial.print("void WriteEEPROM(Timer Array, int adress)");
  Serial.print("adress Start  ");Serial.println(adress); // выводим адрес в послед. порт 
  //bool NOW_WEEK = 0
  EEPROM.put(adress, NOW_WEEK); // записали Array по адресу adress 
  adress += sizeof(NOW_WEEK); // вычисляем следующую свободную ячейку памяти  
  Serial.print("adress NOW_WEEK  ");Serial.println(adress); // выводим адрес в послед. порт   
  
  //byte LastTimer;
  EEPROM.put(adress, LastTimer); // записали Array по адресу adress 
  adress += sizeof(LastTimer); // вычисляем следующую свободную ячейку памяти  
  Serial.print("adress LastTimer  ");Serial.println(adress); // выводим адрес в послед. порт 

  //byte LastTimerDay;
  EEPROM.put(adress, LastTimerDay); // записали Array по адресу adress 
  adress += sizeof(LastTimerDay); // вычисляем следующую свободную ячейку памяти  
  Serial.print("adress LastTimerDay  "); Serial.println(adress); // выводим адрес в послед. порт 

  //byte LastTimerDOW_1;
  EEPROM.put(adress, LastTimerDOW_1); // записали Array по адресу adress 
  adress += sizeof(LastTimerDOW_1); // вычисляем следующую свободную ячейку памяти  
  Serial.print("adress LastTimerDOW_1  ");Serial.println(adress); // выводим адрес в послед. порт 

  //byte LastTimerDOW_2;
  EEPROM.put(adress, LastTimerDOW_2); // записали Array по адресу adress 
  adress += sizeof(LastTimerDOW_2); // вычисляем следующую свободную ячейку памяти  
  Serial.print("adress LastTimerDOW_2  ");Serial.println(adress); // выводим адрес в послед. порт 
  
  //Timer Timers[TIMERS]; || Timer TimersFromEEPROM[TIMERS];
  EEPROM.put(adress, Timers); // записали Array по адресу adress 
  //adress += sizeof(Timers); // вычисляем следующую свободную ячейку памяти  
  Serial.print("adress Timer Timers[TIMERS]  "); Serial.println(adress); // выводим адрес в послед. порт 
  //byte IDSortTimers[TIMERS]; 
  //EEPROM.put(adress, IDSortTimers); // записали Array по адресу adress 
  //adress += sizeof(IDSortTimers); // вычисляем следующую свободную ячейку памяти  
  //Serial.print("adress IDSortTimers  ");Serial.println(adress); 
  
  Serial.println("END WriteEEPROM"); // выводим адрес в послед. порт 
  Serial.println("******************************************************************************"); 
  adress = 0;*/
}

void ReadEEPROM()
{
  Serial.println(F("******************************************************************************")); 
  Serial.print(F("void ReadEEPROM(int adress)"));  
  
  Serial.print(F("adress Start  ")); Serial.println(adress); // выводим адрес в послед. порт 
    
  EEPROM.get(adress, NOW_WEEK); // записали Array по адресу adress 
  adress += sizeof(NOW_WEEK); // вычисляем следующую свободную ячейку памяти  
  Serial.print(F("adress NOW_WEEK  "));Serial.println(adress); // выводим адрес в послед. порт   
  Serial.print(F("NOW_WEEK = "));Serial.println(NOW_WEEK); 
  
  //byte LastTimer;
  EEPROM.get(adress, LastTimer); // записали Array по адресу adress 
  adress += sizeof(LastTimer); // вычисляем следующую свободную ячейку памяти  
  Serial.print(F("adress LastTimer  "));Serial.println(adress); // выводим адрес в послед. порт 
  Serial.print(F("LastTimer = "));Serial.println(LastTimer); 

  //byte LastTimerDay;
  EEPROM.get(adress, LastTimerDay); // записали Array по адресу adress 
  adress += sizeof(LastTimerDay); // вычисляем следующую свободную ячейку памяти  
  Serial.print(F("adress LastTimerDay  "));Serial.println(adress); // выводим адрес в послед. порт 
  Serial.print(F("LastTimerDay = ")); Serial.println(LastTimerDay); 

  //byte LastTimerDOW_1;
  EEPROM.get(adress, LastTimerDOW_1); // записали Array по адресу adress 
  adress += sizeof(LastTimerDOW_1); // вычисляем следующую свободную ячейку памяти  
  Serial.print(F("adress LastTimerDOW_1  "));Serial.println(adress); // выводим адрес в послед. порт 
  Serial.print(F("LastTimerDOW_1 = "));Serial.println(LastTimerDOW_1); 

  //byte LastTimerDOW_2;
  EEPROM.get(adress, LastTimerDOW_2); // записали Array по адресу adress 
  adress += sizeof(LastTimerDOW_2); // вычисляем следующую свободную ячейку памяти  
  Serial.print(F("adress LastTimerDOW_2  "));Serial.println(adress); // выводим адрес в послед. порт 
  Serial.print(F("LastTimerDOW_2 = "));Serial.println(LastTimerDOW_2); 
  
  //Timer Timers[TIMERS]; || Timer TimersFromEEPROM[TIMERS];
  EEPROM.get(adress, Timers); // записали Array по адресу adress 
  
  //adress += sizeof(Timers); // вычисляем следующую свободную ячейку памяти  
  Serial.print(F("adress Timer Timers[TIMERS]  ")); Serial.println(adress); // выводим адрес в послед. порт     
  //byte IDSortTimers[TIMERS]; 
  //EEPROM.get(adress, IDSortTimers); // записали Array по адресу adress 
  //adress += sizeof(IDSortTimers); // вычисляем следующую свободную ячейку памяти  
  //Serial.print("adress IDSortTimers  ");Serial.println(adress); // выводим адрес в послед. порт
  //Serial.print("NOW_WEEK = ");Serial.println(NOW_WEEK);  
  
  for (int i = 0; i < LastTimer; i++) 
  {
    Serial.print(Timers[i].TIME[0]); Serial.print("  "); // выводим массив в порт  
  }
  for (int i = 0; i < LastTimer; i++) 
  {
    Serial.print(IDSortTimers[i]); Serial.print("  "); // выводим массив в порт  
  }
  Serial.println(F("******************************************************************************")); 
  adress = 0;
}

void ClearEEPROM()
{
  for (int i = 0 ; i < EEPROM.length() ; i++) 
  {
    EEPROM.write(i, 0);
    Serial.print(F("EEPROM i  ")); Serial.println(EEPROM.read(i));
    if(i/256 != 0 && i%256 == 0) {Serial.println("");Serial.println(F("*************256bit**************"));}
  }
  Serial.println(F("*************ClearEEPROM()/////// END"));
}
//////////////////////////////END//////////////// EEPROM/////////////////////////////////////////////////////////////////////////

void VerifyWorkOfTimers()
{
  /*Timers[LastTimer].TIME[0] = HOUR_START_LECTURE;
    Timers[LastTimer].TIME[1] = MINET_START_LECTURE;
    Timers[LastTimer].TIME[2] = HOUR_END_LECTURE;
    Timers[LastTimer].TIME[3] = MINET_END_LECTURE;
    Timers[LastTimer].TIME[4] = HOUR_START_BREAK;
    Timers[LastTimer].TIME[5] = MINET_START_BREAK;
    Timers[LastTimer].TIME[6] = HOUR_DELTA_BREAK;
    Timers[LastTimer].TIME[7] = MINET_DELTA_BREAK; */
  unsigned long SumSecTimer = 0;     
  bool EACH_DAY_TimerIsWork = 0, FirstTimeVerifyWorkOfTimers = 1; // Локальная 
  byte Timers_HOUR_END_BREAK = 0, Timers_MINET_END_BREAK = 0;
  NextIDTimerIsWork = 255;
  for(byte i = 0; i < LastTimerDay; i++)
  {
    // Сработка Таймеров Для КАЖДОГО ДНЯ
    // Если Время Больше чем Начало Лекции
    // Если Время Меньше чем Конец Лекции
    // Если Время Меньше чем Начало Перерыва
    // Если Время Больше чем Конец Перерыва 
    // IDSortTimersDay[TIMERS], IDSortTimersDOW_1[TIMERS], IDSortTimersDOW_2[TIMERS]; LastTimerDay = 0, LastTimerDOW_1 = 0, LastTimerDOW_2 = 0;
        
    if(Timers[IDSortTimersDay[i]].ACTIVE_TIMER == true && Timers[IDSortTimersDay[i]].WEEK_OR_EACH_DAY == 0 && Timers[IDSortTimersDay[i]].DAY == TIME.date && Timers[IDSortTimersDay[i]].MONTH == TIME.mon && Timers[IDSortTimersDay[i]].YEAR == TIME.year)
    {
      Serial.print(F("do DayTimerIsExist  ")); Serial.println(DayTimerIsExist);
      DayTimerIsExist = 1; // Есть Хоть один таймер на этот День
      Serial.print(F("posle DayTimerIsExist  ")); Serial.println(DayTimerIsExist);

      if(FirstTimeVerifyWorkOfTimers && (TIME.hour < Timers[IDSortTimersDay[i]].TIME[0] || TIME.min < Timers[IDSortTimersDay[i]].TIME[1] && TIME.hour <= Timers[IDSortTimersDay[i]].TIME[0])) 
      {
        NextIDTimerIsWork = IDSortTimersDay[i]; 
        Serial.print(F("FirstTimeVerifyWorkOfTimers  NextIDTimerIsWork Day ")); Serial.println(NextIDTimerIsWork);
        FirstTimeVerifyWorkOfTimers = 0;
      }       
      
      if(TIME.min >= Timers[IDSortTimersDay[i]].TIME[1] && TIME.hour >= Timers[IDSortTimersDay[i]].TIME[0] \ 
      && TIME.min < Timers[IDSortTimersDay[i]].TIME[3] && TIME.hour <= Timers[IDSortTimersDay[i]].TIME[2]) 
      { // Внутри Таймера        
        Timers_HOUR_END_BREAK = Timers[IDSortTimersDay[i]].TIME[4] + Timers[IDSortTimersDay[i]].TIME[6]; 
        Timers_MINET_END_BREAK = Timers[IDSortTimersDay[i]].TIME[5] + Timers[IDSortTimersDay[i]].TIME[7];
        Serial.print(F("Timers_HOUR_END_BREAK ")); Serial.println(Timers_HOUR_END_BREAK); Serial.print(F("Timers_MINET_END_BREAK ")); Serial.println(Timers_MINET_END_BREAK); 
      
        if((Timers[IDSortTimersDay[i]].TIME[6] == 0 && Timers[IDSortTimersDay[i]].TIME[7] == 0) \
        || (TIME.min < Timers[IDSortTimersDay[i]].TIME[5] && TIME.hour <= Timers[IDSortTimersDay[i]].TIME[4]) \ 
        || (TIME.min >= Timers_MINET_END_BREAK && TIME.hour >= Timers_HOUR_END_BREAK))     
        {//Промежутки Лекции Вне перерыва       
          IDTimerIsWork = IDSortTimersDay[i]; if(i+1 < LastTimerDay){NextIDTimerIsWork = IDSortTimersDay[i+1];}else {NextIDTimerIsWork = 255;} 
          TimerIsWork = 1; // Таймер СРАБОТАН 
          BreakIsWork = 0; // Перерыва нет          
        }else 
        {
          TimerIsWork = 1; // Таймер СРАБОТАН     
          BreakIsWork = 1;
          break;
        } //Перерыв    
        break;  
      }else 
      {
        TimerIsWork = 0; 
        BreakIsWork = 0;
      } // Таймер НЕ СРАБОТАН  
    }else {NextIDTimerIsWork = 255;} // Таймеры на День
  }
  Serial.print(F("NextIDTimerIsWork  ")); Serial.println(NextIDTimerIsWork);
  if(!DayTimerIsExist) //DayTimerIsExist = 1; // Есть Хоть один таймер на этот День
  {
    FirstTimeVerifyWorkOfTimers = 1;
    Serial.println(F("if(!DayTimerIsExist)///////////////START////////////////////////////////////////////////////////////"));
    for(byte i = 0, LastTimerDOW = (NOW_WEEK) ? LastTimerDOW_2 : LastTimerDOW_1; i < LastTimerDOW; i++) // NOW_WEEK 0 -1week; 1 -2week
    {
      // Сработка Таймеров По Дням Недели
      // Если Время Больше чем Начало Лекции
      // Если Время Меньше чем Конец Лекции
      // Если Время Меньше чем Начало Перерыва
      // Если Время Больше чем Конец Перерыва

      Serial.print(F("i= ")); Serial.println(i); Serial.print(F("LastTimerDOW  ")); Serial.println(LastTimerDOW);
      byte IDSortTimersDOW = (NOW_WEEK) ? IDSortTimersDOW_2[i] : IDSortTimersDOW_1[i];
      if(Timers[IDSortTimersDOW].ACTIVE_TIMER == true && (Timers[IDSortTimersDOW].WEEK_OR_EACH_DAY == 1 || Timers[IDSortTimersDOW].WEEK_OR_EACH_DAY == 2 ) && Timers[IDSortTimersDOW].WEEK_OR_EACH_DAY == ((byte)NOW_WEEK + 1) && Timers[IDSortTimersDOW].DOW == TIME.dow) 
      {// Внутри Таймера         
        Serial.println(F("Inside TimerDOW  /////////////////////////"));    
        Serial.print(F("IDSortTimersDOW_2[i]= ")); Serial.println(IDSortTimersDOW_2[i]);
        Serial.print(F("IDSortTimersDOW_1[i]= ")); Serial.println(IDSortTimersDOW_1[i]);
        Serial.print(F("IDSortTimersDOW ")); Serial.println(IDSortTimersDOW); 
        Serial.print(F("Timers[IDSortTimersDOW].TIME[1] ")); Serial.println(Timers[IDSortTimersDOW].TIME[1]);
        Serial.print(F("Timers[IDSortTimersDOW].TIME[0] ")); Serial.println(Timers[IDSortTimersDOW].TIME[0]);
        
        if(FirstTimeVerifyWorkOfTimers && (TIME.hour < Timers[IDSortTimersDOW].TIME[0] || (TIME.min < Timers[IDSortTimersDOW].TIME[1] && TIME.hour <= Timers[IDSortTimersDOW].TIME[0]))) 
        {
          NextIDTimerIsWork = IDSortTimersDOW;
          Serial.print(F("FirstTimeVerifyWorkOfTimers  NextIDTimerIsWork Day ")); Serial.println(NextIDTimerIsWork);
          FirstTimeVerifyWorkOfTimers = 0;
        }          
        
        if(TIME.min >= Timers[IDSortTimersDOW].TIME[1] && TIME.hour >= Timers[IDSortTimersDOW].TIME[0] \ 
        && TIME.min < Timers[IDSortTimersDOW].TIME[3] && TIME.hour <= Timers[IDSortTimersDOW].TIME[2])
        { Serial.println(F("Inside Timer TimerDOW")); 
          Timers_HOUR_END_BREAK = Timers[IDSortTimersDOW].TIME[4] + Timers[IDSortTimersDOW].TIME[6]; 
          Timers_MINET_END_BREAK = Timers[IDSortTimersDOW].TIME[5] + Timers[IDSortTimersDOW].TIME[7];
          Serial.print(F("Timers_HOUR_END_BREAK ")); Serial.println(Timers_HOUR_END_BREAK); Serial.print(F("Timers_MINET_END_BREAK ")); Serial.println(Timers_MINET_END_BREAK); 
          
          if((Timers[IDSortTimersDOW].TIME[6] == 0 && Timers[IDSortTimersDOW].TIME[7] == 0) \
          || (TIME.min < Timers[IDSortTimersDOW].TIME[5] && TIME.hour <= Timers[IDSortTimersDOW].TIME[4]) \ 
          || (TIME.min >= Timers_MINET_END_BREAK && TIME.hour >= Timers_HOUR_END_BREAK))  
          {//Промежутки Лекции Вне перерыва             
            IDSortTimersDOW = (NOW_WEEK) ? IDSortTimersDOW_2[i+1] : IDSortTimersDOW_1[i+1];
            IDTimerIsWork = IDSortTimersDOW; if(i+1 < LastTimerDOW){NextIDTimerIsWork = IDSortTimersDOW;}else {NextIDTimerIsWork = 255;}            
            TimerIsWork = 1; // Таймер СРАБОТАН 
            BreakIsWork = 0; // Перерыва нет  
            Serial.print(F("Inside TimerDOW OutBreak TimerIsWork = ")); Serial.print(TimerIsWork);Serial.print(F("   BreakIsWork = ")); Serial.println(BreakIsWork);
            break;                    
          }else 
          {   
            TimerIsWork = 1; // Таймер СРАБОТАН        
            BreakIsWork = 1; //Перерыв  
            break;
            Serial.print(F("Inside TimerDOW Break TimerIsWork = ")); Serial.print(TimerIsWork);Serial.print(F("   BreakIsWork = ")); Serial.println(BreakIsWork);     
          }//Перерыв    
        }else 
        {
          TimerIsWork = 0;   
          BreakIsWork = 0;
          Serial.print(F("OUTside TimerDOW TimerIsWork = ")); Serial.print(TimerIsWork);Serial.print(F("   BreakIsWork = ")); Serial.println(BreakIsWork);
        } // Таймер НЕ СРАБОТАН 
      }//else {NextIDTimerIsWork = 255;}      
    }
  }
  
  Serial.print(F("NextIDTimerIsWork  ")); Serial.println(NextIDTimerIsWork);
  if(TimerIsWork) // сработан // LastTimerDay || LastTimerDOW_1 || LastTimerDOW_2
  {Serial.println(F("if(TimerIsWork)*************************************************"));
    Timers_HOUR_END_BREAK = Timers[IDTimerIsWork].TIME[4] + Timers[IDTimerIsWork].TIME[6]; Timers_MINET_END_BREAK = Timers[IDTimerIsWork].TIME[5] + Timers[IDTimerIsWork].TIME[7];
    if(TIME.min < Timers[IDTimerIsWork].TIME[5] && TIME.hour <= Timers[IDTimerIsWork].TIME[4]) // Если Время Меньше чем Начало Перерыва
    {Serial.println(F("if(TIME.min < Timers[IDTimerIsWork].TIME[5] && TIME.hour <= Timers[IDTimerIsWork].TIME[4])********"));
      SumSecTimer = 60*(Timers[IDTimerIsWork].TIME[5] + 60*Timers[IDTimerIsWork].TIME[4]) - TIME.sec - 60*(TIME.min + 60*TIME.hour);
      Serial.print(F("TIME.min <= Timers[IDTimerIsWork].TIME[5] && TIME.hour <= Timers[IDTimerIsWork].TIME[4] SumSecTimer ")); Serial.println(SumSecTimer); 
    }else if(TIME.min < Timers_MINET_END_BREAK && TIME.hour <= Timers_HOUR_END_BREAK) // Если Время Меньше чем Конец Перерыва 
          {Serial.println(F("else if(TIME.min < Timers_MINET_END_BREAK && TIME.hour <= Timers_HOUR_END_BREAK)********"));
            SumSecTimer = 60*(Timers_MINET_END_BREAK + 60*Timers_HOUR_END_BREAK) - TIME.sec - 60*(TIME.min + 60*TIME.hour);
            Serial.print(F("TIME.min <= Timers[IDTimerIsWork].TIME[7] && TIME.hour <= Timers[IDTimerIsWork].TIME[6] SumSecTimer ")); Serial.println(SumSecTimer); 
          }else // Если Время Больше чем Конец Перерыва 
          {
            SumSecTimer = 60*(Timers[IDTimerIsWork].TIME[3] + 60*Timers[IDTimerIsWork].TIME[2]) - TIME.sec - 60*(TIME.min + 60*TIME.hour);   
            Serial.print(F("else SumSecTimer ")); Serial.println(SumSecTimer); 
          }
  }
  Serial.print(F("SumSecTimer ")); Serial.println(SumSecTimer);     
  if(!TimerIsWork) // Не сработан // 
  {Serial.println(F("if(!TimerIsWork)*****************************************"));
    if(NextIDTimerIsWork != 255) // Проверка на отсутствие Таймеров впереди
    {Serial.println(F("if(NextIDTimerIsWork != 255) *************************"));
      SumSecTimer = 60*(Timers[NextIDTimerIsWork].TIME[1] + 60*Timers[NextIDTimerIsWork].TIME[0]) - TIME.sec - 60*(TIME.min + 60*TIME.hour);  
      Serial.print(F("Timers[NextIDTimerIsWork].TIME[1] ")); Serial.println(Timers[NextIDTimerIsWork].TIME[1]);   
      Serial.print(F("Timers[NextIDTimerIsWork].TIME[0] ")); Serial.println(Timers[NextIDTimerIsWork].TIME[0]);    
      Serial.print(F("60*(Timers[NextIDTimerIsWork].TIME[1] + 60*Timers[NextIDTimerIsWork].TIME[0]) ")); Serial.println(60*(Timers[NextIDTimerIsWork].TIME[1] + 60*Timers[NextIDTimerIsWork].TIME[0]));   
      Serial.print(F("TIME.sec ")); Serial.println(TIME.sec);    
      Serial.print(F("TIME.min + 60*TIME.hour ")); Serial.println(TIME.min + 60*TIME.hour);   
      Serial.print(F("- TIME.sec - 60*(TIME.min + 60*TIME.hour) ")); Serial.println(- TIME.sec - 60*(TIME.min + 60*TIME.hour));    
      Serial.print(F("NextIDTimerIsWork!=255 SumSecTimer ")); Serial.println(SumSecTimer);   
      Serial.print(F("NextIDTimerIsWork ")); Serial.println(NextIDTimerIsWork);   
    }else {SumSecTimer = 0;}
  }
  Serial.print(F("SumSecTimer ")); Serial.println(SumSecTimer); 
  Serial.print(F("SumSecTimer/3600 ")); Serial.println(SumSecTimer/3600); 
  Serial.print(F("(SumSecTimer%3600)/60 ")); Serial.println((SumSecTimer%3600)/60); 
  Serial.print(F("(SumSecTimer%3600)%60 ")); Serial.println((SumSecTimer%3600)%60); 
  TIME_Timer.hour = SumSecTimer/3600;
  TIME_Timer.min = (SumSecTimer%3600)/60;
  TIME_Timer.sec = (SumSecTimer%3600)%60;  

  OpenCloseDoor(); // Открываем/Закрываем Дверь 
  
  Timers_HOUR_END_BREAK = 0; Timers_MINET_END_BREAK = 0;
  DayTimerIsExist = 0; // Есть Хоть один таймер на этот День
}

void OpenCloseDoor() 
{
  if(TimerIsWork && !BreakIsWork) 
  {
    OpenDoor = 0; // Дверь Закрыта
    if(!InvertValueCloseDoor)
    {
      digitalWrite(Pin_OpenCloseDoor, HIGH);
    }else
    {
      digitalWrite(Pin_OpenCloseDoor, LOW);
    }
  }else
  {
    OpenDoor = 1; // Дверь ОТкрыта
    if(InvertValueCloseDoor)
    {
      digitalWrite(Pin_OpenCloseDoor, HIGH);
    }else
    {
      digitalWrite(Pin_OpenCloseDoor, LOW);
    }
  }
}

void Sortirovka(byte Length)
{Serial.println(F("////////////////////////////////////////////")); 
  //Timers[IDSortTimers[i]].TIME[0] == Timers[LastTimer].TIME[0] && Timers[IDSortTimers[i]].TIME[1] >= Timers[LastTimer].TIME[1] || Timers[IDSortTimers[i]].TIME[0] > Timers[LastTimer].TIME[0])
  // Задаём IDSortTimers[i] по порядку Timers[i]
  LastTimerDOW_1 = 0; LastTimerDOW_2 = 0; LastTimerDay = 0;   
  for(byte k = 0; k < Length; k++)
  {
    IDSortTimers[k] = k;
    Serial.print(F("befor Sort IDSortTimers[k] ")); Serial.println(IDSortTimers[k]); 
    
    if(Timers[IDSortTimers[k]].WEEK_OR_EACH_DAY == 0 && Timers[IDSortTimers[k]].DAY == TIME.date && Timers[IDSortTimers[k]].MONTH == TIME.mon && Timers[IDSortTimers[k]].YEAR == TIME.year)
    {// DOW DAY MONTH YEAR //WEEK_OR_EACH_DAY // 1 for 1st week, 2 for 2nd week, 0 - each day
       Serial.print(F("DAY IDSortTimersDay[k]  "));   Serial.println(IDSortTimers[k]);   
      IDSortTimersDay[LastTimerDay] = IDSortTimers[k];
      LastTimerDay += 1; 
      Serial.print(F("LastTimerDay ")); Serial.println(LastTimerDay);  
      Serial.print(F("DAY LastTimerDay  "));    Serial.println(LastTimerDay);    
    }
    if(Timers[IDSortTimers[k]].WEEK_OR_EACH_DAY == 1 && Timers[IDSortTimers[k]].WEEK_OR_EACH_DAY == ((byte)NOW_WEEK + 1) && Timers[IDSortTimers[k]].DOW == TIME.dow)
    {// NOW_WEEK = 0; // 0 - 1 Week, 1 - 2 Week 
      Serial.print(F("DOW IDSortTimersDOW_1[k]  "));   Serial.println(IDSortTimers[k]);   
      IDSortTimersDOW_1[LastTimerDOW_1] = IDSortTimers[k];
      LastTimerDOW_1 += 1;
      Serial.print(F("LastTimerDOW_1 ")); Serial.println(LastTimerDOW_1);  
      Serial.print(F("DOW LastTimerDOW_1  "));    
    }
    if(Timers[IDSortTimers[k]].WEEK_OR_EACH_DAY == 2 && Timers[IDSortTimers[k]].WEEK_OR_EACH_DAY == ((byte)NOW_WEEK + 1) && Timers[IDSortTimers[k]].DOW == TIME.dow)
    {// NOW_WEEK = 0; // 0 - 1 Week, 1 - 2 Week 
      Serial.print(F("DOW IDSortTimersDOW[k]  "));   Serial.println(IDSortTimers[k]);   
      IDSortTimersDOW_2[LastTimerDOW_2] = IDSortTimers[k];
      LastTimerDOW_2 += 1;
      Serial.print(F("LastTimerDOW_2 ")); Serial.println(LastTimerDOW_2);  
      Serial.print(F("DOW LastTimerDOW_2  "));    
    }
  }
  ///ПРОВЕРКА ЗАПИСИ
  for(byte i = 0; i < LastTimerDOW_1; i++)
 {
    Serial.print(F("Timers[LastTimerDOW_1[i].TIME[0] ")); Serial.println(Timers[IDSortTimersDOW_1[i]].TIME[0]);     
    Serial.print(F("Timers[LastTimerDOW_1[i].TIME[1] ")); Serial.println(Timers[IDSortTimersDOW_1[i]].TIME[1]);        
 }
  for(byte i = 0; i < LastTimerDOW_2; i++)
 {
    Serial.print(F("Timers[LastTimerDOW_2[i].TIME[0] ")); Serial.println(Timers[IDSortTimersDOW_2[i]].TIME[0]);     
    Serial.print(F("Timers[LastTimerDOW_2[i].TIME[1] ")); Serial.println(Timers[IDSortTimersDOW_2[i]].TIME[1]);        
 }
 for(byte i = 0; i < LastTimerDay; i++)
 {
    Serial.print(F("Timers[IDSortTimersDay[i].TIME[0] ")); Serial.println(Timers[IDSortTimersDay[i]].TIME[0]);     
    Serial.print(F("Timers[IDSortTimersDay[i].TIME[1] ")); Serial.println(Timers[IDSortTimersDay[i]].TIME[1]);        
 } ///ПРОВЕРКА ЗАПИСИ 
    
  for(byte i = 0; i < Length - 1; i++)
  {Serial.print(F("start cicl i = ")); Serial.println(i); 
    //bool swapped = false;
    for(byte j = 0; j < Length - i - 1; j++)
    {Serial.print(F("start cicl j = ")); Serial.println(j); 
      if(Timers[IDSortTimers[j]].TIME[0] > Timers[IDSortTimers[j+1]].TIME[0] || Timers[IDSortTimers[j]].TIME[0] == Timers[IDSortTimers[j+1]].TIME[0] && Timers[IDSortTimers[j]].TIME[1] > Timers[IDSortTimers[j+1]].TIME[1])
      {Serial.print(F(" Timers[j].TIME[0] ")); Serial.print(Timers[j].TIME[0]); Serial.print(F("   Timers[j+1].TIME[0] ")); Serial.println(Timers[j+1].TIME[0]); 
         Serial.print(F("if j = ")); Serial.print(j);  Serial.print(F("   IDSortTimers[j] ")); Serial.print(IDSortTimers[j]);  Serial.print(F("   IDSortTimers[j+1] ")); Serial.println(IDSortTimers[j+1]); 
        // Обмен местами
        byte buf = IDSortTimers[j];
        IDSortTimers[j] = IDSortTimers[j+1];
        IDSortTimers[j+1] = buf; 
        Serial.print(F("IDSortTimers[j] ")); Serial.print(IDSortTimers[j]); Serial.print(F("   IDSortTimers[j+1] ")); Serial.println(IDSortTimers[j+1]);          
      }      
    }
  }    
  SortTodayTimers();  
}
void SortTodayTimers()
{
  Serial.println(F("void SortTodayTimers()"));
  // Сохраняем Таймеры На ДЕНЬ  
  
  // Сортируем Таймеры На ДЕНЬ Массив Дней недели
  Serial.println(F("Sort LastTimerDOW_1 ")); 
    Serial.print(F("LastTimerDOW_1 ")); Serial.println(LastTimerDOW_1);  
  for(byte i = 0; i < LastTimerDOW_1 - 1; i++)
  {Serial.print(F("LastTimerDOW_1 start cicl i = ")); Serial.println(i); 
    //bool swapped = false;
    for(byte j = 0; j < LastTimerDOW_1 - i - 1; j++)
    {Serial.print(F(" LastTimerDOW_1 start cicl j = ")); Serial.println(j); 
      if(Timers[IDSortTimersDOW_1[j]].TIME[0] > Timers[IDSortTimersDOW_1[j+1]].TIME[0] || Timers[IDSortTimersDOW_1[j]].TIME[0] == Timers[IDSortTimersDOW_1[j+1]].TIME[0] && Timers[IDSortTimersDOW_1[j]].TIME[1] > Timers[IDSortTimersDOW_1[j+1]].TIME[1])
      {Serial.print(F("LastTimerDOW_1 Timers[j].TIME[0] ")); Serial.print(Timers[j].TIME[0]); Serial.print(F(" LastTimerDOW_1   Timers[j+1].TIME[0] ")); Serial.println(Timers[j+1].TIME[0]); 
         Serial.print(F("LastTimerDOW_1 if j = ")); Serial.print(j);  Serial.print(F(" LastTimerDOW_1   IDSortTimers[j] ")); Serial.print(IDSortTimers[j]);  Serial.print(F("LastTimerDOW_1   IDSortTimers[j+1] ")); Serial.println(IDSortTimers[j+1]); 
        // Обмен местами
        byte buf = IDSortTimersDOW_1[j];
        IDSortTimersDOW_1[j] = IDSortTimersDOW_1[j+1];
        IDSortTimersDOW_1[j+1] = buf; 
        Serial.print(F("LastTimerDOW_1IDSortTimers[j] ")); Serial.print(IDSortTimers[j]); Serial.print(F(" LastTimerDOW_1  IDSortTimers[j+1] ")); Serial.println(IDSortTimers[j+1]);          
      }      
    }
  }// Сортируем Таймеры На ДЕНЬ Массив Дней недели
  for(byte i = 0; i < LastTimerDOW_2 - 1; i++)
  {Serial.print(F("LastTimerDOW_2 start cicl i = ")); Serial.println(i); 
    //bool swapped = false;
    for(byte j = 0; j < LastTimerDOW_2 - i - 1; j++)
    {Serial.print(F(" LastTimerDOW_2 start cicl j = ")); Serial.println(j); 
      if(Timers[IDSortTimersDOW_2[j]].TIME[0] > Timers[IDSortTimersDOW_2[j+1]].TIME[0] || Timers[IDSortTimersDOW_2[j]].TIME[0] == Timers[IDSortTimersDOW_2[j+1]].TIME[0] && Timers[IDSortTimersDOW_2[j]].TIME[1] > Timers[IDSortTimersDOW_2[j+1]].TIME[1])
      {Serial.print(F("LastTimerDOW_2 Timers[j].TIME[0] ")); Serial.print(Timers[j].TIME[0]); Serial.print(F(" LastTimerDOW_2   Timers[j+1].TIME[0] ")); Serial.println(Timers[j+1].TIME[0]); 
         Serial.print(F("LastTimerDOW_2 if j = ")); Serial.print(j);  Serial.print(F(" LastTimerDOW_2   IDSortTimers[j] ")); Serial.print(IDSortTimers[j]);  Serial.print(F("LastTimerDOW_2   IDSortTimers[j+1] ")); Serial.println(IDSortTimers[j+1]); 
        // Обмен местами
        byte buf = IDSortTimersDOW_2[j];
        IDSortTimersDOW_2[j] = IDSortTimersDOW_2[j+1];
        IDSortTimersDOW_2[j+1] = buf; 
        Serial.print(F("LastTimerDOW_2IDSortTimers[j] ")); Serial.print(IDSortTimers[j]); Serial.print(F(" LastTimerDOW_2  IDSortTimers[j+1] ")); Serial.println(IDSortTimers[j+1]);          
      }      
    }
  }// Сортируем Таймеры На ДЕНЬ Массив Дней недели
  // Сортируем Таймеры На ДЕНЬ Массив Конкр День
  Serial.println(F("Sort LastTimerDay")); 
  Serial.print(F("LastTimerDay ")); Serial.println(LastTimerDay);   
  for(byte i = 0; i < LastTimerDay - 1; i++)
  {Serial.print(F("LastTimerDay start cicl i = ")); Serial.print(i); 
    //bool swapped = false;
    for(byte j = 0; j < LastTimerDay - i - 1; j++)
    {Serial.print(F("LastTimerDay start cicl j = ")); Serial.print(j); 
      if(Timers[IDSortTimersDay[j]].TIME[0] > Timers[IDSortTimersDay[j+1]].TIME[0] || Timers[IDSortTimersDay[j]].TIME[0] == Timers[IDSortTimersDay[j+1]].TIME[0] && Timers[IDSortTimersDay[j]].TIME[1] > Timers[IDSortTimersDay[j+1]].TIME[1])
      {Serial.print(F("LastTimerDay Timers[j].TIME[0] ")); Serial.print(Timers[j].TIME[0]); Serial.print(F(" LastTimerDay  Timers[j+1].TIME[0] ")); Serial.println(Timers[j+1].TIME[0]); 
         Serial.print(F("LastTimerDayif j = ")); Serial.print(j);  Serial.print(F(" LastTimerDay  IDSortTimers[j] ")); Serial.print(IDSortTimers[j]);  Serial.print(F(" LastTimerDay  IDSortTimers[j+1] ")); Serial.println(IDSortTimers[j+1]); 
        // Обмен местами
        byte buf = IDSortTimersDay[j];
        IDSortTimersDay[j] = IDSortTimersDay[j+1];
        IDSortTimersDay[j+1] = buf; 
        Serial.print(F("LastTimerDay IDSortTimers[j] ")); Serial.print(IDSortTimers[j]); Serial.print(F(" LastTimerDay  IDSortTimers[j+1] ")); Serial.println(IDSortTimers[j+1]);          
      }      
    }
  }// Сортируем Таймеры На ДЕНЬ Массив Конкр День
  
  
   for(byte i = 0; i < LastTimerDOW_1; i++)
   {
      Serial.print(F("Timers[LastTimerDOW_1[i].TIME[0] ")); Serial.println(Timers[IDSortTimersDOW_1[i]].TIME[0]);     
      Serial.print(F("Timers[LastTimerDOW_1[i].TIME[1] ")); Serial.println(Timers[IDSortTimersDOW_1[i]].TIME[1]);        
   }
   for(byte i = 0; i < LastTimerDOW_2; i++)
   {
      Serial.print(F("Timers[LastTimerDOW_2[i].TIME[0] ")); Serial.println(Timers[IDSortTimersDOW_2[i]].TIME[0]);     
      Serial.print(F("Timers[LastTimerDOW_2[i].TIME[1] ")); Serial.println(Timers[IDSortTimersDOW_2[i]].TIME[1]);        
   }
   for(byte i = 0; i < LastTimerDay; i++)
   {
      Serial.print(F("Timers[IDSortTimersDay[i].TIME[0] ")); Serial.println(Timers[IDSortTimersDay[i]].TIME[0]);     
      Serial.print(F("Timers[IDSortTimersDay[i].TIME[1] ")); Serial.println(Timers[IDSortTimersDay[i]].TIME[1]);        
   }
   Serial.println(F("END void SortTodayTimers()"));
}

void DelOldTimers()
{
  for(byte i = 0; i < LastTimer; i++)
  {Serial.print("DelOldTimers() i = "); Serial.print(i);     
    if(Timers[i].DAY < TIME_Timer.date && Timers[i].MONTH <= TIME_Timer.mon && Timers[i].YEAR <= TIME_Timer.year && !Timers[i].WEEK_OR_EACH_DAY)
    {
     Serial.print(F("Timers[i].DAY = ")); Serial.print(Timers[i].DAY);  Serial.print(F(" Timers[i].MONTH = ")); Serial.print(Timers[i].MONTH);  Serial.print(F(" Timers[i].YEAR = ")); Serial.println(Timers[i].YEAR); 
      // Удаляем таймер
      AddDeleteTimer(0, i); // AddDelTimer = 1 = Add // если Добавляем то аргумент ID_TIMER = 0                
    }   
  }//for
}

void Sleep()
{
  
}

///TABLO///START///////////////////////////////////////////////////////////
void WriteOnTablo(const MyTime &T)
{
    // Set LatchPin LOW while Clocking these 8 bits in to the register
    digitalWrite(LatchPin, LOW);
  
  // TIME.hour TIME.min TIME.sec
//if((byte)T.min/10 == 0){tft.print("0");}

    Serial.print(F("(byte)T.sec/10  ")); Serial.println((byte)T.sec/10);       
    
    if((byte)T.sec/10 == 0)
    {
    Serial.print(F("(byte)T.sec  ")); Serial.println((byte)T.sec);
    Serial.print(F("Numbers((byte)T.sec  ")); Serial.println(Numbers((byte)T.sec));
    Serial.println(F("Print 0")); 
      shiftOut(DataPin, ClockPin, LSBFIRST, Numbers((byte)T.sec));
      shiftOut(DataPin, ClockPin, LSBFIRST, numbers[0]);
      //giveNumber(numbers[(byte)T.sec]);
      //giveNumber(numbers[0]);
    }else
    {
    Serial.print(F("(byte)T.sec%10  ")); Serial.println((byte)T.sec%10);
    Serial.print(F("Numbers((byte)T.sec  ")); Serial.println(Numbers((byte)T.sec));
     Serial.print(F("(byte)T.sec/10  ")); Serial.println((byte)T.sec/10);
    Serial.print(F("Numbers((byte)T.sec  ")); Serial.println(Numbers((byte)T.sec));
      shiftOut(DataPin, ClockPin, LSBFIRST, Numbers((byte)T.sec%10));
      shiftOut(DataPin, ClockPin, LSBFIRST, Numbers((byte)T.sec/10));
      //giveNumber(numbers[(byte)T.sec%10]);
      //giveNumber(numbers[(byte)T.sec/10]);
    }   
    /*digitalWrite(LatchPin, HIGH);
    delay(3000);
    digitalWrite(LatchPin, LOW);*/

    if((byte)T.min/10 == 0)
    {
      shiftOut(DataPin, ClockPin, LSBFIRST, Numbers((byte)T.min));
      shiftOut(DataPin, ClockPin, LSBFIRST, numbers[0]);
      //giveNumber(numbers[(byte)T.min]);
      //giveNumber(numbers[0]);
    }else
    {
      shiftOut(DataPin, ClockPin, LSBFIRST, Numbers((byte)T.min%10));
      shiftOut(DataPin, ClockPin, LSBFIRST, Numbers((byte)T.min/10));
      //giveNumber(numbers[(byte)T.min%10]);
      //giveNumber(numbers[(byte)T.min/10]);
    }   
    /*digitalWrite(LatchPin, HIGH);
    delay(3000);
    digitalWrite(LatchPin, LOW);*/

    if((byte)T.hour/10 == 0)
    {
      shiftOut(DataPin, ClockPin, LSBFIRST, Numbers((byte)T.hour));
      shiftOut(DataPin, ClockPin, LSBFIRST, numbers[0]);
      //giveNumber(numbers[(byte)T.hour]);
      //giveNumber(numbers[0]);
    }else
    {
      shiftOut(DataPin, ClockPin, LSBFIRST, Numbers((byte)T.hour%10));
      shiftOut(DataPin, ClockPin, LSBFIRST, Numbers((byte)T.hour/10));
      //giveNumber(numbers[(byte)T.hour%10]);
      //giveNumber(numbers[(byte)T.hour/10]);
    }       

    //set LatchPin to high to lock and send Data
    digitalWrite(LatchPin, HIGH);

    // put delay here if you want to see the multiplexing in action!
    //delay(5000);
}

byte Numbers(int Num)
{
  switch(Num)
  {
    case 0: return numbers[0];
    case 1: return numbers[1];
    case 2: return numbers[2];
    case 3: return numbers[3];
    case 4: return numbers[4];
    case 5: return numbers[5];
    case 6: return numbers[6];
    case 7: return numbers[7];
    case 8: return numbers[8];
    case 9: return numbers[9];
    default: return numbers[20];
  }
}
///TABLO END////////////////////////////////////////////////////////////////////////

////////функция рисования OK_Window()///START///////////////////// 
void drawOK_Window()
{
  Serial.print(F("X_OK_Window ")); Serial.print(X_OK_Window); Serial.print(F("Y_OK_Window ")); Serial.println(Y_OK_Window); 
  Serial.print(F("DEL_X_OK_Window ")); Serial.print(DEL_X_OK_Window); Serial.print(F("DEL_Y_OK_Window ")); Serial.println(DEL_Y_OK_Window); 
  int X_TEXT_OK_Window = X_OK_Window + (DEL_X_OK_Window/2 - 5*SIZE_TEXT_CALENDAR*11)/2;
  int Y_TEXT_OK_Window = Y_OK_Window + DEL_Y_OK_Window - BOXSIZE_MENU + (BOXSIZE_MENU - 8*SIZE_TEXT_CALENDAR)/2;
Serial.print(F("X_TEXT_OK_Window ")); Serial.print(X_TEXT_OK_Window); Serial.print(F("Y_TEXT_OK_Window ")); Serial.println(Y_TEXT_OK_Window); 
  tft.setTextSize(SIZE_TEXT_OK_Window); tft.setTextColor(TEXT_COLOR_OK_Window);
  tft.setCursor(X_TEXT_OK_Window, Y_TEXT_OK_Window);  tft.println(utf8rus(F("Вы Уверены?")));
  
  tft.fillRect(X_OK_Window, Y_OK_Window, DEL_X_OK_Window, DEL_Y_OK_Window, FON_COLOR_OK_Window); // OK_Window
  
  tft.fillRect(X_OK_Window - 2*BORDER_DESKTOP, Y_OK_Window - 2*BORDER_DESKTOP, DEL_X_OK_Window + 2*2*BORDER_DESKTOP, BORDER_DESKTOP, BORD_COLOR_OK_Window); //Up
  tft.fillRect(X_OK_Window - 2*BORDER_DESKTOP, Y_OK_Window + DEL_Y_OK_Window, DEL_X_OK_Window + 2*2*BORDER_DESKTOP, BORDER_DESKTOP, BORD_COLOR_OK_Window); //Down
  tft.fillRect(X_OK_Window - 2*BORDER_DESKTOP, Y_OK_Window - 2*BORDER_DESKTOP, 2*BORDER_DESKTOP, DEL_Y_OK_Window + 2*2*BORDER_DESKTOP, BORD_COLOR_OK_Window); //Left
  tft.fillRect(X_OK_Window + DEL_X_OK_Window, Y_OK_Window - 2*BORDER_DESKTOP, 2*BORDER_DESKTOP, DEL_Y_OK_Window + 2*2*BORDER_DESKTOP, BORD_COLOR_OK_Window); //Right
   
  tft.fillRect(X_OK_Window, Y_OK_Window + DEL_Y_OK_Window - BOXSIZE_MENU, DEL_X_OK_Window, BOXSIZE_MENU, BUTTON_COLOR_OK_Window); // Button

  int X_OK_Window_Centr = X_OK_Window + DEL_X_OK_Window/2, Y_OK_Window_Centr = Y_OK_Window + DEL_Y_OK_Window - BOXSIZE_MENU;
  
  Serial.print(F("X_OK_Window_Centr ")); Serial.print(X_OK_Window_Centr); Serial.print(F("Y_OK_Window_Centr ")); Serial.println(Y_OK_Window_Centr); 
  tft.fillRect(X_OK_Window, Y_OK_Window + DEL_Y_OK_Window - BOXSIZE_MENU - 2*BORDER_DESKTOP, DEL_X_OK_Window, 2*BORDER_DESKTOP, BORD_COLOR_OK_Window); // Button UP BORD
  tft.fillRect(X_OK_Window_Centr - BORDER_DESKTOP, Y_OK_Window_Centr, 2*BORDER_DESKTOP, BOXSIZE_MENU, BORD_COLOR_OK_Window); // Button Centr BORD
      
  tft.drawRect(X_OK_Window + BORDER_DESKTOP, Y_OK_Window + DEL_Y_OK_Window - BOXSIZE_MENU + BORDER_DESKTOP, X_OK_Window_Centr - 2*BORDER_DESKTOP, BOXSIZE_MENU - 2*BORDER_DESKTOP, TEXT_COLOR_OK_Window); 
  tft.drawRect(X_OK_Window_Centr + BORDER_DESKTOP, Y_OK_Window_Centr + BORDER_DESKTOP, X_OK_Window_Centr - X_OK_Window - 2*BORDER_DESKTOP, BOXSIZE_MENU - 2*BORDER_DESKTOP, TEXT_COLOR_OK_Window);
  
  
  X_TEXT_OK_Window = X_OK_Window + (DEL_X_OK_Window/2 - 5*SIZE_TEXT_CALENDAR*3)/2;
  Y_TEXT_OK_Window = Y_OK_Window + DEL_Y_OK_Window - BOXSIZE_MENU + (BOXSIZE_MENU - 8*SIZE_TEXT_CALENDAR)/2;
  
  tft.setTextSize(SIZE_TEXT_OK_Window); tft.setTextColor(TEXT_COLOR_OK_Window);
  tft.setCursor(X_TEXT_OK_Window, Y_TEXT_OK_Window);  tft.println(utf8rus("Да!"));
  X_TEXT_OK_Window += DEL_X_OK_Window/2;
  tft.setCursor(X_TEXT_OK_Window, Y_TEXT_OK_Window); tft.println(utf8rus("Нет"));
}
////////функция рисования OK_Window()////END//////////////////////
